jQuery(function() {
	jQuery(document).ready(function() {
		RSPageBuilderElementsHelper.initjQueryUI();
		RSPageBuilderElementsHelper.initTinyMCE();
		RSPageBuilderElementsHelper.initEditors(jQuery('.rspbld-elements'));
		RSPageBuilderElementsHelper.fixMooTools();
		
		// Hide modals
		jQuery('#modal-elements-list').modal('hide');
		jQuery('#modal-element-settings').modal('hide');
		jQuery('#modal-element-view-html').modal('hide');
		jQuery('#modal-icons-list').modal('hide');
		
		// Prevent modal form submission on 'Enter' key press
		jQuery(window).keydown(function(e) {
			if (e.keyCode == 13) {
				e.preventDefault();
				return true;
			}
		});
		
		jQuery('select.chzn-select').each(function() {
			jQuery(this).chosen('destroy');
		});		
		
		// Change selected option
		jQuery(document).on('change', '.modal select', function() {
			 var select_val = jQuery(this).val();
			 
			 jQuery(this).find('option').each(function() {
				 if (jQuery(this).attr('value') == select_val) {
					 jQuery(this).attr('selected', 'selected');
				 } else {
					 jQuery(this).removeAttr('selected');
				 }
			 });
		});
		
		// Add new element
		jQuery(document).on('click', '.add-element', function() {
			var elements_wrapper	= jQuery('#modal-elements-list .elements-list-wrapper'),
				elements_categories	= jQuery('#modal-elements-list .elements-categories ul li');
				
			elements_wrapper.find('.elements li').each(function() {
				jQuery(this).removeClass('hidden');
				if (jQuery(this).hasClass('my_elements')) {
					jQuery(this).addClass('hidden');
				}
			});
			elements_categories.removeClass('active')
			elements_categories.first().addClass('active');
			
			jQuery('#modal-element-view-html').modal('hide');
			jQuery('#modal-elements-list').modal('show');
			jQuery('#modal-element-settings #save-element-settings').removeClass('edit-this-element').addClass('add-new-element');
		});
		
		// Elements categories
		jQuery(document).on('click', '#modal-elements-list .elements-categories > ul > li > a', function() {
			var elements_categories = jQuery(this).closest('ul'),
				current_list_item	= jQuery(this).closest('li');
			
			elements_categories.children().removeClass('active');
			current_list_item.addClass('active');
			
			if (current_list_item.data('category') == 'all_elements') {
				jQuery('#modal-elements-list .elements').children().removeClass('hidden');
				jQuery('#modal-elements-list .elements .my_elements').addClass('hidden');
			} else {
				jQuery('#modal-elements-list .elements').children().each(function() {
					if (jQuery(this).hasClass(current_list_item.data('category'))) {
						jQuery(this).removeClass('hidden');
					} else {
						jQuery(this).addClass('hidden');
					}
				});
			}
		});
		
		// Elements search
		jQuery(document).off('#modal-elements-list .elements-filter');
		jQuery(document).on('keyup', '#modal-elements-list .elements-filter', function() {
			var input_value			= jQuery(this).val(),
				elements_wrapper	= jQuery('#modal-elements-list .elements-list-wrapper');
				
			elements_wrapper.find('> ul > li').each(function() {
				if (jQuery(this).find('> a > .element-title').text().toLowerCase().indexOf(input_value.toLowerCase()) >= 0) {
					jQuery(this).removeClass('filter-hidden');
				} else {
					jQuery(this).addClass('filter-hidden');
				}
			});
		});
		
		// Open element settings
		jQuery(document).on('click', '#modal-elements-list .elements > li > a', function() {
			jQuery('#modal-elements-list').modal('hide');
			jQuery('#modal-element-settings').find('.modal-title').text(jQuery(this).next().find('.element-title').text());
			RSPageBuilderElementsHelper.renderElementAjax(jQuery(this).next().find('.element-options'), jQuery(this).next().find('.element-json').val());
			setTimeout(function() {
				RSPageBuilderElementsHelper.initMap(jQuery('#modal-element-settings .element-container'));
			}, 1000);
			jQuery('#modal-element-settings').modal('show');
		});
		
		// Edit element
		jQuery(document).on('click', '.edit-element', function() {
			var element_container = jQuery(this).closest('.element-container');
				
			element_container.addClass('create-element');
			
			if (element_container.find('.element-title').text() != element_container.find('.element-type').text()) {
				jQuery('#modal-element-settings .modal-title').text(element_container.find('.element-title').text() + ' (' + element_container.find('.element-type').text() + ')');
			} else {
				jQuery('#modal-element-settings .modal-title').text(element_container.find('.element-title').text());
			}
			RSPageBuilderElementsHelper.renderElementAjax(element_container.find('.element-options'), element_container.find('.element-json').val());
			
			jQuery('#modal-element-settings #save-element-settings').removeClass('add-new-element').addClass('edit-this-element');
			jQuery('#modal-element-settings').modal('show');
		});
		
		// View element HTML
		jQuery(document).on('click', '.view-element-html', function() {
			RSPageBuilderElementsHelper.elementHtmlAjax(jQuery(this), jQuery(this).closest('.element').find('.element-json').val(), jQuery('#jform_params_bootstrap_version').find('label.active').prev('input').val());
		});
		
		// Duplicate element
		jQuery(document).on('click', '.duplicate-element', function() {
			var element_container	= jQuery(this).closest('.element-container'),
				element_clone		= {};
				
			RSPageBuilderElementsHelper.destroyThisTooltip(element_container);
			
			element_container.removeClass('create-element');
			
			element_clone = element_container.clone();
			element_clone.hide();
			element_clone.insertAfter(element_container);
			element_clone.fadeIn(500);
			
			RSPageBuilderElementsHelper.removeTooltip();
			RSPageBuilderElementsHelper.removePopover();
			RSPageBuilderElementsHelper.initTooltip();
			RSPageBuilderElementsHelper.initPopover();
		});
		
		// Remove element
		jQuery(document).on('click', '.remove-element', function() {
			if (confirm(Joomla.JText._('MOD_RSPAGEBUILDER_ELEMENTS_SURE_REMOVE_ELEMENT')) == true) {
				jQuery(this).closest('.element-container').remove();
			}
		});
		
		// Add iterative item
		jQuery(document).on('click', '#modal-element-settings .add-item', function() {
			var element_container = jQuery('#modal-element-settings .element-container');
			
			RSPageBuilderElementsHelper.duplicateItem(jQuery(this).next().find(' > .accordion-group:first-child'));
			element_container.find('.element-json').val(JSON.stringify(RSPageBuilderElementsHelper.buildElementJson(element_container)));
			
			RSPageBuilderElementsHelper.elementHtmlAjax(element_container.find('.edit-element'), element_container.find('.element-json').val(), '2');
			setTimeout(function() {
				RSPageBuilderElementsHelper.initMap(element_container);
			}, 1000);
			RSPageBuilderElementsHelper.fixMooToolsCarousel(jQuery('#modal-element-settings .element-preview'));
		});
		
		// Duplicate iterative item
		jQuery(document).on('click', '#modal-element-settings .duplicate-item', function() {
			var element_container = jQuery('#modal-element-settings .element-container');
			
			RSPageBuilderElementsHelper.duplicateItem(jQuery(this).closest('.accordion-group'));
			element_container.find('.element-json').val(JSON.stringify(RSPageBuilderElementsHelper.buildElementJson(element_container)), jQuery('#jform_params_bootstrap_version').find('label.active').prev('input').val());
			
			RSPageBuilderElementsHelper.elementHtmlAjax(element_container.find('.edit-element'), element_container.find('.element-json').val(), '2');
			setTimeout(function() {
				RSPageBuilderElementsHelper.initMap(element_container);
			}, 1000);
			RSPageBuilderElementsHelper.fixMooToolsCarousel(jQuery('#modal-element-settings .element-preview'));
		});
		
		// Delete iterative item
		jQuery(document).on('click', '#modal-element-settings .delete-item', function() {
			if (jQuery(this).closest('.accordion').find('.accordion-group').length > 1) {
				if (confirm(Joomla.JText._('MOD_RSPAGEBUILDER_ELEMENTS_SURE_REMOVE_ITEM')) == true) {
					jQuery(this).closest('.accordion-group').fadeOut(500, function() {
						var element_container = jQuery('#modal-element-settings .element-container');
						
						jQuery(this).remove();
						
						element_container.find('.element-json').val(JSON.stringify(RSPageBuilderElementsHelper.buildElementJson(element_container)), jQuery('#jform_params_bootstrap_version').find('label.active').prev('input').val());
						
						RSPageBuilderElementsHelper.elementHtmlAjax(element_container.find('.edit-element'), element_container.find('.element-json').val(), '2');
						setTimeout(function() {
							RSPageBuilderElementsHelper.initMap(element_container);
						}, 1000);
					});
				}
			} else {
				alert(Joomla.JText._('MOD_RSPAGEBUILDER_ELEMENTS_REMOVE_LAST_ITEM'));
				return true;
			}
		});
		
		// Close iterative item
		jQuery(document).on('click', '#modal-element-settings .close-item', function() {
			var accordion_group = jQuery(this).closest('.accordion-group');
			
			if (accordion_group.find('.accordion-body').hasClass('in')) {
				accordion_group.find('.accordion-body').removeClass('in');
				accordion_group.find('.accordion-body').animate({
					height: 0
				}, 100);
			}
		});
		
		// Dynamically change element
		jQuery(document).on('change', '#modal-element-settings .element-options .rspbld-input', function() {
			var element_container = jQuery('#modal-element-settings .element-container'),
				current_input 	  = jQuery(this);
				
			element_container.find('.element-json').val(JSON.stringify(RSPageBuilderElementsHelper.buildElementJson(element_container)));
			
			RSPageBuilderElementsHelper.elementHtmlAjax(jQuery('#modal-element-settings .edit-element'), element_container.find('.element-json').val(), '2');
			setTimeout(function() {
				if (!current_input.hasClass('minicolors')) {
					RSPageBuilderElementsHelper.initMap(element_container);
				} else if (current_input.parent().find('.minicolors-panel').css('display') == 'none') {
					RSPageBuilderElementsHelper.initMap(element_container);
				}
			}, 1000);
			RSPageBuilderElementsHelper.fixMooToolsCarousel(jQuery('#modal-element-settings .element-preview'));
		});
		jQuery(document).on('change', '#modal-element-settings .element-options .field-calendar .js-calendar select', function() {
			var element_container = jQuery('#modal-element-settings .element-container');
			
			element_container.find('.element-json').val(JSON.stringify(RSPageBuilderElementsHelper.buildElementJson(element_container)));
			
			RSPageBuilderElementsHelper.elementHtmlAjax(jQuery('#modal-element-settings .edit-element'), element_container.find('.element-json').val(), '2');
		});
		jQuery(document).on('click', '#modal-element-settings .element-options .field-calendar .js-calendar .day', function() {
			var element_container = jQuery('#modal-element-settings .element-container');
			
			element_container.find('.element-json').val(JSON.stringify(RSPageBuilderElementsHelper.buildElementJson(element_container)));
			
			RSPageBuilderElementsHelper.elementHtmlAjax(jQuery('#modal-element-settings .edit-element'), element_container.find('.element-json').val(), '2');
		});
		
		// Add / edit element
		jQuery(document).on('click', '#modal-element-settings #save-element-settings', function() {
			var container				= jQuery('#modal-element-settings')
				element_container		= container.find('.element-container'),
				element_container_clone	= {},
				
				pixel_fields			= [
					'border_radius',
					'border_width',
					'box_margin',
					'box_padding',
					'client_avatar_height',
					'client_avatar_margin',
					'client_avatar_padding',
					'client_avatar_width',
					'content_border_radius',
					'content_border_width',
					'content_margin',
					'content_padding',
					'controls_font_size',
					'controls_size',
					'font_size',
					'height',
					'icon_font_size',
					'icon_margin',
					'icon_padding',
					'image_height',
					'image_margin',
					'image_padding',
					'image_width',
					'indicators_size',
					'item_bar_height',
					'item_content_margin',
					'item_content_padding',
					'item_font_size',
					'item_height',
					'item_image_height',
					'item_image_width',
					'item_margin',
					'item_padding',
					'item_percentage_font_size',
					'item_size',
					'item_title_font_size',
					'item_title_icon_font_size',
					'item_title_margin',
					'item_title_padding',
					'item_width',
					'margin',
					'marker_title_font_size',
					'number_font_size',
					'padding',
					'price_font_size',
					'social_icons_font_size',
					'social_icons_margin',
					'social_icons_padding',
					'subtitle_font_size',
					'subtitle_margin',
					'subtitle_padding',
					'tag_font_size',
					'tag_margin',
					'tag_padding',
					'tags_margin',
					'tags_padding',
					'text_font_size',
					'title_font_size',
					'title_margin',
					'title_padding',
					'width'
				],
				em_fields				= [
					'border_radius',
					'border_width',
					'box_margin',
					'box_padding',
					'client_avatar_margin',
					'client_avatar_padding',
					'content_border_radius',
					'content_margin',
					'content_padding',
					'controls_font_size',
					'controls_size',
					'font_size',
					'icon_font_size',
					'icon_margin',
					'icon_padding',
					'image_margin',
					'image_padding',
					'indicators_size',
					'item_content_margin',
					'item_content_padding',
					'item_font_size',
					'item_margin',
					'item_padding',
					'item_percentage_font_size',
					'item_title_font_size',
					'item_title_icon_font_size',
					'item_title_margin',
					'item_title_padding',
					'margin',
					'marker_title_font_size',
					'number_font_size',
					'padding',
					'price_font_size',
					'social_icons_font_size',
					'social_icons_margin',
					'social_icons_padding',
					'subtitle_font_size',
					'subtitle_margin',
					'subtitle_padding',
					'tag_font_size',
					'tag_margin',
					'tag_padding',
					'tags_margin',
					'tags_padding',
					'text_font_size',
					'title_font_size',
					'title_margin',
					'title_padding'
				],
				rem_fields				= [
					'border_radius',
					'border_width',
					'box_margin',
					'box_padding',
					'client_avatar_margin',
					'client_avatar_padding',
					'content_border_radius',
					'content_margin',
					'content_padding',
					'controls_font_size',
					'controls_size',
					'font_size',
					'icon_font_size',
					'icon_margin',
					'icon_padding',
					'image_margin',
					'image_padding',
					'indicators_size',
					'item_content_margin',
					'item_content_padding',
					'item_font_size',
					'item_margin',
					'item_padding',
					'item_percentage_font_size',
					'item_title_font_size',
					'item_title_icon_font_size',
					'item_title_margin',
					'item_title_padding',
					'margin',
					'marker_title_font_size',
					'number_font_size',
					'padding',
					'price_font_size',
					'social_icons_font_size',
					'social_icons_margin',
					'social_icons_padding',
					'subtitle_font_size',
					'subtitle_margin',
					'subtitle_padding',
					'tag_font_size',
					'tag_margin',
					'tag_padding',
					'tags_margin',
					'tags_padding',
					'text_font_size',
					'title_font_size',
					'title_margin',
					'title_padding'
				],
				percentage_fields		= [
					'border_radius',
					'box_margin',
					'box_padding',
					'client_avatar_height',
					'client_avatar_margin',
					'client_avatar_padding',
					'client_avatar_width',
					'content_border_radius',
					'content_margin',
					'content_padding',
					'height',
					'icon_margin',
					'icon_padding',
					'image_height',
					'image_margin',
					'image_padding',
					'image_width',
					'item_bar_width',
					'item_content_margin',
					'item_content_padding',
					'item_height',
					'item_image_height',
					'item_image_width',
					'item_margin',
					'item_padding',
					'item_title_margin',
					'item_title_padding',
					'item_width',
					'margin',
					'padding',
					'social_icons_margin',
					'social_icons_padding',
					'subtitle_margin',
					'subtitle_padding',
					'tag_margin',
					'tag_padding',
					'tags_margin',
					'tags_padding',
					'title_margin',
					'title_padding',
					'width'
				],
				multiple_mixed_fields	= [
					'box_margin',
					'box_padding',
					'client_avatar_margin',
					'client_avatar_padding',
					'content_margin',
					'content_padding',
					'icon_margin',
					'icon_padding',
					'image_margin',
					'image_padding',
					'item_content_margin',
					'item_content_padding',
					'item_margin',
					'item_padding',
					'item_title_margin',
					'item_title_padding',
					'margin',
					'padding',
					'social_icons_margin',
					'social_icons_padding',
					'subtitle_margin',
					'subtitle_padding',
					'tag_margin',
					'tag_padding',
					'tags_margin',
					'tags_padding',
					'title_margin',
					'title_padding'
				],
				invalid_fields			= RSPageBuilderElementsHelper.validateSizeInput(container, pixel_fields, em_fields, rem_fields, percentage_fields, multiple_mixed_fields);
				
			if (!invalid_fields) {
				element_container.find('.element-json').val(JSON.stringify(RSPageBuilderElementsHelper.buildElementJson(element_container)));
				RSPageBuilderElementsHelper.removeComponents(element_container.find('.element-options'));
				element_container.find('.element-options').empty();
				element_container.find('.element-options').addClass('hidden');
				
				element_container_clone = element_container.clone();
				
				if (jQuery(this).hasClass('add-new-element')) {
					setTimeout(function() {
						jQuery('.rspbld-container .column-content').append(element_container_clone);
					}, 100);
				} else {
					jQuery('.rspbld-container .create-element .element').remove();
					jQuery('.rspbld-container .create-element').append(element_container_clone.find('.element'));
					jQuery('.rspbld-container .create-element').removeClass('create-element');
				}
				
				// Initialize element actions tooltip
				RSPageBuilderElementsHelper.removeTooltip();
				RSPageBuilderElementsHelper.removePopover();
				RSPageBuilderElementsHelper.initTooltip();
				RSPageBuilderElementsHelper.initPopover();
				
				// Remove videos
				RSPageBuilderElementsHelper.removeVideos();
				
				container.modal('hide');
				jQuery(this).closest('.modal-content').find('.modal-body > .row-fluid').removeAttr('style');
				jQuery(this).closest('.modal-content').find('.modal-body > .loader').removeAttr('style');
			}
		});
		
		// Iterative item title
		jQuery(document).on('keyup', '#modal-element-settings .accordion [data-name*="item_title-"], #modal-element-settings .accordion [data-name*="item_text-"], #modal-element-settings .accordion [data-name*="marker_title-"]', function() {
			jQuery(this).closest('.accordion-group').find('.accordion-toggle').text(jQuery(this).val());
		});
		
		// Remove modal loader style
		jQuery(document).on('click', '#modal-element-settings #close-element-settings, #modal-element-settings #cancel-element-settings', function() {
			jQuery('.create-element').removeClass('create-element');
			
			// Remove videos
			RSPageBuilderElementsHelper.removeVideos();
			
			jQuery(this).closest('.modal-content').find('.modal-body > .row-fluid').removeAttr('style');
			jQuery(this).closest('.modal-content').find('.modal-body > .loader').removeAttr('style');
		});
		
		// Fix tinyMCE editor plugins in modal
		jQuery(document).on('focusin', function(e) {
			if (jQuery(e.target).closest('.mce-window').length) {
				e.stopImmediatePropagation();
			}
		});
	});
	
	Joomla.submitbutton = function(task) {
		jQuery('#jform_params_elements').val(RSPageBuilderElementsHelper.elementsToJson());
		
		if (document.getElementById('module-form') !== null) {
			Joomla.submitform(task, document.getElementById('module-form'));
		} else {
			Joomla.submitform(task, document.getElementById('modules-form'));
		}
	}
	
	RSPageBuilderElementsHelper.initTooltip();
	RSPageBuilderElementsHelper.initPopover();
});

var RSPageBuilderElementsHelper = {
	
	// Make elements sortable
	sortableElements: function(obj) {
		obj.sortable({
			connectWith: obj,
			items: '.element-container',
			placeholder: 'ui-state-highlight',
			forcePlaceholderSize: true,
			axis: 'y',
			opacity: 0.8,
			tolerance: 'pointer',
			start: function(event, ui) {
				ui.item.css('margin-bottom', '0');
			},
			stop: function(event, ui) {
				ui.item.removeAttr('style');
			}
		}).disableSelection();
	},
	
	// Make items sortable
	sortableItems: function(obj) {
		obj.sortable({
			handle: '.move-item',
			placeholder: 'ui-state-highlight',
			axis: 'y',
			opacity: 0.8,
			tolerance: 'pointer',
			start: function(event, ui) {
				RSPageBuilderElementsHelper.removeComponents(ui.item);
				ui.item.closest('.iterative-items.accordion').find('.ui-state-highlight').css({
					'height'	: ui.item.outerHeight(),
					'width'		: ui.item.width()
				});
			},
			stop: function(event, ui) {
				RSPageBuilderElementsHelper.initComponents(ui.item);
				var element_container = jQuery('#modal-element-settings .element-container');
				
				element_container.find('.element-json').val(JSON.stringify(RSPageBuilderElementsHelper.buildElementJson(element_container)));
				RSPageBuilderElementsHelper.elementHtmlAjax(element_container.find('.edit-element'), element_container.find('.element-json').val(), '2');
				setTimeout(function() {
					RSPageBuilderElementsHelper.initMap(element_container);
				}, 1000);
				RSPageBuilderElementsHelper.fixMooToolsCarousel(jQuery('#modal-element-settings .element-preview'));
			}
		});
	},
	
	// Initialize jQuery UI
	initjQueryUI: function() {
		RSPageBuilderElementsHelper.sortableElements(jQuery('.rspbld-container .column-content'));
	},
	
	// Edit element
	editElement: function(obj) {
		var clone = obj.clone();
		
		clone.find('.element-options').removeClass('hidden');
		clone.find('.element-json').val(JSON.stringify(RSPageBuilderElementsHelper.buildElementJson(clone)));
		
		jQuery('#modal-element-settings .modal-body .span6:first').empty();
		jQuery('#modal-element-settings .modal-body .span6:first').append(clone);
		
		RSPageBuilderElementsHelper.elementHtmlAjax(clone.find('.edit-element'), clone.find('.element-json').val(), '2');
		RSPageBuilderElementsHelper.initComponents(jQuery('#modal-element-settings .element'));
		setTimeout(function() {
			RSPageBuilderElementsHelper.initMap(jQuery('#modal-element-settings .element-container'));
		}, 1000);
		RSPageBuilderElementsHelper.fixMooToolsCarousel(jQuery('#modal-element-settings .element-preview'));
		RSPageBuilderElementsHelper.sortableItems(jQuery('#modal-element-settings .accordion'));
		RSPageBuilderElementsHelper.initOptionsTab();
		
		jQuery('#modal-element-settings .loader').fadeOut(200);
		jQuery('#modal-element-settings .row-fluid').fadeIn(200);
	},
	
	// Duplicate iterative item
	duplicateItem: function(obj) {
		RSPageBuilderElementsHelper.removeComponents(jQuery('#modal-element-settings .accordion'));
		
		var clone			= obj.clone(),
			new_id			= RSPageBuilderElementsHelper.randomNumber(),
			items_number	= jQuery('#modal-element-settings .iterative-items .accordion-group').length;
			
		clone.find('.accordion-heading .accordion-toggle').attr('href', '#' + new_id);
		clone.find('.accordion-body').attr('id', new_id);
		clone.find('.collapse').removeClass('in');
		clone.find('.rspbld-input').each(function() {
			var item_segments = jQuery(this).attr('data-name').split('-');
				
			jQuery(this).attr('data-name', item_segments[0] + '-' + (items_number + 1));
			jQuery(this).attr('id', jQuery(this).attr('data-name').replace('-', '_'));
		});
		obj.closest('.accordion').append(clone);
		RSPageBuilderElementsHelper.initComponents(jQuery('#modal-element-settings .accordion'));
		RSPageBuilderElementsHelper.sortableItems(jQuery('#modal-element-settings .accordion'));
	},
	
	// Initialize tooltip
	initTooltip: function() {
		jQuery('*[data-rel="tooltip"]').tooltip();
	},
	
	// Destroy tooltip
	destroyThisTooltip: function(obj) {
		obj.find('*[data-rel="tooltip"]').tooltip('destroy');
	},

	// Remove tooltip
	removeTooltip: function() {
		jQuery('.tooltip').remove();
	},
	
	// Initialize popover
	initPopover: function() {
		jQuery('*[data-rel="popover"]').popover({trigger: 'hover'});
	},
	
	// Destroy popover
	destroyThisPopover: function(obj) {
		obj.find('*[data-rel="popover"]').popover('destroy');
	},

	// Remove popover
	removePopover: function() {
		jQuery('.popover').remove();
	},
	
	// Remove videos
	removeVideos: function() {
		var video_container = jQuery('.rspbld-video .rspbld-video-player, .rspbld-video .rspbld-vimeo-video, .rspbld-video .rspbld-youtube-video');
		
		if (video_container.length) {
			video_container.remove();
		}
	},
	
	// Initialize Joomla/Bootstrap components
	initComponents: function(obj) {
		
		// Initialize radio btn-group
		obj.find('.rspbld-field.btn-group.radio').each(function() {
			var field = jQuery(this);
			
			if (field.closest('.tab-pane').attr('id') != 'items') {
				field.find('input[checked="checked"]').attr('data-name', field.attr('id'));
			} else {
				field.find('input[checked="checked"]').attr('data-name', field.attr('id').replace(/_(\d+)$/, '-$1'));
			}
			field.find('input[checked="checked"]').addClass('rspbld-input');
			field.find('label').addClass('btn');
			field.find('label[for="' + field.find('input[checked="checked"]').attr('id') + '"]').addClass('active');
			
			if (field.find('input[checked="checked"]').val() == 0) {
				field.find('label[for="' + field.find('input[checked="checked"]').attr('id') + '"]').addClass('btn-danger');
			} else {
				field.find('label[for="' + field.find('input[checked="checked"]').attr('id') + '"]').addClass('btn-success');
			}
			
			field.find('label').click(function() {
				if (jQuery(this).hasClass('active')) {
					return true;
				} else {
					field.find('input').checked = false;
					field.find('input').removeAttr('checked');
					field.find('input').removeAttr('data-name');
					field.find('input').removeClass('rspbld-input');
					field.find('label').removeClass('active');
					field.find('label').removeClass('btn-danger');
					field.find('label').removeClass('btn-success');
					field.find('#' + jQuery(this).attr('for')).checked = true;
					field.find('#' + jQuery(this).attr('for')).attr('checked', 'checked');
					
					if (field.closest('.tab-pane').attr('id') != 'items') {
						field.find('#' + jQuery(this).attr('for')).attr('data-name', field.attr('id'));
					} else {
						field.find('#' + jQuery(this).attr('for')).attr('data-name', field.attr('id').replace(/_(\d+)$/, '-$1'));
					}
					field.find('#' + jQuery(this).attr('for')).addClass('rspbld-input');
					
					jQuery(this).addClass('active');
					
					if (jQuery('#' + jQuery(this).attr('for')).val() == 0) {
						jQuery(this).addClass('btn-danger');
					} else {
						jQuery(this).addClass('btn-success');
					}
					
					// Dynamically change element
					if (field.closest('#modal-element-settings .element-options').length) {
						var element_container = jQuery('#modal-element-settings .element-container');
						
						element_container.find('.element-json').val(JSON.stringify(RSPageBuilderElementsHelper.buildElementJson(element_container)));
						
						RSPageBuilderElementsHelper.elementHtmlAjax(jQuery('#modal-element-settings .edit-element'), element_container.find('.element-json').val(), '2');
						setTimeout(function() {
							RSPageBuilderElementsHelper.initMap(element_container);
						}, 1000);
						RSPageBuilderElementsHelper.fixMooToolsCarousel(jQuery('#modal-element-settings .element-preview'));
					}
				}
			});
		});
		
		// Initialize iterative items accordion
		obj.find('.accordion-group').each(function() {
			var id = RSPageBuilderElementsHelper.randomNumber();
			
			jQuery(this).find('.accordion-toggle').attr('href', '#item' + id);
			jQuery(this).find('.accordion-body').attr('id', 'item' + id);
		});
		
		// Initialize element / item Joomla! calendar
		var calendar_fields = obj.find('.field-calendar');
		
		for (i = 0; i < calendar_fields.length; i++) {
			JoomlaCalendar.init(calendar_fields[i]);
		}
		
		// Initialize element / item chosen
		jQuery('select').chosen();
		
		// Initialize element / item color picker
		obj.find('.color').each(function() {
			jQuery(this).minicolors({
				control: jQuery(this).attr('data-control') || 'hue',
				position: jQuery(this).attr('data-position') || 'bottom',
				theme: 'bootstrap',
				changeDelay: 200,
				change: function() {
					var element_container = jQuery('#modal-element-settings .element-container');
					
					element_container.find('.element-json').val(JSON.stringify(RSPageBuilderElementsHelper.buildElementJson(element_container)));
					
					RSPageBuilderElementsHelper.elementHtmlAjax(element_container.find('.edit-element'), element_container.find('.element-json').val(), '2');
					setTimeout(function() {
						RSPageBuilderElementsHelper.initMap(element_container);
					}, 1000);
					RSPageBuilderElementsHelper.fixMooToolsCarousel(jQuery('#modal-element-settings .element-preview'));
				}
			});
		});
		
		// Initialize element / item tinyMCE editor
		obj.find('.editor').each(function () {
			var id = 'editor-' + RSPageBuilderElementsHelper.randomNumber();
			
			jQuery(this).attr('id', id);
			tinyMCE.execCommand('mceAddEditor', false, id);
		});
		
		// Initialize tooltip
		obj.find('.hasTooltip').tooltip();
		
		// Initialize popover
		obj.find('.hasPopover').popover({trigger: 'hover'});
		
		// Initialize icons list
		obj.find('.iconslist').each(function() {
			jQuery(this).iconsList();
		});
		obj.find('.icons-list').removeClass('hidden');
		
		// Initialize image upload
		obj.find('.media').each(function() {
			jQuery(this).uploadImage();
		});
	},
	
	// Remove Joomla / Bootstrap components
	removeComponents: function(obj) {
		
		// Remove iterative items accordion
		obj.find('.accordion-group').each(function() {
			jQuery(this).find('.accordion-toggle').removeAttr('href');
			jQuery(this).find('.accordion-body').removeAttr('id');
		});
		
		// Remove element / item chosen
		obj.find('select').chosen('destroy');
		
		// Remove element / item color picker
		obj.find('.minicolors-input').each(function() {
			jQuery(this).minicolors('destroy');
		});
		
		// Remove element / item tinyMCE editor
		obj.find('.editor').each(function () {
			var id		= jQuery(this).attr('id'),
				content = tinyMCE.get(id).getContent();
				
			tinyMCE.execCommand('mceRemoveEditor', false, id);
			jQuery(this).text(content);
		});
		
		// Remove element / item media
		obj.find('.media').each(function() {
			jQuery(this).find('.input-media').removeAttr('id');
			
			// Element / item image preview
			jQuery(this).find('.image-preview').removeAttr('id');
			jQuery(this).find('.image-preview').find('img').removeAttr('id');
			jQuery(this).find('a.modal').removeAttr('href');
			jQuery(this).find('a.remove-media').removeAttr('onClick');
		});
		
		// Remove tooltip
		obj.find('.hasTooltip').tooltip('destroy');
		
		// Remove popover
		obj.find('.hasPopover').popover('destroy');
		
		// Remove icons list
		obj.find('.iconslist').removeAttr('style');
		obj.find('.icons-list').addClass('hidden');
	},
	
	// Initialize TinyMCE editors
	initEditors: function(obj) {
		obj.find('.editor').each(function() {
			var new_id = 'editor-' + RSPageBuilderElementsHelper.randomNumber();
			
			jQuery(this).attr('id', new_id);
			tinyMCE.EditorManager.execCommand('mceAddEditor', false, new_id);
		});
	},
	
	// Initialize Google maps
	initMap: function(obj) {
		if (obj.closest('.row-fluid').find('.map').length) {
			var map_container	= document.getElementById(obj.closest('.row-fluid').find('.map').attr('id')),
				element			= JSON.parse(JSON.stringify(eval('(' + obj.find('.element-json').val() + ')'))),
				style			= [];
				
			if (element.options.map_color) {
				style = [
					{
						elementType: "labels",
						stylers    : [
							{saturation: element.options.map_saturation}
						]
					},
					{
						featureType: "poi",
						elementType: "labels",
						stylers    : [
							{visibility: "off"}
						]
					},
					{
						featureType: "road.highway",
						elementType: "labels",
						stylers    : [
							{visibility: "off"}
						]
					},
					{
						featureType: "road.local",
						elementType: "labels.icon",
						stylers    : [
							{visibility: "off"}
						]
					},
					{
						featureType: "road.arterial",
						elementType: "labels.icon",
						stylers    : [
							{visibility: "off"}
						]
					},
					{
						featureType: "road",
						elementType: "geometry.stroke",
						stylers    : [
							{visibility: "off"}
						]
					},
					{
						featureType: "transit",
						elementType: "geometry.fill",
						stylers    : [
							{hue: element.options.map_color},
							{visibility: "on"},
							{lightness: element.options.map_brightness},
							{saturation: element.options.map_saturation}
						]
					},
					{
						featureType: "poi",
						elementType: "geometry.fill",
						stylers    : [
							{hue: element.options.map_color},
							{visibility: "on"},
							{lightness: element.options.map_brightness},
							{saturation: element.options.map_saturation}
						]
					},
					{
						featureType: "poi.government",
						elementType: "geometry.fill",
						stylers    : [
							{hue: element.options.map_color},
							{visibility: "on"},
							{lightness: element.options.map_brightness},
							{saturation: element.options.map_saturation}
						]
					},
					{
						featureType: "poi.sport_complex",
						elementType: "geometry.fill",
						stylers    : [
							{hue: element.options.map_color},
							{visibility: "on"},
							{lightness: element.options.map_brightness},
							{saturation: element.options.map_saturation}
						]
					},
					{
						featureType: "poi.attraction",
						elementType: "geometry.fill",
						stylers    : [
							{hue: element.options.map_color},
							{visibility: "on"},
							{lightness: element.options.map_brightness},
							{saturation: element.options.map_saturation}
						]
					},
					{
						featureType: "poi.business",
						elementType: "geometry.fill",
						stylers    : [
							{hue: element.options.map_color},
							{visibility: "on"},
							{lightness: element.options.map_brightness},
							{saturation: element.options.map_saturation}
						]
					},
					{
						featureType: "transit",
						elementType: "geometry.fill",
						stylers    : [
							{hue: element.options.map_color},
							{visibility: "on"},
							{lightness: element.options.map_brightness},
							{saturation: element.options.map_saturation}
						]
					},
					{
						featureType: "transit.station",
						elementType: "geometry.fill",
						stylers    : [
							{hue: element.options.map_color},
							{visibility: "on"},
							{lightness: element.options.map_brightness},
							{saturation: element.options.map_saturation}
						]
					},
					{
						featureType: "landscape",
						stylers    : [
							{hue: element.options.map_color},
							{visibility: "on"},
							{lightness: element.options.map_brightness},
							{saturation: element.options.map_saturation}
						]

					},
					{
						featureType: "road",
						elementType: "geometry.fill",
						stylers    : [
							{hue: element.options.map_color},
							{visibility: "on"},
							{lightness: element.options.map_brightness},
							{saturation: element.options.map_saturation}
						]
					},
					{
						featureType: "road.highway",
						elementType: "geometry.fill",
						stylers    : [
							{hue: element.options.map_color},
							{visibility: "on"},
							{lightness: element.options.map_brightness},
							{saturation: element.options.map_saturation}
						]
					},
					{
						featureType: "water",
						elementType: "geometry",
						stylers    : [
							{hue: element.options.map_color},
							{visibility: "on"},
							{lightness: element.options.map_brightness},
							{saturation: element.options.map_saturation}
						]
					}
				];
			}
				
				var map		= new google.maps.Map(map_container, {
					center: {
						lat: parseFloat(element.options.map_latitude),
						lng: parseFloat(element.options.map_longitude)
					},
					styles: style,
					zoom: parseInt(element.options.map_zoom)
				}),
				geocoder	= new google.maps.Geocoder();
				
			if (element.items.length) {
				for (var i = 0; i < element.items.length; i++) {
					var marker_options = RSPageBuilderElementsHelper.escapeHtmlObject(element.items[i].options);
					
					marker_options.marker_index = i + 1;
					
					if (marker_options.marker_address) {
						var address_input = obj.find('#marker_address_' + (i + 1));
						
						address_input.attr('autocomplete', 'off');
						RSPageBuilderElementsHelper.aucompleteLocation(map, address_input);
						
						geocoder.geocode({
							'address': marker_options.marker_address
						}, RSPageBuilderElementsHelper.onGeocodeComplete(map, marker_options));
					} else if (marker_options.marker_latitude && marker_options.marker_longitude) {
						var position = {
								lat: parseFloat(marker_options.marker_latitude),
								lng: parseFloat(marker_options.marker_longitude)
							};
							
						RSPageBuilderElementsHelper.googleMapMarkers(map, marker_options, position);
					}
				}
			}
		}
	},
	
	// Geocode (address to coordinates)
	onGeocodeComplete: function(map, marker_options) {
		var geocodeCallBack = function(results, status) {
			if (status == google.maps.GeocoderStatus.OK) {
				RSPageBuilderElementsHelper.googleMapMarkers(map, marker_options, results[0].geometry.location);
			} else {
				alert ('Location geocoding failed: ' + status);
			}
		}
		return geocodeCallBack;
	},
	
	aucompleteLocation: function(map, location) {
		var geocoder = new google.maps.Geocoder();
		
		location.on('keyup', function(e) {
			
			// Disable event on 'Shift' key press
			if ( e.which == 16) {
				return true;
			}
			if (RSPageBuilderElementsHelper.timer != null) {
				clearTimeout(RSPageBuilderElementsHelper.timer);
			}
			
			RSPageBuilderElementsHelper.timer = setTimeout(function() {
				location.nextAll('.location_results').remove();
				
				if (jQuery.trim(location.val())) {
					geocoder.geocode({
						'address': jQuery.trim(location.val())
					}, function(results, status) {
						if (status == google.maps.GeocoderStatus.OK) {
							results_wrapper = '<div class="location_results"><ul></ul></div>';
							
							location.after(results_wrapper);
							
							location_results = location.next('.location_results');
							
							if (results.length) {
								jQuery(results).each(function(index, item) {
									li = jQuery('<li>' + item.formatted_address + '</li>');
									
									li.click(function() {
										location.val(item.formatted_address);
										map.setCenter(item.geometry.location);
										
										location_results.remove();
									});
									
									location_results.find('ul').append(li);
								});
							} else {
								location_results.remove();
							}
							jQuery(document).click(function(event) {
								if (jQuery(event.target).parents().index(results) == -1) {
									location_results.remove();
								}
							});
						}
					});
				}
			}, 10);
		});
	},
	
	// Add Google maps markers
	googleMapMarkers: function(map, marker_options, position) {
		
		// Build marker
		var marker_title_show	= (typeof marker_options.marker_title_show == 'undefined' || (typeof marker_options.marker_title_show !== 'undefined' && marker_options.marker_title_show == 1)) ? 1 : 0,
			marker				= new google.maps.Marker({
			id: 'marker_' + marker_options.marker_index,
			position: position,
			map: map,
			icon: {
				path: 'M 0,0 C -2,-20 -10,-22 -10,-30 A 10,10 0 1,1 10,-30 C 10,-22 2,-20 0,0 z M -2,-30 a 2,2 0 1,1 4,0 2,2 0 1,1 -4,0',
				fillColor: marker_options.marker_color,
				fillOpacity: parseFloat(marker_options.marker_opacity),
				scale: parseFloat(marker_options.marker_scale),
				strokeColor: marker_options.marker_stroke_color,
				strokeWeight: parseInt(marker_options.marker_stroke_weight)
			}
		});
		
		// Build infowindow
		var infowindow_content	= '',
			marker_title_style	= {},
			marker_content_style	= {};
			
		if ((marker_options.marker_title && marker_title_show) || marker_options.marker_content) {
			if (marker_options.marker_title && marker_title_show) {
				if (marker_options.marker_title_font_size) {
					marker_title_style['font-size'] = marker_options.marker_title_font_size;
				}
				if (marker_options.marker_title_text_color && marker_options.marker_title_text_color != 'none') {
					marker_title_style['color'] = marker_options.marker_title_text_color;
				}
			}
			if (marker_options.marker_content) {
				if (marker_options.marker_content_text_color) {
					marker_content_style['color'] = marker_options.marker_content_text_color;
				}
			}
			infowindow_content += '<div class="infowindow">';
			
			if (marker_options.marker_title && marker_title_show) {
				infowindow_content += '<h1 class="heading"' + RSPageBuilderElementsHelper.buildStyle(marker_title_style) + '>' + marker_options.marker_title + '</h1>';
			}
			if (marker_options.marker_content) {
				infowindow_content += '<div class="content"' + RSPageBuilderElementsHelper.buildStyle(marker_content_style) + '>' + marker_options.marker_content + '</div>';
			}
			infowindow_content += '</div>';
			
			var infowindow = new google.maps.InfoWindow({
				content: infowindow_content,
				maxWidth: 250
			});
		}
		
		// Add infowindow listener
		if (marker && infowindow) {
			google.maps.event.addListener(marker, 'click', function() {
				infowindow.open(map, marker);
			});
		}
	},
	
	// Initialize Animated Number
	initAnimatedNumber: function() {
		if (jQuery.isFunction(jQuery.fn.visible) && jQuery.isFunction(jQuery.fn.animateNumber)) {
			jQuery('#modal-element-settings .element-preview .rspbld-animated-number').each(function() {
				var limit		= jQuery(this).find('.rspbld-number').data('limit'),
					separator	= jQuery.animateNumber.numberStepFactories.separator(jQuery(this).find('.rspbld-number').data('separator')),
					duration	= jQuery(this).find('.rspbld-number').data('duration'),
					delay		= jQuery(this).find('.rspbld-number').data('delay');
					
				if (jQuery(this).visible('vertical')) {
					jQuery(this).find('.rspbld-number').delay(parseInt(delay)).animateNumber({	
						number: parseInt(limit),
						numberStep: separator
					}, parseInt(duration));
				}
			});
		}
	},
	
	// Initialize Animate Progress Bars
	initAnimateProgressBars: function() {
		if (jQuery.isFunction(jQuery.fn.visible) && (jQuery('#modal-element-settings .element-preview .rspbld-progress-bars.animate .progress .bar').length > 0)) {
			jQuery('#modal-element-settings .element-preview .rspbld-progress-bars.animate .progress .bar').each(function(index) {
				if (!jQuery(this).attr('data-animated')) {
					var duration	= jQuery(this).closest('.rspbld-progress-bars.animate').data('duration'),
						delay		= jQuery(this).closest('.rspbld-progress-bars.animate').data('delay');
					
					jQuery(this).css('margin-left', '-' + jQuery(this).css('width'));
					jQuery(this).css('opacity', '1');
					
					if (jQuery(this).visible('vertical')) {
						jQuery(this).delay(parseInt(index * delay)).animate({
							marginLeft: 0
						}, duration);
						
						jQuery(this).attr('data-animated', '1');
					}
				}
			});
		}
	},
	
	// Initialize Animate Progress Circles
	initAnimateProgressCircles: function() {
		if (jQuery.isFunction(jQuery.fn.visible) && (jQuery('.rspbld-progress-circles.animate .progress-circle').length > 0)) {
			jQuery('#modal-element-settings .element-preview .rspbld-progress-circles.animate .progress-circle').each(function(index) {
				var current_circle = jQuery(this);
				
				if (!current_circle.attr('data-animated')) {
					var duration				= current_circle.closest('.rspbld-progress-circles.animate').data('duration'),
						delay					= current_circle.closest('.rspbld-progress-circles.animate').data('delay'),
						item_size				= current_circle.find('.item-wrapper').width(),
						show_item_percentage	= false;
						
					if (current_circle.find('.item-wrapper > span').text().indexOf('%') >= 0) {
						show_item_percentage = true;
					}
					
					if (current_circle.visible('vertical')) {
						current_circle.prop('counter', 0);
						
						setTimeout(function() {
							current_circle.animate({
							   counter: current_circle.find('.item-wrapper').attr('data-max-width'),
							}, {
								duration: duration,
								step: function(now) {
									var current = Math.ceil(now);
										
									if (current < 50) {
										current_circle.find('.item-wrapper .bar-wrapper').css('clip', 'rect(0, ' + item_size + 'px, ' + item_size + 'px, ' + item_size / 2 + 'px)');
									} else {
										current_circle.find('.item-wrapper .bar-wrapper').css('clip', 'rect(auto, auto, auto, auto)');
									}
									current_circle.find('.item-wrapper').attr('data-width', current);
								},
								queue: false
							}).animate({
								val_counter: (typeof current_circle.find('.item-wrapper').attr('data-max-value') !== 'undefined') ? current_circle.find('.item-wrapper').attr('data-max-value') : current_circle.find('.item-wrapper').attr('data-max-width'),
							}, {
								duration: duration,
								step: function(now) {
									var current = Math.ceil(now)
										symbol	= (typeof current_circle.find('.item-wrapper').attr('data-max-value') !== 'undefined' || !show_item_percentage) ? '' : '%';
										
									current += symbol;
									
									current_circle.find('.item-wrapper > span').text(current);
								},
								queue: false
							});
							
							current_circle.attr('data-animated', '1');
						}, index * delay);
					}
				}
			});
		}
	},
	
	// Initialize Countdown Timer
	initCountdownTimer: function() {
		if (jQuery.isFunction(jQuery.fn.countdownTimer) && (jQuery('.rspbld-countdown-timer').length > 0)) {
			jQuery('.rspbld-countdown-timer').each(function() {
				jQuery(this).countdownTimer();
			});
		}
	},
	
	// Initialize Masonry Boxes
	initMasonryBoxes: function() {
		var boxes_container	= jQuery('#modal-element-settings .element-preview .rspbld-masonry-boxes .boxes-container'),
			min_size		= parseInt(boxes_container.attr('data-min-size')),
			gutter			= parseInt(boxes_container.attr('data-gutter'));
		
		boxes_container.find('.box').each(function() {
			var sizes		= parseInt(jQuery(this).attr('class').replace(/^.*size([0-9]+).*$/, '$1')).toString().split(''),
				row_size	= (jQuery.isNumeric(sizes[1])) ? parseInt(sizes[1]) : 1,
				column_size	= (jQuery.isNumeric(sizes[0])) ? parseInt(sizes[0]) : 1,
				box_height	= (gutter > 0) ? parseInt(min_size * row_size + gutter * (row_size - 1)) : parseInt(min_size * row_size);
				box_width	= (gutter > 0) ? parseInt(min_size * column_size + gutter * (column_size - 1)) : parseInt(min_size * column_size);
			
			jQuery(this).css('height', box_height);
			jQuery(this).css('width', box_width);
			jQuery(this).css('margin-bottom', gutter);
		});
		
		boxes_container.masonry({
			itemSelector: '.box',
			columnWidth: min_size,
			gutter: gutter
		});
	},
	
	// Initialize Vimeo video
	initVimeoVideo: function() {
		if (jQuery('#modal-element-settings .element-preview .rspbld-vimeo-video').length) {
			var video 	= jQuery('#modal-element-settings .element-preview .rspbld-vimeo-video'),
				options	= {
					id			: video.data('source'),
					autoplay	: (video.data('autoplay') == 1) ? true : false,
					loop		: (video.data('loop') == 1) ? true : false
				},
				player	= new Vimeo.Player(video.attr('id'), options);
				
			player.setVolume(video.data('volume') / 100);
			
			if (video.data('start') != 0 || video.data('end') != 0) {
				if (video.data('end') > video.data('start')) {
					player.setCurrentTime(video.data('start')).then(function(seconds) {
						player.addCuePoint(parseInt(video.data('end')));
						
						player.on('cuepoint', function() {
							player.pause();
						})
					});
				} else if (video.data('end') == 0) {
					player.setCurrentTime(video.data('start')).then(function(seconds) {
						player.getDuration().then(function(duration) {
							player.addCuePoint(parseInt(duration));
							
							player.on('cuepoint', function() {
								player.pause();
							})
						}).catch(function(error) {});
					}).catch(function(error) {});
				}
			}
		}
	},
	
	// Initialize YouTube video
	initYouTubeVideo: function() {
		if (jQuery('#modal-element-settings .element-preview .rspbld-youtube-video').length) {
			var player,
				video = jQuery('#modal-element-settings .element-preview .rspbld-youtube-video');
			
			player = new YT.Player(video.attr('id'), {
				videoId		: video.data('source'),
				playerVars	: {
					autoplay	: video.data('autoplay'),
					controls	: video.data('controls'),
					showinfo	: video.data('showinfo'),
					rel			: video.data('rel'),
					loop		: video.data('loop'),
					playlist	: video.data('playlist'),
					start		: video.data('start'),
					end			: video.data('end'),
					vq			: video.data('vq')
				},
				events		: {
					'onReady': onPlayerReady
				}
			});
			
			function onPlayerReady(event) {
				event.target.setVolume(video.data('volume'));
			}
		}
	},
	
	// Initialize video player
	initVideoPlayer: function() {
		if (jQuery('#modal-element-settings .element-preview .rspbld-video-player').length) {
			jQuery('#modal-element-settings .element-preview .rspbld-video-player').videoPlayer();
		}
	},
	
	// Initialize YouTube Background Video Boxes
	initYouTubeBackgroundVideoBoxes: function() {
		jQuery.mbYTPlayer.apiKey = jQuery('#modal-element-settings .element-preview .rspbld-youtube-player').data('apikey');
		jQuery('#modal-element-settings .element-preview .rspbld-youtube-player').YTPlayer();
	},
	
	// Initialize Portfolio Filtering Box
	initPortfolioFiltering: function() {
		//Initialize filterizr 
		var layout = jQuery('#modal-element-settings .element-preview .rspbld-portfolio-filtering-container').attr('data-layout');
		
		jQuery('#modal-element-settings .element-preview .rspbld-portfolio-filtering-container').filterizr({layout: layout, setupControls: false});
		
		//Simple filter controls
		jQuery('#modal-element-settings .element-preview .rspbld-filter li').click(function() {
			jQuery('#modal-element-settings .element-preview .rspbld-filter li').removeClass('active');
			jQuery(this).addClass('active');
		});
	},
	
	// Random number
	randomNumber: function() {
		return Math.floor(Math.random() * (9999 - 1000 + 1) + 1000);
	},
	
	// Create id
	createId: function(string, number) {
		return string.replace(/\W/g, '').toLowerCase() + number;
	},
	
	// Escape HTML
	escapeHtml: function(str) {
		return str.replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/&/g, '&amp;');
	},
	
	// Escape HTML
	escapeHtmlObject: function(obj) {
		for (var key in obj) {
			if (key != 'item_content' && key != 'marker_content') {
				obj[key] = RSPageBuilderElementsHelper.escapeHtml(obj[key]);
			}
		}
		
		return obj;
	},
	
	// Get location
	getLocation: function(href) {
		var new_element = document.createElement('a');
		
		new_element.href = href;
		
		return new_element;
	},
	
	// Build style
	buildStyle: function(obj) {
		var style				= '';
		
		if (Object.keys(obj).length) {
			style += ' style="';
			
			for (var key in obj) {
				if (key == 'background-image') {
					style += key + ':url(' + obj[key] + ');';
				} else {
					style += key + ':' + obj[key] + ';';
				}
			}
			style += '"';
		}
		return style;
	},
	
	// Fix for Bootstrap conflict with MooTools
	fixMooTools: function() {
		if (typeof MooTools != 'undefined' ) {
			Element.implement({
				hide: function() {
					return;
				}
			});
		}
	},
	
	// Fix for Bootstrap carousel conflict with MooTools
	fixMooToolsCarousel: function() {
		if (typeof MooTools != 'undefined' ) {
			Element.implement({
				slide: function(how, mode) {
					return this;
				}
			});
		}
	},
	
	// Initialize Bootstrap carousel
	initCarousel: function() {
		jQuery('#modal-element-settings .element-preview .rspbld-carousel .carousel').each(function() {
			var carousel_cycle 	  = (jQuery(this).attr('data-interval') == 0) ? false : true,
				carousel_interval = (jQuery(this).attr('data-interval') == 0) ? false : jQuery(this).attr('data-interval');
				
			jQuery(this).carousel({
				interval: carousel_interval,
				cycle: carousel_cycle
			});
		});
	},
	
	// Initialize options tab navigation
	initOptionsTab: function() {
		jQuery(document).on('click', '.options-tab .nav-tabs > li > a', function() {
			var id = jQuery(this).attr('href').replace('#', '');
			
			jQuery(this).closest('.tab').find('.tab-pane').each(function() {
				if (jQuery(this).attr('id') == id) {
					jQuery(this).addClass('active');
				} else {
					jQuery(this).removeClass('active');
				}
			});
		});
	},
	
	// Initialize TinyMCE editors
	initTinyMCE: function() {
		var dir  = jQuery('html').attr('dir'),
		    lang = jQuery('html').attr('lang').split('-');
			
		tinyMCE.init({
			
			// General
			directionality: dir,
			language: lang[0].toLowerCase(),
			mode: 'textarea.mce_editable',
			autosave_restore_when_empty: false,
			skin: 'lightgray',
			theme: 'modern',
			schema: 'html5',
			
			// Cleanup / output
			inline_styles: true,
			gecko_spellcheck: true,
			entity_encoding: 'raw',
			valid_elements: '',
			extended_valid_elements: 'hr[id|title|alt|class|width|size|noshade]',
			fontsize_formats: '8px 10px 12px 14px 16px 18px 20px 22px 24px 26px 28px 30px 32px 34px 36px 38px 40px 42px 44px 48px',
			force_br_newlines: false,
			force_p_newlines: true,
			forced_root_block: 'p',
			toolbar_items_size: 'small',
			invalid_elements: 'script,applet',
			
			// Plugins
			plugins: 'table link image code hr charmap autolink lists importcss',
			
			// Toolbar
			toolbar1: 'bold italic underline strikethrough | alignleft aligncenter alignright alignjustify | formatselect | bullist numlist',
			toolbar2: 'fontsizeselect | outdent indent | undo redo | link unlink anchor image code | hr table | subscript superscript | charmap',
			removed_menuitems: 'newdocument',
			
			// URL
			relative_urls: true,
			remove_script_host: true,
			document_base_url: rspbld_root,
			
			// Layout
			content_css: rspbld_root + 'templates/system/css/editor.css',
			importcss_append: true,
			
			// Advanced options
			resize: 'both',
			height: '300',
			width: '',
			
			// Element preview
			setup: function(ed) {
				ed.on('change', function(e) {
					var element_container = jQuery('#modal-element-settings .element-container');
					
					jQuery('#' + ed.id).text(ed.getContent());
					jQuery('#' + ed.id).val(ed.getContent());
					
					element_container.find('.element-json').val(JSON.stringify(RSPageBuilderElementsHelper.buildElementJson(element_container)));
					RSPageBuilderElementsHelper.elementHtmlAjax(element_container.find('.edit-element'), element_container.find('.element-json').val(), '2');
					setTimeout(function() {
						RSPageBuilderElementsHelper.initMap(element_container);
					}, 1000);
					RSPageBuilderElementsHelper.fixMooToolsCarousel(jQuery('#modal-element-settings .element-preview'));
				});
			}
		});
	},
	
	elementFieldToTitle: function(container_id, element_field) {
		var field_parts = element_field.split('-');
		
		return Joomla.JText._('MOD_RSPAGEBUILDER_ELEMENTS_' + field_parts[0].toUpperCase());
	},
	
	elementTypeToTitle: function(element_type) {
		return Joomla.JText._('MOD_RSPAGEBUILDER_ELEMENTS_' + element_type.replace('rspbld_', '').toUpperCase());
	},
	
	renderElementAjax: function(container, element) {
		if (typeof element != 'undefined') {
			var regexp = /^<div class="\options-tab tab"\>/;
			
			jQuery.ajax({
				type: 'POST',
				dataType: 'html',
				url: rspbld_root + 'administrator/index.php?option=com_rspagebuilder&task=page.renderElement',
				data: JSON.parse(JSON.stringify(eval('(' + element + ')'))),
				success: function(html) {
					if (regexp.test(html)) {
						container.empty();
						container.append(html);
						container.find('.rspbld-input').each(function() {
							jQuery(this).attr('data-name', jQuery(this).attr('name'));
							jQuery(this).removeAttr('name');
						});
						container.find('.rspbld-field.btn-group.radio').each(function() {
							if (!jQuery(this).find('.rspbld-input').length) {
								jQuery(this).find('input[checked="checked"]').addClass('rspbld-input');
								
								if (jQuery(this).closest('.tab-pane').attr('id') != 'items') {
									jQuery(this).find('input[checked="checked"]').attr('data-name', jQuery(this).attr('id'));
								} else {
									jQuery(this).find('input[checked="checked"]').attr('data-name', jQuery(this).attr('id').replace(/_(\d+)$/, '-$1'));
								}
							}
						});
						RSPageBuilderElementsHelper.editElement(container.closest('.element-container'));
					} else {
						window.location.reload();
					}
				}
			});
		}
	},
	
	elementHtmlAjax: function(trigger, element, bootstrap_version) {
		var regexp = /class="rspbld-/;
		
		element = JSON.parse(JSON.stringify(eval('(' + element + ')')));
		element.bootstrap_version = bootstrap_version;
		
		if (trigger.hasClass('edit-element')) {
			jQuery('#modal-element-settings .modal-body .element-preview').append('<div class="preview-loader"></div>');
		}
		
		jQuery.ajax({
			type: 'POST',
			dataType: 'html',
			url: rspbld_root + 'administrator/index.php?option=com_rspagebuilder&task=page.elementHtml',
			data: element,
			success: function(html) {
				if (regexp.test(html) || html == '') {
					if (trigger.hasClass('view-element-html')) {
						var title		= '',
							subtitle	= '';
							
						if (element.options.title) {
							title = element.options.title;
						} else if (element.options.text) {
							title = element.options.text;
						} else {
							title = RSPageBuilderElementsHelper.elementTypeToTitle(element.type);
						}
						subtitle = RSPageBuilderElementsHelper.elementTypeToTitle(element.type);
						
						if (title != subtitle) {
							jQuery('#modal-element-view-html .modal-title').text(title + ' (' + subtitle + ')');
						} else {
							jQuery('#modal-element-view-html .modal-title').text(title);
						}
						jQuery('#modal-element-view-html .modal-body > textarea').empty();
						jQuery('#modal-element-view-html .modal-body > textarea').text(style_html(html));
						jQuery('#modal-element-view-html').modal('show');
					} else if (trigger.hasClass('edit-element')) {
						setTimeout(function() {
							jQuery('#modal-element-settings .modal-body .element-preview').empty();
							jQuery('#modal-element-settings .modal-body .element-preview').append(html);
						}, 200);
						
						setTimeout(function() {
							if (element.type == 'rspbld_animated_number') {
								RSPageBuilderElementsHelper.initAnimatedNumber();
							} else if (element.type == 'rspbld_carousel') {
								RSPageBuilderElementsHelper.initCarousel();
							} else if (element.type == 'rspbld_countdown_timer') {
								RSPageBuilderElementsHelper.initCountdownTimer();
							} else if (element.type == 'rspbld_masonry_boxes') {
								RSPageBuilderElementsHelper.initMasonryBoxes();
							} else if (element.type == 'rspbld_progress_bars') {
								RSPageBuilderElementsHelper.initAnimateProgressBars();
							} else if (element.type == 'rspbld_progress_circles') {
								RSPageBuilderElementsHelper.initAnimateProgressCircles();
							} else if ((element.type == 'rspbld_video')) {
								RSPageBuilderElementsHelper.initVideoPlayer();
								RSPageBuilderElementsHelper.initVimeoVideo();
								RSPageBuilderElementsHelper.initYouTubeVideo();
							} else if (element.type == 'rspbld_youtube_background_video_box') {
								RSPageBuilderElementsHelper.initYouTubeBackgroundVideoBoxes();
							} else if (element.type == 'rspbld_portfolio_filtering') {
								RSPageBuilderElementsHelper.initPortfolioFiltering();
							}
						}, 500);
					}
				} else {
					window.location.reload();
				}
			}
		});
	},
	
	buildElementJson: function(element_container) {
		var element_type		= '',
			element_category	= '',
			element_options		= {};
		
		if (element_container.find('[data-name="title"]').length) {
			element_container.find('.element-title').text(element_container.find('[data-name="title"]').val());
		} else if (element_container.find('[data-name="text"]').length) {
			element_container.find('.element-title').text(element_container.find('[data-name="text"]').val());
		}
		if (!element_container.find('.element-title').text()) {
			element_container.find('.element-title').text(element_container.find('.element-type').text());
			element_container.find('.element-type').addClass('hidden');
		}
		if (element_container.find('.element-title').text() == element_container.find('.element-type').text()) {
			element_container.find('.element-type').addClass('hidden');
		} else {
			element_container.find('.element-type').removeClass('hidden');
		}
		
		element_container.find('.element-options .tab-content > div:not(#items) .rspbld-input').each(function() {
			if (jQuery(this).data('name') == 'type') {
				element_type = jQuery(this).val();
			} else if (jQuery(this).data('name') == 'category') {
				element_category = jQuery(this).val();
			} else {
				element_options[jQuery(this).data('name')] = jQuery(this).val();
			}
		});
		
		element = {
			'type': element_type,
			'category': element_category,
			'options': element_options,
			'items': []
		};
		
		element_container.find('.element-options .iterative-items .accordion-inner').each(function(index) {
			var item_options = {};
			
			jQuery(this).find('.rspbld-input').each(function() {
				var field = jQuery(this).data('name').split('-');
				
				item_options[field[0]] = jQuery(this).val();
			});
			
			element.items[index] = {
				'type'		: element_type + '_item',
				'options'	: item_options
			};
		});
		
		return element;
	},
	
	validateSizeInput: function(container, pixel_fields, em_fields, rem_fields, percentage_fields, multiple_mixed_fields) {
		var invalid_fields		= [],
			invalid_fields_html	= '';
			
		container.find('.rspbld-input').each(function() {
			var pixel_regexp			= new RegExp('^(' + pixel_fields.join('|') + ')', 'i'),
				em_regexp				= new RegExp('^(' + em_fields.join('|') + ')', 'i'),
				rem_regexp				= new RegExp('^(' + rem_fields.join('|') + ')', 'i'),
				percentage_regexp		= new RegExp('^(' + percentage_fields.join('|') + ')', 'i'),
				multiple_mixed_regexp	= new RegExp('^(' + multiple_mixed_fields.join('|') + ')', 'i'),
				all_regexp				= new RegExp(pixel_regexp.source + '|' + em_regexp.source + '|' + rem_regexp.source + '|' + percentage_regexp.source + '|' + multiple_mixed_regexp.source),
				
				pixel_value				= /^[0-9]+\.?[0-9]*px$/,
				em_value				= /^[0-9]+\.?[0-9]*em$/,
				rem_value				= /^[0-9]+\.?[0-9]*rem$/,
				percentage_value		= /^[0-9]+\.?[0-9]*\%$/,
				multiple_mixed_values	= /^[0-9]+\.?[0-9]*(px|em|rem|\%)( )?([0-9]+\.?[0-9]*(px|em|rem|\%))?( )?([0-9]+\.?[0-9]*(px|em|rem|\%))?( )?([0-9]+\.?[0-9]*(px|em|rem|\%))?$/,
				
				invalid					= true;
				
			if (jQuery(this).val() && all_regexp.test(jQuery(this).attr('data-name'))) {
				if (pixel_regexp.test(jQuery(this).attr('data-name')) && pixel_value.test(jQuery(this).val())) {
					invalid = false;
				} else if (em_regexp.test(jQuery(this).attr('data-name')) && em_value.test(jQuery(this).val())) {
					invalid = false;
				} else if (rem_regexp.test(jQuery(this).attr('data-name')) && rem_value.test(jQuery(this).val())) {
					invalid = false;
				} else if (percentage_regexp.test(jQuery(this).attr('data-name')) && percentage_value.test(jQuery(this).val())) {
					invalid = false;
				} else if (multiple_mixed_regexp.test(jQuery(this).attr('data-name')) && multiple_mixed_values.test(jQuery(this).val())) {
					invalid = false;
				}
				
				if (invalid) {
					jQuery(this).addClass('invalid');
					jQuery(this).closest('.control-group').find('label').addClass('invalid');
					invalid_fields.push(jQuery(this));
					invalid_fields_html += '<p>' + Joomla.JText._('MOD_RSPAGEBUILDER_ELEMENTS_INVALID_FIELD') + ': ' + RSPageBuilderElementsHelper.elementFieldToTitle(container.attr('id'), jQuery(this).attr('data-name')) + '</p>';
				} else {
					jQuery(this).removeClass('invalid');
					jQuery(this).closest('.control-group').find('label').removeClass('invalid');
				}
			}
		});
		
		if (invalid_fields_html) {
			container.find('.alert.message').remove();
			container.find('.options-tab').before('<div class="alert alert-danger message"><h4>' + Joomla.JText._('MOD_RSPAGEBUILDER_ELEMENTS_ERROR') + '</h4>' + invalid_fields_html + '</div>');
		} else {
			container.find('.alert.message').remove();
		}
		
		container.find('.options-tab .nav-tabs li a').removeClass('invalid');
		container.find('.iterative-items .accordion-heading a').removeClass('invalid');
		
		if (invalid_fields.length) {
			for (var i = 0; i < invalid_fields.length; i++) {
				if (!container.find('.options-tab .nav-tabs li a[href="#' + invalid_fields[i].closest('.tab-pane').attr('id') + '"]').hasClass('invalid')) {
					container.find('.options-tab .nav-tabs li a[href="#' + invalid_fields[i].closest('.tab-pane').attr('id') + '"]').addClass('invalid');
				}
				if (container.find('.iterative-items').length) {
					if (!container.find('.iterative-items .accordion-heading a[href="#' + invalid_fields[i].closest('.accordion-body').attr('id') + '"]').hasClass('invalid')) {
						container.find('.iterative-items .accordion-heading a[href="#' + invalid_fields[i].closest('.accordion-body').attr('id') + '"]').addClass('invalid');
					}
				}
			}
		}
		
		return invalid_fields.length;
	},
	
	elementsToJson: function() {
		var elements = [];
		
		jQuery('.rspbld-container .element-container').each(function(index) {
			var element				= jQuery(this),
				element_attributes	= JSON.parse(JSON.stringify(eval('(' + jQuery(this).find('.element-json').val() + ')')));
			
			elements[index] = {
				'type' 		: element_attributes.type,
				'category'	: element_attributes.category,
				'options'	: element_attributes.options,
				'items'		: element_attributes.items
			};
		});
		
		return JSON.stringify(elements);
	}
};