<?php
/**
 * @package RSPageBuilder!
 * @copyright (C) 2016 www.rsjoomla.com
 * @license GPL, http://www.gnu.org/licenses/gpl-3.0.html
 */

defined('JPATH_PLATFORM') or die;

JHtml::_('behavior.modal');
JHtml::_('behavior.formvalidation');
JHtml::_('jquery.ui', array('core', 'sortable'));
JHtml::_('formbehavior.chosen', 'select');

JFormHelper::loadFieldClass('list');

class JFormFieldElementslist extends JFormField {
	protected $type = 'Elementslist';
	
	protected function getInput() {
		jimport('joomla.filesystem.folder');
		jimport('joomla.filesystem.file');

		require_once JPATH_SITE . '/modules/mod_rspagebuilder_elements/helper.php';
		require_once JPATH_ADMINISTRATOR . '/components/com_rspagebuilder/helpers/config.php';
		require_once JPATH_ADMINISTRATOR . '/components/com_rspagebuilder/helpers/rspagebuilder.php';
		
		$html 					= '';
		$doc					= JFactory::getDocument();
		$elements				= json_decode($this->value);
		$default_elements		= RSPageBuilderConfig::getElements();
		$my_elements			= RSPageBuilderConfig::getMyElements();
		$elements_category		= array();
		$elements_category[]	= JText::_('MOD_RSPAGEBUILDER_ELEMENTS_ALL_ELEMENTS');
		$element_title			= '';
		$element_subtitle		= '';
		$google_api_key			= JComponentHelper::getParams('com_rspagebuilder')->get('google_api_key');
		
		// Load CSS files
		$doc->addStylesheet(JUri::root(true) . '/media/jui/css/jquery.minicolors.css');
		
		RSPageBuilderHelper::loadAsset('component', 'font-awesome.min.css');
		RSPageBuilderHelper::loadAsset('component', 'animations.css');
		RSPageBuilderHelper::loadAsset('component', 'jquery.mb.YTPlayer.min.css');
		RSPageBuilderHelper::loadAsset('component', 'fields/iconslist.css');
		RSPageBuilderHelper::loadAsset('component', 'fields/uploadimage.css');
		RSPageBuilderHelper::loadAsset('module', 'admin-style.css');
		RSPageBuilderHelper::loadGoogleFonts();
		
		// Load JS files
		$doc->addScript(JUri::root(true) . '/media/jui/js/jquery.minicolors.min.js');
		$doc->addScript(JUri::root(true) . '/media/editors/tinymce/tinymce.min.js');
		$doc->addScript('https://www.youtube.com/iframe_api');
		$doc->addScript('https://player.vimeo.com/api/player.js');
		
		RSPageBuilderHelper::loadAsset('component', 'rsmodal.js');
		RSPageBuilderHelper::loadAsset('component', 'beautify-html.js');
		RSPageBuilderHelper::loadAsset('component', 'jquery.visible.min.js');
		RSPageBuilderHelper::loadAsset('component', 'jquery.animateNumber.min.js');
		RSPageBuilderHelper::loadAsset('component', 'jquery.countdownTimer.js');
		RSPageBuilderHelper::loadAsset('component', 'masonry.pkgd.min.js');
		RSPageBuilderHelper::loadAsset('component', 'jquery.mb.YTPlayer.min.js');
		RSPageBuilderHelper::loadAsset('component', 'jquery.videoPlayer.js');
		RSPageBuilderHelper::loadAsset('component', 'jquery.filterizr.js');
		RSPageBuilderHelper::loadAsset('component', 'fields/iconslist.js');
		RSPageBuilderHelper::loadAsset('component', 'fields/uploadimage.js');
		RSPageBuilderHelper::loadAsset('module', 'admin-script.js');
		
		$doc->addScriptDeclaration('var rspbld_root="'.JUri::root().'";');
		
		// Load elements CSS files
		foreach ($default_elements as $element) {
			$elements_category[] = strtolower($element['category']);
			
			// Load each element style
			RSPageBuilderHelper::loadAsset('element', str_replace('rspbld_', '', $element['type']).'.css');
		}
		
		// Load template rendered elements style
		RSPageBuilderHelper::loadAsset('component', 'admin-elements-style.css');
		
		foreach ($my_elements as $element) {
			$elements_category[] = strtolower($element['category']);
		}
		$elements_category = array_unique($elements_category);
		
		// Messages translations
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ERROR');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_INVALID_FIELD');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_LEAVE_PAGE');
		
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_COUNTDOWN_TIMER_EXPIRED');
		
		JText::script('WARNING');
		
		// Actions translations
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_BUTTON');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SURE_REMOVE_ELEMENT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SURE_REMOVE_ITEM');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_REMOVE_LAST_ITEM');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ICON_SEARCH_ICON');

		// Elements translations
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ACCORDION');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ALERT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ANIMATED_NUMBER');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_BUTTON');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_CAROUSEL');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_COUNTDOWN_TIMER');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_DIVIDER');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_GOOGLE_MAP');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_HORIZONTAL_ICON_BOX');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_HORIZONTAL_IMAGE_BOX');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ICON');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_IMAGE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_LIST');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_MODULE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_PERSONAL_BOX');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_PORTFOLIO_FILTERING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_PRICE_BOX');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_PROGRESS_BARS');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_PROGRESS_CIRCLES');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SPACER');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_TAB');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_TESTIMONIAL_BOX');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_TEXT_BLOCK');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_VERTICAL_ICON_BOX');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_VERTICAL_IMAGE_BOX');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_VIDEO');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_YOUTUBE_BACKGROUND_VIDEO_BOX');

		// Elements fields translations
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_BORDER_RADIUS');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_BORDER_WIDTH');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_BOX_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_BOX_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_CLIENT_AVATAR_HEIGHT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_CLIENT_AVATAR_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_CLIENT_AVATAR_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_CLIENT_AVATAR_WIDTH');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_CONTENT_BORDER_RADIUS');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_CONTENT_BORDER_WIDTH');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_CONTENT_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_CONTENT_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_CONTROLS_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_CONTROLS_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_COUNTDOWN_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_COUNTDOWN_FONT_WEIGHT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_COUNTDOWN_TEXT_COLOR');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_DETAILS_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_DETAILS_FONT_WEIGHT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_DETAILS_TEXT_COLOR');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_FONT_WEIGHT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_FORMAT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_HEIGHT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ICON_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ICON_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ICON_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_IMAGE_HEIGHT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_IMAGE_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_IMAGE_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_IMAGE_WIDTH');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_INDICATORS_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_BAR_HEIGHT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_BAR_WIDTH');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_CONTENT_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_CONTENT_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_HEIGHT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_IMAGE_HEIGHT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_IMAGE_WIDTH');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_PERCENTAGE_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_TITLE_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_TITLE_ICON_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_TITLE_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_TITLE_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_ITEM_WIDTH');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_LONG');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_LONG_DAY');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_LONG_DAYS');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_LONG_HOURS');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_LONG_HOUR');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_LONG_MINUTE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_LONG_MINUTES');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_LONG_SECOND');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_LONG_SECONDS');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_MARKER_TITLE_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_NUMBER_BACKGROUND_COLOR');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_NUMBER_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_NUMBER_FONT_WEIGHT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_NUMBER_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_NUMBER_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_NUMBER_POISTION');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_NUMBER_TEXT_COLOR');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_PRICE_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SHORT');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SHORT_DAYS');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SHORT_HOURS');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SHORT_MINUTES');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SHORT_SECONDS');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SOCIAL_ICONS_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SOCIAL_ICONS_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SOCIAL_ICONS_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SUBTITLE_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SUBTITLE_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_SUBTITLE_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_TEXT_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_TAG_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_TAG_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_TAG_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_TAGS_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_TAGS_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_TITLE_FONT_SIZE');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_TITLE_MARGIN');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_TITLE_PADDING');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_URL');
		JText::script('MOD_RSPAGEBUILDER_ELEMENTS_WIDTH');
		
		// Initialize field class
		!empty($this->class) ? $this->class = ' '.$this->class : $this->class = '';
		
		// Build field HTML
		$html .= '<div class="rspbld-elements">';
		$html .= '	<div class="rspbld-container">';
		$html .=		'<div class="column-content">';

		if ($elements && count($elements)) 
		{
			foreach ($elements as $element) 
			{
				if (isset($element->options->title) && $element->options->title) {
					$element_title = RSPageBuilderHelper::escapeHtml($element->options->title);
				} else if (isset($element->options->text) && $element->options->text) {
					$element_title = RSPageBuilderHelper::escapeHtml($element->options->text);
				} else {
					$element_title = RSPageBuilderElementsHelper::elementTypeToTitle($element->type);
				}
				$element_subtitle = RSPageBuilderElementsHelper::elementTypeToTitle($element->type);
				
				$html .=	'<div class="element-container">';
				$html .=		'<div class="element">';
				$html .= 			'<img class="element-image '.$element->type.' pull-left" src="'.RSPageBuilderHelper::getElementIcon($element->type).'" alt="'.RSPageBuilderElementsHelper::elementTypeToTitle($element->type).'"/>';
				$html .=			'<h3 class="element-title">'.$element_title.'</h3>';
				$html .=			'<h4 class="element-type'.(($element_title == $element_subtitle) ? ' hidden' : '').'" data-type="'.$element->type.'">'.$element_subtitle.'</h4>';
				$html .=			'<div class="element-actions">';
				$html .= 				'<a class="edit-element hasTooltip" href="javascript:void(0)" data-rel="tooltip" data-title="'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_EDIT_ELEMENT').'"><i class="fa fa-pencil"></i></a>';
				$html .= 				'<a class="view-element-html hasTooltip" href="javascript:void(0)" data-rel="tooltip" data-title="'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_VIEW_ELEMENT_HTML').'"><i class="fa fa-file-code-o"></i></a>';
				$html .= 				'<a class="duplicate-element hasTooltip" href="javascript:void(0)" data-rel="tooltip" data-title="'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_DUPLICATE_ELEMENT').'"><i class="fa fa-files-o"></i></a>';
				$html .= 				'<a class="remove-element hasTooltip" href="javascript:void(0)" data-rel="tooltip" data-title="'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_REMOVE_ELEMENT').'"><i class="fa fa-times"></i></a>';
				$html .=			'</div>';
				$html .=			'<div class="element-options hidden">';
				$html .=			'</div>';
				$html .=			'<input class="element-json" type="hidden" value="'.RSPageBuilderElementsHelper::escape(json_encode($element)).'">';
				$html .=		'</div>';
				$html .=	'</div>';
			}
		}
		$html .=			'<div class="add-element-container">';
		$html .=				'<a href="javascript:void(0)" class="add-element"><i class="fa fa-plus"></i></a>';
		$html .=			'</div>';
		$html .=		'</div>';
		$html .=	'</div>';
		
		$html .=	'<input id="'.$this->id.'" type="hidden" name="'.$this->name.'" class="'.$this->class.'" value="'.str_replace('"', '\'', $this->value).'">';

		// Load Google Map script
		if ($google_api_key) {
			$doc->addScript('https://maps.google.com/maps/api/js?key='.$google_api_key, array(), array("async" => "async", "defer"=> "defer"));
		}
		// Elements list modal
		$html .=	'<div class="modal hide fade" id="modal-elements-list" data-backdrop="static" data-keyboard="false" tabindex="-1" role="dialog" aria-labelledby="modal-elements-list-label" aria-hidden="true">';
		$html .=		'<div class="modal-dialog">';
		$html .=			'<div class="modal-content">';
		$html .=				'<div class="modal-header">';
		$html .= 					'<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>';
		$html .=					'<h3 class="modal-title" id="modal-elements-list-label">'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_ELEMENTS_LIST').'</h3>';
		$html .=				'</div>';
		$html .=				'<div class="modal-body">';
		$html .=					'<div class="row-fluid">';
		$html .=						'<div class="span3">';
		$html .=							'<div class="elements-categories">';
		$html .=								'<ul>';
		
		foreach ($elements_category as $key => $element_category) {
			$html .=								'<li ';
			
			if ($key == 0) {
				$html .=								'class="active"';
			}
			$html .=									'data-category="'.str_replace(' ', '_', strtolower($element_category)).'"';
			$html .=								'>';
			$html .=									'<a href="javascript:void(0)">'.ucwords(str_replace('_', ' ', $element_category)).'</a>';
			$html .=								'</li>';
		}
		$html .=								'</ul>';
		$html .= 							'</div>';
		$html .=							'<input class="elements-filter" name="elements_filter" type="text" placeholder="'.JText::_('MOD_RSPAGEBUILDER_SEARCH_ELEMENT').'">';
		$html .=						'</div>';
		$html .=						'<div class="span9">';
		$html .=							'<div class="elements-list-wrapper">';
		$html .=								'<ul class="elements">';
		
		foreach ($default_elements as $element) {
			if (!empty($element['options']['title'])) {
				$element_title = RSPageBuilderHelper::escapeHtml($element['options']['title']);
			} else {
				$element_title = RSPageBuilderElementsHelper::elementTypeToTitle($element['type']);
			}
			
			$html .= 								'<li class="'.strtolower($element['category']).' text-center">';
			$html .=									'<a id="'.$element['type'].'" href="javascript:void(0)">';
			$html .= 										'<img class="image-left '.$element['type'].'" src="'.RSPageBuilderHelper::getElementIcon($element['type']).'" alt="'.$element_title.'"/>';
			$html .= 										'<h3 class="element-title">'.$element_title.'</h3>';
			$html .=									'</a>';
			$html .=									'<div class="element-container">';
			$html .=										'<div class="element">';
			$html .= 											'<img class="element-image '.$element['type'].' pull-left" src="'.RSPageBuilderHelper::getElementIcon($element['type']).'" alt="'.$element_title.'"/>';
			$html .=											'<h3 class="element-title">'.$element_title.'</h3>';
			$html .=											'<h4 class="element-type" data-type="'.$element['type'].'">'.$element_title.'</h4>';
			$html .=											'<div class="element-actions">';
			$html .= 												'<a class="edit-element hasTooltip" href="javascript:void(0)" data-rel="tooltip" data-title="'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_EDIT_ELEMENT').'"><i class="fa fa-pencil"></i></a>';
			$html .= 												'<a class="view-element-html hasTooltip" href="javascript:void(0)" data-rel="tooltip" data-title="'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_VIEW_ELEMENT_HTML').'"><i class="fa fa-file-code-o"></i></a>';
			$html .= 												'<a class="duplicate-element hasTooltip" href="javascript:void(0)" data-rel="tooltip" data-title="'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_DUPLICATE_ELEMENT').'"><i class="fa fa-files-o"></i></a>';
			$html .= 												'<a class="remove-element hasTooltip" href="javascript:void(0)" data-rel="tooltip" data-title="'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_REMOVE_ELEMENT').'"><i class="fa fa-times"></i></a>';
			$html .=											'</div>';
			$html .=											'<div class="element-options hidden">';
			$html .=											'</div>';
			$html .=											'<input class="element-json" type="hidden" value="'.RSPageBuilderElementsHelper::escape(json_encode($element)).'">';
			$html .=										'</div>';
			$html .=									'</div>';
			$html .= 								'</li>';
		}
		foreach ($my_elements as $element) {
			if (!empty($element['options']['title'])) {
				$element_title = RSPageBuilderHelper::escapeHtml($element['options']['title']);
			} else if (!empty($element['options']['text'])) {
				$element_title = RSPageBuilderHelper::escapeHtml($element['options']['text']);
			} else {
				$element_title = RSPageBuilderElementsHelper::elementTypeToTitle($element['type']);
			}
			$element_subtitle = RSPageBuilderElementsHelper::elementTypeToTitle($element['type']);
			
			$html .= 								'<li class="'.strtolower($element['category']).' text-center">';
			$html .=									'<a id="'.$element['type'].'" href="javascript:void(0)">';
			$html .= 										'<img class="image-left '.$element['type'].'" src="'.RSPageBuilderHelper::getElementIcon($element['type']).'" alt="'.$element_title.'"/>';
			$html .= 										'<h3 class="element-title">'.$element_title.'</h3>';
			
			if ($element_title != $element_subtitle) {
				$html .= 									'<h4 class="element-subtitle">('.$element_subtitle.')</h4>';
			}
			$html .=									'</a>';
			$html .=									'<div class="element-container">';
			$html .=										'<div class="element">';
			$html .= 											'<img class="element-image '.$element['type'].' pull-left" src="'.RSPageBuilderHelper::getElementIcon($element['type']).'" alt="'.$element_title.'"/>';
			$html .=											'<h3 class="element-title">'.$element_title.'</h3>';
			$html .=											'<h4 class="element-type" data-type="'.$element['type'].'">'.$element_title.'</h4>';
			$html .=											'<div class="element-actions">';
			$html .= 												'<a class="edit-element hasTooltip" href="javascript:void(0)" data-rel="tooltip" data-title="'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_EDIT_ELEMENT').'"><i class="fa fa-pencil"></i></a>';
			$html .= 												'<a class="view-element-html hasTooltip" href="javascript:void(0)" data-rel="tooltip" data-title="'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_VIEW_ELEMENT_HTML').'"><i class="fa fa-file-code-o"></i></a>';
			$html .= 												'<a class="duplicate-element hasTooltip" href="javascript:void(0)" data-rel="tooltip" data-title="'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_DUPLICATE_ELEMENT').'"><i class="fa fa-files-o"></i></a>';
			$html .= 												'<a class="remove-element hasTooltip" href="javascript:void(0)" data-rel="tooltip" data-title="'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_REMOVE_ELEMENT').'"><i class="fa fa-times"></i></a>';
			$html .=											'</div>';
			$html .=											'<div class="element-options hidden">';
			$html .=											'</div>';
			$html .=											'<input class="element-json" type="hidden" value="'.RSPageBuilderElementsHelper::escape(json_encode($element)).'">';
			$html .=										'</div>';
			$html .=									'</div>';
			$html .= 								'</li>';
		}
		$html .=								'</ul>';
		$html .=							'</div>';
		$html .=						'</div>';
		$html .=					'</div>';
		$html .=				'</div>';
		$html .=			'</div>';
		$html .=		'</div>';
		$html .= 	'</div>';
		
		// Element settings modal
		$html .= 	'<div class="modal hide fade" id="modal-element-settings" data-backdrop="static" data-keyboard="false" tabindex="-1" role="dialog" aria-labelledby="modal-element-settings-label" aria-hidden="true">';
		$html .=		'<div class="modal-dialog">';
		$html .=			'<div class="modal-content">';
		$html .=				'<div class="modal-header">';
		$html .=					'<button type="button" class="close" id="close-element-settings" data-dismiss="modal" aria-hidden="true">&times;</button>';
		$html .=					'<h3 class="modal-title" id="modal-element-label"></h3>';
		$html .=				'</div>';
		$html .=				'<div class="modal-body">';
		$html .=					'<div class="row-fluid">';
		$html .=						'<div class="span6">';
		$html .= 						'</div>';
		$html .=						'<div class="span6">';
		$html .=							'<div class="element-preview">';
		$html .=							'</div>';
		$html .=						'</div>';
		$html .=					'</div>';
		$html .=					'<div class="loader"></div>';
		$html .=				'</div>';
		$html .=				'<div class="modal-footer clearfix">';
		$html .=					'<a href="javascript:void(0)" class="btn btn-success pull-left" id="save-element-settings">'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_SAVE').'</a>';
		$html .=					'<button class="btn btn-danger pull-left" id="cancel-element-settings" data-dismiss="modal" aria-hidden="true">'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_CANCEL').'</button>';
		$html .=				'</div>';
		$html .=			'</div>';
		$html .=		'</div>';
		$html .=	'</div>';
		
		// Element HTML view modal
		$html .=	'<div class="modal hide fade" id="modal-element-view-html" data-backdrop="static" data-keyboard="false" tabindex="-1" role="dialog" aria-labelledby="modal-preview-label" aria-hidden="true">';
		$html .=		'<div class="modal-dialog">';
		$html .=			'<div class="modal-content">';
		$html .=				'<div class="modal-header">';
		$html .=					'<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>';
		$html .=					'<h3 class="modal-title" id="modal-preview-label"></h3>';
		$html .=				'</div>';
		$html .=				'<div class="modal-body"><textarea onclick="this.focus();this.select()" readonly="readonly"></textarea></div>';
		$html .=				'<div class="modal-footer clearfix">';
		$html .=					'<button class="btn btn-danger pull-left" data-dismiss="modal" aria-hidden="true">'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_CLOSE').'</button>';
		$html .=				'</div>';
		$html .=			'</div>';
		$html .=		'</div>';
		$html .=	'</div>';
		
		// Upload image modal
		$html .=	'<div class="modal hide fade" id="modal-upload-image" data-backdrop="static" data-keyboard="false" tabindex="-1" role="dialog" aria-labelledby="modal-preview-label" aria-hidden="true">';
		$html .=		'<div class="modal-dialog">';
		$html .=			'<div class="modal-content">';
		$html .=				'<div class="modal-header">';
		$html .=					'<button type="button" class="close" aria-hidden="true">&times;</button>';
		$html .=					'<h3>'.JText::_('JLIB_FORM_CHANGE_IMAGE').'</h3>';
		$html .=				'</div>';
		$html .=				'<div class="modal-body"></div>';
		$html .=				'<div class="modal-footer">';
		$html .=					'<button class="btn btn-danger media-close">'.JText::_('MOD_RSPAGEBUILDER_ELEMENTS_CLOSE').'</button>';
		$html .=				'</div>';
		$html .=			'</div>';
		$html .=		'</div>';
		$html .=	'</div>';
		
		$html .= '</div>';
		
		return $html;
	}
}