<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die;

class RSTroneHelper {
	/**
	 * @param            $id
	 * @param bool|false $title
	 *
	 * @return array
	 */
	public static function getTemplateParams($id, $title = false) {
		JTable::addIncludePath(JPATH_ADMINISTRATOR . '/components/com_templates/tables');
		$table		= JTable::getInstance('Style', 'TemplatesTable', array());
		$table->load($id);
		$registry	= new JRegistry;
		$params		= $registry->loadString($table->params)->toArray();

		if ($title) {
			return $table->title;
		}

		return $params;
	}

	/**
	 * Get template type
	 *
	 * @return string
	 */
	public static function getTemplateType($id) {
		JTable::addIncludePath(JPATH_ADMINISTRATOR . '/components/com_templates/tables');
		$table = JTable::getInstance('Style', 'TemplatesTable', array());
		$table->load($id);

		return $table->template;
	}

	/**
	 * Get default front end template
	 *
	 * @return string
	 */
	public static function getDefaultSiteTemplate() {
		$db 	= JFactory::getDBO();
		$query 	= $db->getQuery(true);

		$query->select($db->qn('template'))
			->from($db->qn('#__template_styles'))
			->where($db->qn('client_id') . ' = 0 AND ' . $db->qn('home') . ' = 1');

		$db->setQuery($query);
		$default_template = $db->loadResult();
		
		return $default_template;
	}

	/**
	 * Grabs the pre-defined themes from the themes file
	 *
	 * @return mixed|string
	 */
	public static function getThemes() {
		$themes = file_get_contents(JPATH_SITE . '/templates/rstrone/css/themes/themes.json');
		$themes = json_decode($themes);

		return $themes;
	}
}