<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('JPATH_PLATFORM') or die;
JFormHelper::loadFieldClass('list');

/**
 * Extends Joomla! form fields, adds a styled select element
 */
class JFormFieldDroplist extends JFormFieldList
{
	/**
	 * @var string
	 */
	protected $type = 'Droplist';

	/**
	 * Rendering the field
	 * @method getInput
	 *
	 * @return string
	 */
	protected function getInput()
	{
		$document = JFactory::getDocument();
		$document->addStyleSheet(JUri::root(true) . '/templates/rstrone/classes/fields/css/droplist_preloader_types.css');
		$document->addStyleSheet(JUri::root(true) . '/templates/rstrone/classes/fields/css/droplist_preloader_effects.css');
		$document->addScript(JUri::root(true) . '/templates/rstrone/classes/fields/js/droplist.js');
		$document->addScriptDeclaration('
	jQuery(document).ready(function ($) {
		$(\'#' . $this->id . '\').ddslick({
			onSelected: function(data) {
				if ($(document.getElementsByName(\'' . $this->name . '\')).length == 0) {
					$(\'#' . $this->id . '\').append(\'<input type="hidden" name="' . $this->name . '" />\');
				}
				$(document.getElementsByName(\'' . $this->name . '\')[0]).val(data.selectedData.value);
			}
		});
		$(\'#' . $this->id . ' .dd-option\').hover(function() {
			$(this).children(\':last\').addClass(\'custom-tooltip\');
			$(this).children(\':last\').offset({ top: $(this).offset().top - 15, left: $(this).offset().left + 50 });
		}, function() {
			$(this).children(\':last\').removeClass(\'custom-tooltip\');
		});
		// If chosen is loaded, destroy it.
		$(\'#' . $this->id . '_chzn\').remove();
	});
	');

		return parent::getInput();
	}

}
