/*
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

jQuery.noConflict();

/**
 *
 * @param sample_type
 * @param force
 */
function installSampleData(sample_type, force) {
	
	sample_type = jQuery('select[name="sample_type"]').val();
	
    if (sample_type == 'data-rsmg') {

        variables = {
            check: "extension", sample_type: sample_type, extensions: [
                "com_rsmediagallery",
            	"com_rspagebuilder",
				"com_k2",
                "mod_rsmediagallery_responsive_slider",
                "mod_rsmediagallery_showcase",
				"mod_rspagebuilder_elements",
				"mod_rspagebuilder_search",
                "mod_rscontact",
				"jw_sig",
				"jw_allvideos"
            ]
        };
        $warning = jQuery('#install-response.alert-warning');

        if ($warning.length) {
            $warning.css('display', 'none');
        }
	} else if (sample_type == 'data-no-rsmg') {
        variables = {
            check: "extension", sample_type: sample_type, extensions: [
            	"com_rspagebuilder",
				"com_k2",
				"mod_rspagebuilder_elements",
				"mod_rspagebuilder_search",
                "mod_rscontact",
				"jw_sig",
				"jw_allvideos"
            ]
        };
        $warning = jQuery('#install-response.alert-warning');

        if ($warning.length) {
            $warning.css('display', 'none');
        }
	}
	else if (sample_type == undefined) {
		variables = {check: 'none', sample_type: ''};
	}

	if (force) {
		variables = {check: 'none', sample_type: sample_type};
	}

	jQuery.ajax({
		type      : "POST",
		url       : "../templates/rstrone/classes/installer.php",
		data      : variables,
		beforeSend: function () {
			jQuery('#rs-installer').find('i').removeClass('icon-next').addClass('rstpl-rotating icon-refresh');
			$response = jQuery('#install-response');
		},
		success   : function (msg) {
			jQuery('#data-loading').hide();
			var response = jQuery.parseJSON(msg);
			
			if (response.success) {
				$response.empty();
				$response.css('display', 'block').removeAttr('class').addClass('alert alert-success');
				$response.append(response.success);
				jQuery('#rs-installer').find('i').removeAttr('class').addClass('icon-ok');
				location.reload();
			} else if (response.warning) {
				$response.empty();
				$response.css('display', 'block').removeAttr('class').addClass('alert alert-warning');
				$response.append(response.warning);
				jQuery('#rs-installer').find('i').removeAttr('class').addClass('icon-next');
			} else {
				$response.empty();
				$response.css('display', 'block').removeAttr('class').addClass('alert alert-error');
				$response.append(response.error);
				jQuery('#rs-installer').find('i').removeAttr('class').addClass('icon-not-ok');
			}
		}
	});
}
