/*
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

'use strict';
// Define variables that will be used across the scripts
var element,
	elements = [],
	siblings,
	/**
	 * Size Calculation Variables
	 */
	closestSpanClass,
	total,
	newSpans = {},
	thisSize,
	spans = {
		'span1' : 8,
		'span2' : 16,
		'span3' : 24,
		'span4' : 32,
		'span5' : 40,
		'span6' : 48,
		'span7' : 58,
		'span8' : 66,
		'span9' : 74,
		'span10': 82,
		'span11': 91,
		'span12': 100
	},
	/**
	 * Row Setting Variable
	 */
	fullwidth,
	rclass,

	/**
	 * Column Settings
	 */
	temp,
	key,
	col,
	action,
	object,

	/**
	 * Variables that take care of the JSOn and it's settings
	 */
	select,
	json,
	$id,
	values,
	positions,

	/**
	 * Misc Variable
	 */
	window_w;


jQuery(document).ready(function () {
	// Initialize sortable
	jQuery('.removed-fields').sortable({
		connectWith: "#rs_sortable",
		receive    : function (event, ui) {
			element = ui.item;
			$id = element.attr('data_item');
			element.append('<span id="' + $id + '">' + $id + '</span>');
			var elements = [];
			jQuery('.removed-fields li').each(function (index, elem) {
				var rs_pos = jQuery(elem).attr('data_item');
				elements.push(rs_pos);
			});
			var serialize_elem = elements.join();
			jQuery('#jform_params_removed_positions').val(serialize_elem);

		},
		remove     : function (event, ui) {
			element = ui.item;
			$id = element.attr('data_item');
			element.find('#' + $id).remove();
			var elements = [];
			jQuery('.removed-fields li').each(function (index, elem) {
				var rs_pos = jQuery(elem).attr('data_item');
				elements.push(rs_pos);
			});
			var serialize_elem = elements.join();
			jQuery('#jform_params_removed_positions').val(serialize_elem);
		}
	});
	jQuery("#rs_sortable").sortable({
		handle     : ".handle",
		scroll     : false,
		connectWith: ".removed-fields",
		receive    : function (event, ui) {
			var elements = [];
			jQuery('#rs_sortable li.sortable-row').each(function (index, elem) {
				var rs_pos = jQuery(elem).attr('data_item');
				elements.push(rs_pos);
			});
			var serialize_elem = elements.join();
			jQuery('#jform_params_defined_positions').val(serialize_elem);

		},
		stop       : function (event, ui) {
			var elements = [];
			jQuery('#rs_sortable li.sortable-row').each(function (index, elem) {
				var rs_pos = jQuery(elem).attr('data_item');
				elements.push(rs_pos);
			});
			var serialize_elem = elements.join();

			jQuery('#jform_params_defined_positions').val(serialize_elem);
		}
	});
	jQuery(".sortable-cols").sortable({
		axis       : 'x',
		placeholder: "sortable-placeholder",
		cursor     : 'move',
		handle     : '.col-handle',
		cursorAt   : {left: 0, top: 0},
		stop       : function (event, ui) {
			/**
			 * Grab the element that is being sorted along with the key and its siblings
			 */
			element = ui.item;
			key = element.parent().parent().attr('data_item');
			siblings = jQuery('.' + key + ' .col');

			/**
			 * Grab the already known JSON
			 */
			json = jQuery.parseJSON(jQuery('#jform_params_defined_row_settings').val());

			/**
			 * We create a temporary object so we can save the new "ordering"
			 * @type {Object}
			 */
			temp = {};

			siblings.each(function () {
				// We get a reference to the column
				col = jQuery(this).attr('data_col');
				// and start building the object
				temp[col] = {};
				// add its size
				temp[col].size = jQuery(this).attr('data_computed');
				// and the animation that is currently stored in the json
				temp[col].an = json[key].cols[col].an;
				temp[col].wg = json[key].cols[col].wg;
			});

			/**
			 * Rewrite the object
			 * @type {Object}
			 */
			json[key].cols = temp;

			/**
			 * Add it to the JSON
			 */
			jQuery('#jform_params_defined_row_settings').val(JSON.stringify(json));
		}
	});

	var step = (jQuery('.rs_inner-sortable').width() - 60) / 12;

	/**
	 * Initiate resizable
	 */
	jQuery(".resizable > .col").resizable({
		handles: 'e',
		grid   : [step, 0],
		helper : 'resizable-helper'
	});

	/**
	 * Disable selection so it can be dragged
	 */
	jQuery("#rs_sortable, #rs_sortable li").disableSelection();

	/**
	 * Get the Window's width
	 */
	window_w = jQuery(window).width();

	/**
	 * Disable resizable if it's a tablet viewport
	 */
	if (window_w < 768) {
		jQuery(".resizable > .col").resizable('disable');
	}

	/**
	 * Handle the screen resize, enable/disable the plugin
	 */
	jQuery(window).resize(function () {
		window_w = jQuery(window).width();
		if (window_w < 768) {
			jQuery(".resizable > .col").resizable('disable');
		} else if (window_w > 768) {
			step = (jQuery('.rs_inner-sortable').width() - 70) / 12;
			jQuery(".resizable > .col").resizable('enable');
			jQuery(".resizable > .col").resizable("option", "grid", [step, 10]);
		}
	});

	/**
	 * We invert spans so we can grab the OBJECT KEY through its value
	 */
	jQuery.each(spans, function (key, value) {
		newSpans[value] = key;
	});

	var resize = jQuery(".resizable > .col").on("resize", function (event, ui) {
		element = ui.originalElement;
		siblings = element.siblings('.col:not([data_computed="rem"])');

		closestSpanClass = newSpans[RSTemplateUtils.closestSpan(spans, ui.size.width / jQuery(this).parent().outerWidth() * 100)];
		/**
		 * Get the "span" of the current element
		 * @type {Number}
		 */
		thisSize = parseInt(closestSpanClass.substr(4));

		/**
		 * And calculate the sum of the spans
		 * @type {number}
		 */
		total = 0;
		siblings.each(function () {
			total += parseInt(jQuery(this).attr('data_computed').substr(4));
		});
		total += thisSize;

		/**
		 * Depending on the result we change closestSpanClass so that the total of the spans does not go over 12
		 */
		if (total > 12) {
			//jQuery( ".resizable > .col" ).resizable( "option", "maxWidth", ui.size.width );
			jQuery(document).trigger("mouseup");
		}
	});

	var start = jQuery(".resizable > .col").on("resizestart", function (event, ui) {

		element = ui.originalElement;
		siblings = element.siblings('.col:not([data_computed="rem"])');
		closestSpanClass = newSpans[RSTemplateUtils.closestSpan(spans, element.percWidth())];
		/**
		 * Get the "span" of the current element
		 * @type {Number}
		 */
		thisSize = parseInt(closestSpanClass.substr(4));

		/**
		 * And calculate the sum of the spans
		 * @type {number}
		 */
		total = 0;
		siblings.each(function () {
			total += parseInt(jQuery(this).attr('data_computed').substr(4));
		});
		total += thisSize;

		/**
		 * Depending on the result we change closestSpanClass so that the total of the spans does not go over 12
		 */
		if (total == 12) {
			jQuery(".resizable > .col").resizable("option", "maxWidth", jQuery(this).outerWidth());
		}

	});

	/**
	 * Handle the resize end event, saving the new sizes
	 */
	var end = jQuery(".resizable > .col").on("resizestop", function (event, ui) {
		/**
		 * Get a ref. to the element that is being resized and its siblings
		 */
		element = ui.originalElement;
		siblings = element.siblings('.col:not([data_computed="rem"])');

		/**
		 * Calculate what's the closestSpan bootstrap class of the element that is being resized
		 */
		closestSpanClass = newSpans[RSTemplateUtils.closestSpan(spans, element.percWidth())];

		/**
		 * Get the "span" of the current element
		 * @type {Number}
		 */
		thisSize = parseInt(closestSpanClass.substr(4));

		/**
		 * And calculate the sum of the spans
		 * @type {number}
		 */
		total = 0;
		siblings.each(function () {
			total += parseInt(jQuery(this).attr('data_computed').substr(4));
		});
		total += thisSize;

		/**
		 * Depending on the result we change closestSpanClass so that the total of the spans does not go over 12
		 */
		if (total > 12) {
			closestSpanClass = 'span' + (thisSize - (total - 12));
		}

		/**
		 * Remove the inline styles added by the plugin
		 * along with the applied bootstrap class and add the new class
		 */
		element.removeAttr('style').removeClass('span1 span2 span3 span4 span5 span6 span7 span8 span9 span10 span11 span12').addClass(closestSpanClass);

		/**
		 * Change the data_computed attr to the new class for easier calculation
		 */
		element.attr('data_computed', closestSpanClass);

		/**
		 * Start building the object by grabbing the key (e.g. TOP)
		 */
		key = element.parent().parent().attr('data_item');
		/**
		 * And the actual Column (e.g. TOP-A)
		 */
		col = element.attr('data_col');

		/**
		 * And store the new object
		 */

		var args = {
			'action': 'resize',
			'size'  : closestSpanClass
		};

		RSTemplateUtils.storeData(key, col, args);
		jQuery(".resizable > .col").resizable("option", "maxWidth", null);
	});

	/**
	 * Initiate the buttons of the script
	 * Row Setting Event
	 */
	jQuery('.customization-row, .customization-col').click(function () {

		if (jQuery(this).hasClass('customization-col')) {
			/**
			 * Upon clicking we grab the row's name and column name
			 * send them to hidden fields in the modal and change
			 * the header of the modal
			 */
			col = jQuery(this).parent().attr('data_col');
			key = jQuery(this).parent().parent().parent().attr('data_item');

			jQuery('#colSettings').find('input[id="col"]').val(col);
			jQuery('#colSettings').find('input[id="key"]').val(key);
			jQuery('#colSettingsLabel').html("Editing the " + col.toUpperCase() + " position");

			/**
			 * Auto-select the default value in the select
			 */
			RSTemplateUtils.populateValue(key, col);
		} else {
			/**
			 * Upon clicking we grab the row's name send it to a
			 * hidden field in the modal    and change the header of the modal
			 */
			key = jQuery(this).attr('data_key');
			jQuery('#rowSettings').find('input[type="hidden"]').val(key);
			jQuery('#rowSettingsLabel').html("Editing the " + key.toUpperCase() + " position");

			/**
			 * populate the fields with the values from the JSON object
			 */
			RSTemplateUtils.populateValue(key);
		}

	});

	/**
	 * Modal Buttons
	 * Save Button
	 */
	jQuery('.saveObject').click(function () {
		/**
		 * upon clicking, call the function to store the object
		 */
		var action = jQuery(this).attr('data_obj');

		if (action == 'row') {
			RSTemplateUtils.storeValue();
		} else {
			key = jQuery('#colSettings').find('input[id="key"]').val();
			col = jQuery('#colSettings').find('input[id="col"]').val();
			select = jQuery('#colSettings').find('select');

			var args = {};

			select.each(function () {
				var field = jQuery(this).attr('id');
				args['action'] = 'colOption';
				if (field == 'wg') {
					if (jQuery(this).val() != null) {
						args['widget'] = jQuery(this).val().toString();
					} else {
						args['widget'] = 0;
					}
				} else {
					args['animation'] = jQuery(this).val();
				}
			});

			RSTemplateUtils.storeData(key, col, args);
		}
		/**
		 * Hide the modal
		 */
		jQuery('#rowSettings, #colSettings').modal('hide');
		jQuery('#rowSettings').find('.minicolors-swatch > span').removeAttr('style');
	});

	/**
	 *  Clear Button
	 */
	jQuery('.clearObject').click(function () {
		/**
		 * clicking the button will grab the input fields / checkbox and clear their values
		 */
		jQuery('#rowSettings').find('input[type="text"]').not(':input[type="hidden"]').val('');
		jQuery('#rowSettings').find('input[type="checkbox"]').prop('checked', false);

		/**
		 * save the data
		 */
		RSTemplateUtils.storeValue();

		/**
		 *  hide the modal
		 */
		jQuery('#rowSettings, #colSettings').modal('hide');
		jQuery('#rowSettings').find('.minicolors-swatch > span').removeAttr('style');
	});

	/**
	 * Column Buttons
	 */
	jQuery('.columnOption').click(function () {
		/**
		 * Check what action is triggered
		 */
		action = jQuery(this).attr('data_action');
		key = jQuery(this).attr('data_key');

		/**
		 * Handle event
		 */
		if (action == 'remove' && jQuery('.' + key).find('.col:not([data_computed="rem"])').length > 1) {
			/**
			 * Remove column
			 */
			RSTemplateUtils.removeColumn(key);
		} else if (action == 'add') {
			/**
			 * Add column
			 */
			RSTemplateUtils.addColumn(key);
		} else if (action == 'equalize') {
			/**
			 * Equalize columns
			 */
			RSTemplateUtils.equalizeColumns(key);
		}
	});

	/**
	 * Button to revert to default
	 */
	jQuery('#rwJSON').click(function () {
		RSTemplateUtils.resetToDefaultSettings();
	});

	/**
	 * We hide the add/remove buttons on document ready
	 */
	jQuery('[data_action="add"], [data_action="remove"]').css('display', 'none');

	var resizableRows = jQuery('.sortable-row');
	resizableRows.each(function () {
		/**
		 * And depending on how many removed columns each row has we show the button
		 */
		var hasRem = jQuery(this).find('[data_computed="rem"]');
		if (hasRem.length >= 1 && hasRem.length <= 3) {
			jQuery(this).find('[data_action="add"]').show();
		}

		if (hasRem.length < 3) {
			jQuery(this).find('[data_action="remove"]').show();
		}
	});

	positions = jQuery('.col');
	positions.each(function () {
		if (jQuery(this).find('.has-module').length) {
			jQuery(this).addClass('not-empty-module');
		}

		if (jQuery(this).find('.has-widget').length) {
			jQuery(this).addClass('widget-module')
		}
	});
});

var RSTemplateUtils = {
	/**
	 * Function that equalizes the columns in a row (key)
	 * @param key
	 */
	equalizeColumns: function (key) {
		var cols = jQuery('.' + key).find('.col:not([data_computed="rem"])');
		cols.each(function (index) {
			col = jQuery(this).attr('data_col');
			jQuery(this).removeClass('span1 span2 span3 span4 span5 span6 span7 span8 span9 span10 span11 span12').addClass('span' + (12 / cols.length));
			jQuery(this).attr('data_computed', 'span' + (12 / cols.length));

			var args = {
				'action': 'resize',
				'size'  : 'span' + (12 / cols.length)
			};

			RSTemplateUtils.storeData(key, col, args);
		});
	},

	/**
	 * Function to remove the last column of the row (key)
	 * @param key
	 */
	removeColumn: function (key) {
		/**
		 * Get the last element
		 */
		if (key == 'all-content') {
			element = jQuery('.' + key).find('.col:not([data_col="content"]):not([data_computed="rem"])').slice(-1);
		} else {
			element = jQuery('.' + key).find('.col:not([data_computed="rem"])').slice(-1);
		}

		siblings = jQuery('.' + key).find('.col:not([data_computed="rem"])');
		/**
		 * The actual column name
		 */
		col = element.attr('data_col');

		/**
		 * Change the "data_computed" so we do not calculate it later
		 */
		element.attr('data_computed', 'rem');

		/**
		 * Remove the bootstrap class and hide it
		 */
		element.removeClass('span1 span2 span3 span4 span5 span6 span7 span8 span9 span10 span11 span12').css('display', 'none');

		/**
		 * Store the new options
		 */

		var args = {
			'action': 'resize',
			'size'  : 'rem'
		};

		RSTemplateUtils.storeData(key, col, args);
		if (siblings.length <= 4 && siblings.length > 2) {
			jQuery('.' + key).find('[data_action="add"]').show('fast');
		} else {
			jQuery('.' + key).find('[data_action="remove"]').hide('fast');
		}

	},

	/**
	 * Function to add a column to the row (key)
	 * @param key
	 * @returns {mixed}
	 */
	addColumn: function (key) {
		/**
		 * Get the first element that is hidden
		 */
		element = jQuery('.' + key).find('.col[data_computed="rem"]').first();

		if (element.length) {
			/**
			 * And its siblings
			 */
			siblings = jQuery('.' + key).find('.col:not([data_computed="rem"])');
			col = element.attr('data_col');

			/**
			 * Calculate the spans so we can insert this column with the maximum size
			 * @type {number}
			 */
			total = 0;
			siblings.each(function () {
				total += parseInt(jQuery(this).attr('data_computed').substr(4));
			});

			/**
			 * Calculate the available size
			 * @type {number}
			 */
			var available = 12 - total;

			/**
			 * If there is not enough space we will resize the last element
			 */
			if (available === 0) {
				/**
				 * Grab it by selecting the FIRST column that is not span1
				 */
				var resizeElem = element.siblings('.col:not([data_computed="span1"])').first();
				var resizeElemSize = parseInt(resizeElem.attr('data_computed').substr(4));

				/**
				 * Resize it and insert another col
				 */
				resizeElem.removeClass('span' + resizeElemSize).attr('data_computed', 'span' + (resizeElemSize - 1)).addClass('span' + (resizeElemSize - 1));
				element.attr('data_computed', 'span1').addClass('span1').css('display', 'block');

				/**
				 * Store the affected columns in the JSON
				 */

				var rArgs = {
					'action': 'resize',
					'size'  : 'span' + (resizeElemSize - 1)
				};

				RSTemplateUtils.storeData(key, resizeElem.attr('data_col'), rArgs);

				var args = {
					'action': 'resize',
					'size'  : 'span1'
				};

				RSTemplateUtils.storeData(key, col, args);

			} else {
				// If there is enough room, we add it with the max size
				element.attr('data_computed', 'span' + available).addClass('span' + available).css('display', 'block');

				var args = {
					'action': 'resize',
					'size'  : 'span' + available
				};

				RSTemplateUtils.storeData(key, col, args);
			}

			/**
			 * Handle button visibility
			 */
			if (siblings.length >= 3) {
				jQuery('.' + key).find('[data_action="add"]').hide('fast');
			} else {
				jQuery('.' + key).find('[data_action="remove"]').show('fast');
			}

			if (key == 'all-content' && siblings.length >= 2) {
				jQuery('.' + key).find('[data_action="add"]').hide('fast');
			} else {
				jQuery('.' + key).find('[data_action="remove"]').show('fast');
			}

		} else {
			/**
			 * If there is no element we return true
			 */
			return true;
		}
	},

	/**
	 * Function to store the new options for the column
	 *
	 * @param key
	 * @param column
	 * @param args
	 */
	storeData: function (key, column, args) {
		json = jQuery.parseJSON(jQuery('#jform_params_defined_row_settings').val());

		switch (args.action) {
			case 'resize':
				json[key].cols[column].size = args.size;
				break;
			case 'colOption':
				json[key].cols[column].wg = args.widget;
				json[key].cols[column].an = args.animation;
				break;
		}

		jQuery('#jform_params_defined_row_settings').val(JSON.stringify(json));
	},

	/**
	 *  Function to store the row settings (from the modal window)
	 */
	storeValue: function () {
		/**
		 * Get the JSON
		 */
		json = jQuery.parseJSON(jQuery('#jform_params_defined_row_settings').val());

		/**
		 * Get the key from the hidden field that we sent earlier
		 */
		key = jQuery('#rowSettings').find('input[type="hidden"]').val();

		/**
		 * Grab the settings
		 */
		values 	  	= jQuery('#rowSettings').find('input[type="text"]').not(':input[type="hidden"]').not(':input[name="cls"]');
		fullwidth	= jQuery('#rowSettings').find('input[type="checkbox"]').is(':checked');
		rclass		= jQuery('#rowSettings').find('input[name="cls"]');
		
		/**
		 * Build the object
		 * @type {object}
		 */
		json[key].css = {};

		/**
		 * Send the values to the object
		 */
		values.each(function () {
			json[key].css[this.name] = this.value;
		});

		/**
		 * Depending on the checkbox, set the setting to fullwidth false/true
		 */
		if (fullwidth) {
			json[key].general.fw = 1;
		} else {
			json[key].general.fw = 0;
		}

		/**
		 * Send the row class to the object
		 */
		json[key].general.cls = rclass.val();
		
		/**
		 * Save the new settings
		 */
		jQuery('#jform_params_defined_row_settings').val(JSON.stringify(json));
	},

	/**
	 * Function to populate the values in the modal window
	 * @param key
	 * @param col
	 */
	populateValue: function (key, col) {
		/**
		 * Get the JSON
		 */
		json = jQuery.parseJSON(jQuery('#jform_params_defined_row_settings').val());
		json = json[key];

		if (!col) {
			/**
			 * Grab CSS input fields
			 */
			values = jQuery('#rowSettings').find('input[type="text"]').not(':input[type="hidden"]').not(':input[name="cls"]');

			/**
			 * Populate CSS input fields with the values from the JSON
			 */
			values.each(function () {
				this.value = json.css[this.name];
			});

			/**
			 * Populate CSS class input field
			 */
			jQuery('#rowSettings').find('input[name="cls"]').val(json.general.cls);
			
			/**
			 * Check / Uncheck the checkbox
			 */
			if (json.general.fw) {
				jQuery('#rowSettings').find('input[type="checkbox"]').prop('checked', true);
			}
			if (json.css.bg-color) {
				jQuery('#rowSettings').find('.minicolors-swatch > span').css('background-color', json.css.bg-color)
			}
		} else {
			jQuery('#colSettings').find('select').each(function () {
				var field = jQuery(this).attr('id');
				if (jQuery(this).attr('multiple') == 'multiple') {
					try {
						if (json.cols[col][field] != 0) {
							var vals = json.cols[col][field].split(',');
						}
					} catch (error) {
						console.log(error);
					}
					jQuery(this).val(vals);
				} else {
					jQuery(this).val(json.cols[col][field]);
				}
				jQuery(this).trigger("liszt:updated");
			})
		}
	},

	/**
	 * Function to find the closest bootstrap class
	 * @param array
	 * @param num
	 * @returns {Number}
	 */
	closestSpan           : function (array, num) {
		var i = 0,
			minDiff = 1000,
			span;
		for (i in array) {
			var m = Math.abs(num - array[i]);
			if (m < minDiff) {
				minDiff = m;
				span = array[i];
			}
		}
		return span;
	},
	/**
	 * In case the JSON gets broken, restore it to the default settings
	 */
	resetToDefaultSettings: function () {
		jQuery('#jform_params_defined_row_settings').val('');
		Joomla.submitbutton('style.apply')
	}
};

/**
 * Function that resets the value of the json to default
 */
function rsResetPositions() {
	/**
	 * Define the variables
	 */
	var $default = jQuery('#jform_params_default_positions'),
		$default_array = $default.val().split(','),
		$defined = jQuery('#jform_params_defined_positions'),
		$defined_array = $defined.val().split(','),
		$removed = jQuery('#jform_params_removed_positions'),
		$removed_array = $removed.val().split(','),
		$extra,
		$removed_val = function (arr) {
			return arr.join(',');
		};

	/**
	 * Compare the two arrays and grab what we need to move in the "REMOVED LIST"
	 */
	if ($defined_array.length > $default_array.length) {
		$extra = $defined_array.diff($default_array);

		jQuery.each($extra, function ($index, $element) {
			var $toberemoved = jQuery('[data_item="' + $element + '"]');

			$toberemoved.append('<span id="' + $element + '">' + $element + '</span>');
			$toberemoved.detach().appendTo('.removed-fields');
		});

		$removed_array = $removed_array.concat($extra);

	}

	$defined.val($default.val());
	$removed.val($removed_val($removed_array));

	//set the first element
	jQuery('[data_item="' + $default_array[0] + '"]').parent().prepend(jQuery('[data_item="' + $default_array[0] + '"]'));
	for (var i = 1; i < $default_array.length; i++) {
		jQuery('[data_item="' + $default_array[i] + '"]').insertAfter(jQuery('[data_item="' + $default_array[i - 1] + '"]'));
	}

}

Array.prototype.diff = function (a) {
	return this.filter(function (i) {
		return a.indexOf(i) < 0;
	});
};
