/*
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

jQuery(document).ready(function ($) {

	var controlGroups = $("#attrib-logo_options").find('.control-group');

	// Split the control groups so we can hide/show depending on the selection
	controlGroups.slice(0, 5).wrapAll("<div class='menu-options'></div>").end();
	controlGroups.slice(5, 10).wrapAll("<div class='general-logo_options'></div>").end();
	controlGroups.slice(10, 15).wrapAll("<div class='text-logo_options'></div>").end();
	controlGroups.slice(15, 18).wrapAll("<div class='image-logo_options'></div>").end();

	// Show options for text or image
	var logoAppearance = $('#jform_params_logo_appearance').find('input:radio');

	if (logoAppearance.filter(':checked').attr('id') == 'jform_params_logo_appearance0') {
		$('.image-logo_options').hide('slow');
	} else {
		$('.text-logo_options').hide('slow');
	}

	logoAppearance.click(function () {
		if ($(this).attr('id') == 'jform_params_logo_appearance0') {
			$('.image-logo_options').hide('slow');
			$('.text-logo_options').show('slow');
		} else {
			$('.text-logo_options').hide('slow');
			$('.image-logo_options').show('slow');
		}
	});

	// Carousel Initiator
	jQuery('.owl-carousel').parent().css({"margin-left": "0", "clear": "both"});
	var owl = jQuery('.owl-carousel').owlCarousel({
		margin    : 30,
		nav       : true,
		dots      : false,
		responsive: {
			360: {
				items: 1,
				nav  : false
			},
			768: {
				items: 4,
				nav  : true
			}
		}
	});

	// Trigger the theme changer button
	jQuery('.populateInputs').click(function () {

		var themeJSON = getJSON(rs_base_path + '/css/themes/themes.json');
		var settings = themeJSON[jQuery(this).attr('data-customizer')];

		jQuery.each(settings, function (key, value) {
			jQuery('.' + key).val(value);
			// Update the color picker
			if (jQuery('.' + key).hasClass('minicolors')) {
				jQuery('.' + key).siblings('.minicolors-swatch').find('span').removeAttr('style').css('background-color', value);
			}
			;
			// Update chosen
			if (jQuery('.' + key).next().hasClass('chzn-container')) {
				jQuery('.' + key).trigger("liszt:updated");
			}
			;

		});

		jQuery('#rstpl-style-alert').slideToggle('fast');
		setTimeout(function () {
			jQuery('#rstpl-style-alert').slideToggle('fast');
		}, 4000);
	});

	// Function to retrieve the JSON through AJAX
	function getJSON(url) {
		var xhReq = new XMLHttpRequest();
		xhReq.open("GET", url, false);
		xhReq.send(null);
		var themeJSON = xhReq.response;

		return jQuery.parseJSON(themeJSON);
	};

});
