<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die;

?>
<div class="rs_inner-sortable">
	<!-- Reset Button -->
	<div class="rs-reset">
		<input type="button" class="btn" value="<?php echo JText::_('TPL_RSTEMPLATE_TEMPLATE_POSITIONS_CONFIRM_BUTTON') ?>" onclick="if(confirm('<?php echo JText::_('TPL_RSTEMPLATE_TEMPLATE_POSITIONS_CONFIRM') ?>')) return rsResetPositions()"/>
	</div>
	<!-- End Reset Button -->
	<!-- Template Active Fields -->
	<ul id="rs_sortable" class="ui-sortable ">
		<?php
		if (isset($displayData->positions) && count($displayData->positions) > 0)
		{
			foreach ($displayData->positions as $pos)
			{
				$pos = trim($pos);
				$pos = $this->escape($pos);	?>
				<li class="ui-state-default sortable-row <?php echo $pos ?>" data_item="<?php echo $pos ?>">
					<?php

					$first_layout = array(
						'rowsettings' => $displayData->rowsettings,
						'position'    => $pos
					);

					$second_layout = array(
						'rowsettings' => $displayData->rowsettings,
						'position'    => $pos,
						'activemodules' => $displayData->activemodules
					);

					echo $this->sublayout('rowsettings', (object) $first_layout);
					echo $this->sublayout('position', (object) $second_layout);
					?>
				</li>
			<?php
			}
		}
		?>
	</ul>
	<!-- Removed Fields -->
	<div class="removable-fields">
		<span class="removing-fields"><?php echo JText::_("TPL_RSTEMPLATE_REMOVEDFIELDS") ?></span>
		<ul class="removed-fields">
			<?php
			if ($displayData->removed != '')
			{
				$removed = array_filter(explode(',', $displayData->removed));
				foreach ($removed as $removedRow)
				{
				?>
					<li class="ui-state-default sortable-row <?php echo $removedRow ?>" data_item="<?php echo $removedRow ?>" >
						<?php
						$first_layout = array(
							'rowsettings' => $displayData->rowsettings,
							'position'    => $removedRow
						);

						$second_layout = array(
							'rowsettings' => $displayData->rowsettings,
							'position'    => $removedRow,
							'activemodules' => $displayData->activemodules
						);

						echo $this->sublayout('rowsettings', (object) $first_layout);
						echo $this->sublayout('position', (object) $second_layout);
						?>
						<span id="<?php echo $removedRow ?>"><?php echo $removedRow ?></span>
					</li>
				<?php
				}
			}
			?>
		</ul>
	</div>
	<!-- / Removed Fields -->
</div>
<!-- Modals -->
<?php
echo $this->sublayout('modalrowsettings', (object) array());
echo $this->sublayout('modalcolsettings', (object) array());
?>
<!-- / Modals -->
