<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('JPATH_PLATFORM') or die;
JFormHelper::loadFieldClass('spacer');

/**
 * Extends Joomla! Form Fields, adds a spacer
 */
class JFormFieldRSSpacer extends JFormFieldSpacer
{
	/**
	 * @var string
	 */
	protected $type = 'rsspacer';

	/**
	 * Grabs the form field's label
	 * @method getLabel
	 *
	 * @return string
	 */
	protected function getLabel()
	{
		return;
	}

	/**
	 * Rendering the field
	 * @method getInput
	 *
	 * @return string
	 */
	protected function getInput()
	{
		$text     = $this->element['label'] ? (string) $this->element['label'] : (string) $this->element['name'];
		$document = JFactory::getDocument();
		$document->addScript(JUri::root(true) . '/templates/rstrone/classes/fields/js/rsspacer.js');
		$htmlField = '<h4 id="' . $this->id . '">' . JText::_($text) . '</h4>';

		return $htmlField;
	}

}
