<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('JPATH_PLATFORM') or die;

/**
 * Extends Joomla! Form Field, Provides a sample data installer
 */
class JFormFieldSampledatainstaller extends JFormField
{
	/**
	 * @var string
	 */
	protected $type = 'sampledatainstaller';

	/**
	 * Rendering the field
	 * @method getInput
	 *
	 * @return string
	 */
	protected function getInput()
	{
		$document = JFactory::getDocument();
		$document->addScript(JUri::root(true) . '/templates/rstrone/classes/fields/js/installer.js');
		$document->addStyleDeclaration("
			#rstpl-sampledata-options {
				margin: 0 auto;
				position: relative;
				width: 75%;
			}
			#rstpl-sampledata-options img {
				border: 1px solid #dcdcdc;
				width: 100%;
			}
			.rstpl-sample-option {
				padding: 6%;
				border: 1px solid #dcdcdc;
				border-radius: 0;
				background-color: #f0f0f0;
				position:relative;
			}
			.rstpl-sample-option:hover {
				background-color: #e1efe0;
			}
			.rstpl-sample-option.installed:hover {
				background-color: #f0f0f0;
			}
			.rstpl-sample-option-title {
				margin: 15px 0 0 0;
			}
			#rstpl_rsmg_option_chzn {
				margin: 20px 0;
			}
			#install-response {
				width: 500px;
				margin: 10px auto;
				display: none;
			}
			@media (min-width: 768px) and (max-width: 979px) {
				#rstpl-sampledata-options {
					margin: 0;
					width: 100%;
				}
			}
			@media (max-width: 767px) {
				#rstpl-sampledata-options {
					margin: 0;
					width: 100%;
				}
			}
			"
		);
		$app   = JFactory::getApplication();
		$id    = $app->input->get('id');
		$table = JTable::getInstance('Style', 'TemplatesTable', array());
		
		$table->load($id);
		
		$registry		= new JRegistry;
		$params   		= $registry->loadString($table->params)->toArray();
		$input_status	= '';
		$image_name		= '';
		
		if ($params['installed_sample_data']) {
			$input_status   = ' disabled';
            $image_name     = '_installed';
		}
		
		$return = '<div class="row-fluid" id="rstpl-sampledata-options">
			<div class="span4 offset4 text-center">
			    <label class="rstpl-sample-option' . ($input_status ? ' installed' : '') . '">
				<img src="' . JUri::root(true) . '/templates/rstrone/classes/fields/img/rstrone' . $image_name . '.png"/>
				<h3 class="rstpl-sample-option-title">' . JText::_('TPL_LABEL_RSTRONE_SAMPLE_DATA') . '</h3>
			</div>
		</div>
        <div class="row-fluid" id="rstpl-rsmg-options">
            <div class="span12 text-center">
                <select class="span2" name="sample_type" id="rstpl-rsmg-option"' . $input_status . '>
                    <option value="data-rsmg" selected>' . JText::_('TPL_WITH_RSMEDIAGALLERY') . '</option>
                    <option value="data-no-rsmg">' . JText::_('TPL_WITHOUT_RSMEDIAGALLERY') . '</option>
                </select>
            </div>
        </div>';
		
		if (!$params['installed_sample_data']) {
			$return .= '<div class="clearfix"></div><br>
					<div class="row-fluid text-center">
						<div class="span12">
							<button type="button" id="rs-installer" class="btn btn-primary btn-large" onclick="installSampleData(\'normal\', false)"><i class="icon-next"></i>' . JText::_('TPL_INSTALL_SAMPLE_DATA_BUTTON') . '</button>
							<div class="alert" id="install-response" style="padding-top:10px"></div>
						</div>
					</div>';
		}

		return $return;
	}
}
