<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die('Restricted access');

JTable::addIncludePath(JPATH_ADMINISTRATOR . '/components/com_rspagebuilder/tables/');

/**
 * Class XMLParserRSPageBuilder
 */
class XMLParserRSPageBuilder extends XMLParser {
	
	protected function getTable() {
		return JTable::getInstance('Page', 'RSPageBuilderTable');
	}

	public function saveItem($item, $folder) {
		$check = XMLParser::checkIfInstalled('com_rspagebuilder');
		
		if ($check) {
			$item      = $this->prepareData($item);
			$extension = $this->setDefaultValue($item, 'extension', 'com_rspagebuilder');

			$table = $this->getTable();
			$table->bind($item);
			$table->id			= null;
			$table->access		= 1;
			$table->published	= 1;
			$table->created   	= date("Y-m-d H:i:s");
			$table->created_by	= JFactory::getUser()->id;
			$table->modified_by	= JFactory::getUser()->id;
			$table->language	= '*';
			$table->content		= $item['content'];
			
			if ($table->check()) {
				$table->store();
				$this->tableData[] = $table;
			}
		}
	}
	
	public function addModulesIds($item, $folder) {
		$check = XMLParser::checkIfInstalled('com_rspagebuilder');
		
		if ($check) {			
			$db    = JFactory::getDbo();
			$query = $db->getQuery(true);

			$query->update($db->qn('#__rspagebuilder'))
				->set($db->qn('content') . ' = ' . $db->q($this->parseContent($item->content)))
				->where($db->qn('alias') . ' = ' . $db->q($item->alias));
			$db->setQuery($query);
			$db->execute();
		}
	}
	
	private function parseContent($content) {
		$data = json_decode($content);
		
		// for RSPageBuilder! Module elements get module id by using module title
		foreach ($data as $row) {
			foreach ($row->columns as $column) {
				foreach ($column->elements as $element) {
					if ($element->type == 'rspbld_module') {
						$db    = JFactory::getDbo();
						$query = $db->getQuery(true);

						$query->select($db->qn('id'))
							->from($db->qn('#__modules'))
							->where($db->qn('title') . ' = ' . $db->q($element->options->module))
							->where($db->qn('client_id'). ' = 0')
							->where($db->qn('published') . ' = 1');
						$db->setQuery($query);
						$modules = $db->loadObjectList();
						
						if (count($modules)) {
							$element->options->module = $modules{0}->id;
						}
					}
				}
			}
		}
		
		return json_encode($data);
	}
	
	public function getPageId($alias) {
		static $cache = array();

		if (!isset($cache[$alias])) {
			foreach ($this->tableData as $position => $table) {
				if ($table->alias == $alias) {
					$cache[$alias] = $position;
					break;
				}
			}
		}

		return $this->tableData[$cache[$alias]]->id;
	}
}
