<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die('Restricted access');

/**
 * Class XMLParserMenuTypes
 */
class XMLParserMenuTypes extends XMLParser
{
	/**
	 * @return mixed
	 */
	protected function getTable()
	{
		JTable::addIncludePath(JPATH_SITE . '/libraries/legacy/table/menu/');

		return JTable::getInstance('MenuType', 'JTable');
	}

	/**
	 * @param $item
	 * @param $folder
	 */
	public function saveItem($item, $folder)
	{
		$item  = $this->prepareData($item);
		$table = $this->getTable();
		$table->bind($item);
		$table->id = null;

		if ($table->check())
		{
			$table->store();
			$this->tableData[] = $table;
		}
	}

	/**
	 * @param $alias
	 *
	 * @return mixed
	 */
	public function getCategoryId($alias)
	{
		static $cache = array();

		if (!isset($cache[$alias]))
		{
			foreach ($this->tableData as $position => $table)
			{
				if ($table->alias == $alias)
				{
					$cache[$alias] = $position;
					break;
				}
			}
		}

		return $this->tableData[$cache[$alias]]->id;
	}
}
