<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die('Restricted access');

class XMLParserTemplates extends XMLParser {
	
	protected function getTable() {
		JTable::addIncludePath(JPATH_ADMINISTRATOR . '/components/com_templates/tables');

		return JTable::getInstance('Style', 'TemplatesTable');
	}

	public function saveItem($item, $folder) {
		$item = $this->prepareData($item);
		$tref = $item['tref'];
		unset($item['tref']);

		$table            = $this->getTable();
		$table->id        = null;
		$table->template  = 'rstrone';
		$table->client_id = 0;
		$table->home      = 0;
		$table->title     = $this->setDefaultValue($item, 'title', 'title');

		if ($table->check()) {
			$table->store();
			$this->tableData[$tref] = $table;
			$this->setTemplateStyles();
		}

	}

	public function getTemplateId($tref) {
		return isset($this->tableData[$tref]) ? $this->tableData[$tref]->id : '';
	}

	protected function setTemplateStyles() {
		$templateName = XMLParser::getTemplateName();
		$db           = JFactory::getDbo();
		$query        = $db->getQuery(true);

		$query->select($db->qn(array('id', 'title')))
			->from($db->qn('#__template_styles'))
			->where($db->qn('template') . ' = ' . $db->q($templateName));
		$db->setQuery($query);
		$templateStyles = $db->loadObjectList();


		foreach ($templateStyles as $templateStyle) {
			$id     = $templateStyle->id;
			$title  = $templateStyle->title;
			$base   = dirname(dirname(dirname(__FILE__)));
			$params = '';
			
			if ($title == "RSTrone! - Featured Headings") {
				$params = @file_get_contents($base . '/sampledata/data-rsmg/featured-headings-style.json');
			} else if ($title == "RSTrone! - K2") {
				$params = @file_get_contents($base . '/sampledata/data-rsmg/k2-style.json');
			} else {
				$params = @file_get_contents($base . '/sampledata/data-rsmg/default-style.json');
			}

			$query->clear();
			$query->update($db->qn('#__template_styles'))
				->set($db->qn('params') . ' = ' . $db->q($params))
				->where($db->qn('template') . ' = ' . $db->q($templateName))
				->where($db->qn('title') . ' = ' . $db->q($title))
				->where($db->qn('id') . ' = ' . $db->q($id));
			$db->setQuery($query);
			$db->execute();
		}

	}

}
