<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die('Restricted access');

class XMLParserUsers extends XMLParser
{
	protected function getTable()
	{
		JTable::addIncludePath(JPATH_SITE . '/libraries/joomla/table/');

		return JTable::getInstance('User', 'JTable');
	}

	public function saveItem($item, $folder)
	{
		$user	= JFactory::getUser();
		$item 	= $this->prepareData($item);

		$table	= $this->getTable();
		$table->bind($item);
		$table->id			= null;
		$table->password	= JUserHelper::hashPassword(JUserHelper::genRandomPassword(16));

		JModelLegacy::addIncludePath( JPATH_ADMINISTRATOR.'/components/com_users/models', 'UserModel');
		$user_model = JModelLegacy::getInstance('User', 'UsersModel', array('ignore_request' => true));
		
		$table->store();
		$last_record_id = $user_model->getState($user_model->getName() . '.id');
		$this->tableData[$item['ref']] = $table;
	}
	
	protected function prepareData($item)
	{
		$data = array();
		foreach ($item as $key => $val)
		{
			if ($key == 'params')
			{
				$data[$key] = json_decode($val);
			}
			elseif ($key == 'groups')
			{
				$data[$key] = explode(',', $val);
			}
			elseif ($key == 'email')
			{
				list($user, $domain) = explode('@', $val, 2);
				$data[$key] = $user . strtolower(JUserHelper::genRandomPassword(8)) . '@' . strtolower(JUserHelper::genRandomPassword(8)) . $domain;
			}
			else
			{
				$data[$key] = (string) trim($val);
			}
		}

		return $data;
	}
}
