<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.filesystem.folder');

/**
 * Class XMLSorter
 */
class XMLSorter
{
	/**
	 * @var
	 */
	protected $path;

	/**
	 * XMLSorter constructor.
	 *
	 * @param $path
	 */
	public function __construct($path)
	{
		$this->buildPath($path);
	}

	/**
	 * @param $path
	 */
	protected function buildPath($path)
	{
		$this->path = dirname(__FILE__) . '/sampledata/' . $path . '/';
	}

	/**
	 * @return array
	 */
	public function getFiles()
	{
		$files  = JFolder::files($this->path, '\.xml');
		$sorted = array();
		foreach ($files as $file)
		{
			$order          = $this->getOrder($this->readFile($this->path . $file));
			$sorted[$order] = substr($file, 0, -4);
		}

		ksort($sorted);

		return $sorted;
	}

	/**
	 * @param $file
	 *
	 * @return string
	 */
	protected function readFile($file)
	{
		return file_get_contents($file);
	}

	/**
	 * @param $contents
	 *
	 * @return mixed
	 */
	protected function getOrder($contents)
	{
		$pattern = '#<order>([0-9]+)<\/order>#';
		if (preg_match($pattern, $contents, $match))
		{
			return $match[1];
		}
	}
}
