<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die;

define('RSTEMPLATE_PATH', dirname(__FILE__));
// Include helper file
require_once dirname(__FILE__) . '/classes/template.php';
$template = new RSTemplate($this);

if ($this->params->get('load_bootstrap'))
{
	$template->addBootstrap();
}
if ($this->params->get('load_jquery') && !$this->params->get('load_bootstrap'))
{
	$template->addjQuery();
}
?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $this->language; ?>" lang="<?php echo $this->language; ?>" dir="<?php echo $this->direction; ?>">
<head>
	<jdoc:include type="head" />
	<?php
	// Add Stylesheets
	if (file_exists(RSTEMPLATE_PATH . '/css/themes/template-' . $template->getTemplateId() . '.css'))
	{
		$template->addCSS('themes/template-' . $template->getTemplateId() . '.css');
	}
	else
	{
		$template->addCSS('template.css');
	}

	$template->addCSS('icons.css');
	$template->addComponentCSS();
	// Load the custom.css
	$template->addCustomCSS();
	// Add Google Font
	$template->addGoogleFont();
	?>
	<!--[if lt IE 9]>
	<script src="<?php echo $this->baseurl ?><?php echo $template->getJSPath('html5', 'html5.js'); ?>"></script>
	<![endif]-->
	<?php
	// Add Google Analytics Tracking Code
	echo $template->addGoogleAnalytics();
	if (trim($this->params->get('add_header_content')) != '')
	{
		echo $this->params->get('add_header_content');
	}
	?>
	<script type="text/javascript">
		var backend = false;
		var rs_base_path = '<?php echo JUri::root();?>';
		var rs_template = '<?php echo $this->template?>';
		var rs_template_id = '<?php echo $template->getTemplateId(); ?>';
	</script>
</head>
<body class="contentpane rstpl-tmpl-component">
<?php echo $template->addGoogleTagManager(); ?>
<div id="rstpl-modal">
	<jdoc:include type="message" />
	<jdoc:include type="component" />
</div>
</body>
</html>
