<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die;
?>
<dl class="contact-address dl-horizontal" itemprop="address" itemscope itemtype="http://schema.org/PostalAddress">
	<?php if (($this->params->get('address_check') > 0) &&
		($this->contact->address || $this->contact->suburb || $this->contact->state || $this->contact->country || $this->contact->postcode)
	) : ?>
		<?php if ($this->params->get('address_check') > 0) : ?>
			<dt>
				<?php
				if ($this->params->get('contact_icons'))
				{
					echo $this->params->get('marker_address');
				}
				else
				{
					if (!preg_match('/rstemplate\/images\/contacts\/con_address.png/', $this->params->get('marker_address')))
					{
						echo $this->params->get('marker_address');
					}
					else
					{
						?>
						<span class="icon-home"></span>
						<?php
					}
				}
				?>
			</dt>
		<?php endif; ?>
		<dd>
			<?php if ($this->contact->address && $this->params->get('show_street_address')) : ?>
				<span class="contact-street" itemprop="streetAddress">
					<?php echo $this->contact->address . ', '; ?>
				</span>
			<?php endif; ?>

			<?php if ($this->contact->suburb && $this->params->get('show_suburb')) : ?>
				<span class="contact-suburb" itemprop="addressLocality">
					<?php echo $this->contact->suburb . ', '; ?>
				</span>
			<?php endif; ?>
			<?php if ($this->contact->state && $this->params->get('show_state')) : ?>
				<span class="contact-state" itemprop="addressRegion">
					<?php echo $this->contact->state . ', '; ?>
				</span>
			<?php endif; ?>
			<?php if ($this->contact->postcode && $this->params->get('show_postcode')) : ?>
				<span class="contact-postcode" itemprop="postalCode">
					<?php echo $this->contact->postcode . ', '; ?>
				</span>
			<?php endif; ?>
			<?php if ($this->contact->country && $this->params->get('show_country')) : ?>
				<span class="contact-country" itemprop="addressCountry">
					<?php echo $this->contact->country; ?>
				</span>
			<?php endif; ?>
		</dd>
	<?php endif; ?>

	<?php if ($this->contact->email_to && $this->params->get('show_email')) : ?>
		<dt>
			<?php
			if ($this->params->get('contact_icons'))
			{
				echo $this->params->get('marker_email');
			}
			else
			{
				if (!preg_match('/rstemplate\/images\/contacts\/emailButton.png/', $this->params->get('marker_email')))
				{
					echo $this->params->get('marker_email');
				}
				else
				{
					?>
					<span class="icon-envelope-o" itemprop="email"></span>
					<?php
				}
			}
			?>
		</dt>
		<dd>
		<span class="contact-emailto">
			<?php echo $this->contact->email_to; ?>
		</span>
		</dd>
	<?php endif; ?>

	<?php if ($this->contact->telephone && $this->params->get('show_telephone')) : ?>
		<dt>
			<?php
			if ($this->params->get('contact_icons'))
			{
				echo $this->params->get('marker_telephone');
			}
			else
			{
				if (!preg_match('/rstemplate\/images\/contacts\/con_tel.png/', $this->params->get('marker_telephone')))
				{
					echo $this->params->get('marker_telephone');
				}
				else
				{
					?>
					<span class="icon-phone"></span>
					<?php
				}
			}
			?>
		</dt>
		<dd>
		<span class="contact-telephone" itemprop="telephone">
			<?php echo $this->contact->telephone; ?>
		</span>
		</dd>
	<?php endif; ?>
	<?php if ($this->contact->fax && $this->params->get('show_fax')) : ?>
		<dt>
			<?php
			if ($this->params->get('contact_icons'))
			{
				echo $this->params->get('marker_fax');
			}
			else
			{
				if (!preg_match('/rstemplate\/images\/contacts\/con_fax.png/', $this->params->get('marker_fax')))
				{
					echo $this->params->get('marker_fax');
				}
				else
				{
					?>
					<span class="icon-fax"></span>
					<?php
				}
			}
			?>
		</dt>
		<dd>
		<span class="contact-fax" itemprop="faxNumber">
			<?php echo $this->contact->fax; ?>
		</span>
		</dd>
	<?php endif; ?>
	<?php if ($this->contact->mobile && $this->params->get('show_mobile')) : ?>
		<dt>
			<?php
			if ($this->params->get('contact_icons'))
			{
				echo $this->params->get('marker_mobile');
			}
			else
			{
				if (!preg_match('/rstemplate\/images\/contacts\/con_mobile.png/', $this->params->get('marker_mobile')))
				{
					echo $this->params->get('marker_mobile');
				}
				else
				{
					?>
					<span class="icon-mobile"></span>
					<?php
				}
			}
			?>
		</dt>
		<dd>
		<span class="contact-mobile" itemprop="telephone">
			<?php echo $this->contact->mobile; ?>
		</span>
		</dd>
	<?php endif; ?>
	<?php if ($this->contact->webpage && $this->params->get('show_webpage')) : ?>
		<dt>
		<span class="<?php echo $this->params->get('marker_class'); ?>">
		</span>
		</dt>
		<dd>
		<span class="contact-webpage">
			<a href="<?php echo $this->contact->webpage; ?>" target="_blank" itemprop="url">
				<?php echo JStringPunycode::urlToUTF8($this->contact->webpage); ?></a>
		</span>
		</dd>
	<?php endif; ?>
</dl>
