<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

// no direct access
defined('_JEXEC') or die;

// Define default image size (do not change)
K2HelperUtilities::setDefaultImage($this->item, 'itemlist', $this->params);

?>

<!-- Start K2 Item Layout -->
<div class="catItemView group<?php echo ucfirst($this->item->itemGroup); ?><?php echo ($this->item->featured) ? ' catItemIsFeatured' : ''; ?><?php if($this->item->params->get('pageclass_sfx')) echo ' '.$this->item->params->get('pageclass_sfx'); ?>">

	<!-- Plugins: BeforeDisplay -->
	<?php echo $this->item->event->BeforeDisplay; ?>

	<!-- K2 Plugins: K2BeforeDisplay -->
	<?php echo $this->item->event->K2BeforeDisplay; ?>

	<?php if($this->item->params->get('catItemImage') && !empty($this->item->image)): ?>
	<!-- Item Image -->
	<div class="catItemImageBlock">
	  <span class="catItemImage">
		<a href="<?php echo $this->item->link; ?>" title="<?php if(!empty($this->item->image_caption)) echo K2HelperUtilities::cleanHtml($this->item->image_caption); else echo K2HelperUtilities::cleanHtml($this->item->title); ?>">
			<img src="<?php echo $this->item->image; ?>" alt="<?php if(!empty($this->item->image_caption)) echo K2HelperUtilities::cleanHtml($this->item->image_caption); else echo K2HelperUtilities::cleanHtml($this->item->title); ?>" style="width:<?php echo $this->item->imageWidth; ?>px; height:auto;" />
		</a>
	  </span>
	  <div class="clr"></div>
	</div>
	<?php endif; ?>

	<?php if($this->item->itemGroup != 'links'): ?>
	<div class="catItemContainer">
		<div class="catItemHeader">
			<?php if($this->item->params->get('catItemTitle')): ?>
			<!-- Item title -->
			<h3 class="catItemTitle">
				<?php if(isset($this->item->editLink)): ?>
				<!-- Item edit link -->
				<span class="catItemEditLink">
					<a data-k2-modal="edit" href="<?php echo $this->item->editLink; ?>" title="<?php echo JText::_('K2_EDIT_ITEM'); ?>">
						<i class="icon-edit"></i>
					</a>
				</span>
				<?php endif; ?>

			<?php if ($this->item->params->get('catItemTitleLinked')): ?>
				<a href="<?php echo $this->item->link; ?>">
				<?php echo $this->item->title; ?>
			</a>
			<?php else: ?>
			<?php echo $this->item->title; ?>
			<?php endif; ?>

			<?php if($this->item->params->get('catItemFeaturedNotice') && $this->item->featured): ?>
			<!-- Featured flag -->
			<span><sup><?php echo JText::_('K2_FEATURED'); ?></sup></span>
			<?php endif; ?>
			</h3>
			<?php endif; ?>
			
			<?php
			if(
			$this->item->params->get('catItemAuthor') ||
			$this->item->params->get('catItemDateCreated') ||
			$this->item->params->get('catItemCategory')
			):
			?>
			<div class = "catItemPreInfo">
				<?php if($this->item->params->get('catItemAuthor')): ?>
				<!-- Item Author -->
				<span class="catItemAuthor">
					<i class="icon-user"></i>
					<?php if(isset($this->item->author->link) && $this->item->author->link): ?>
					<a rel="author" href="<?php echo $this->item->author->link; ?>"><?php echo $this->item->author->name; ?></a>
					<?php else: ?>
					<?php echo $this->item->author->name; ?>
					<?php endif; ?>
				</span>
				<?php endif; ?>

				<?php if($this->item->params->get('catItemDateCreated')): ?>
				<!-- Date created -->
				<span class="catItemDateCreated">
					<i class="icon-calendar"></i>
					<?php echo JHTML::_('date', $this->item->created , JText::_('K2_DATE_FORMAT_LC2')); ?>
				</span>
				<?php endif; ?>

				<?php if($this->item->params->get('catItemCategory')): ?>
				<!-- Item category name -->
				<span class="catItemCategory">
					<i class="icon-th-list"></i>
					<a href="<?php echo $this->item->category->link; ?>"><?php echo $this->item->category->name; ?></a>
				</span>
				<?php endif; ?>
			</div>
			<?php endif; ?>
		</div>

		<!-- Plugins: AfterDisplayTitle -->
		<?php echo $this->item->event->AfterDisplayTitle; ?>

		<!-- K2 Plugins: K2AfterDisplayTitle -->
		<?php echo $this->item->event->K2AfterDisplayTitle; ?>

		<?php if($this->item->params->get('catItemRating')): ?>
		<!-- Item Rating -->
		<div class="catItemRatingBlock">
			<span><?php echo JText::_('K2_RATE_THIS_ITEM'); ?></span>
			<div class="itemRatingForm">
				<ul class="itemRatingList">
					<li class="itemCurrentRating" id="itemCurrentRating<?php echo $this->item->id; ?>" style="width:<?php echo $this->item->votingPercentage; ?>%;"></li>
					<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_1_STAR_OUT_OF_5'); ?>" class="one-star">1</a></li>
					<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_2_STARS_OUT_OF_5'); ?>" class="two-stars">2</a></li>
					<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_3_STARS_OUT_OF_5'); ?>" class="three-stars">3</a></li>
					<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_4_STARS_OUT_OF_5'); ?>" class="four-stars">4</a></li>
					<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_5_STARS_OUT_OF_5'); ?>" class="five-stars">5</a></li>
				</ul>
				<div id="itemRatingLog<?php echo $this->item->id; ?>" class="itemRatingLog"><?php echo $this->item->numOfvotes; ?></div>
				<div class="clr"></div>
			</div>
			<div class="clr"></div>
		</div>
		<?php endif; ?>

		<div class="catItemBody">

			<!-- Plugins: BeforeDisplayContent -->
			<?php echo $this->item->event->BeforeDisplayContent; ?>

			<!-- K2 Plugins: K2BeforeDisplayContent -->
			<?php echo $this->item->event->K2BeforeDisplayContent; ?>

			<?php if($this->item->params->get('catItemIntroText')): ?>
			<!-- Item introtext -->
			<div class="catItemIntroText">
			<?php echo $this->item->introtext; ?>
			</div>
			<?php endif; ?>

			<div class="clr"></div>

			<?php if($this->item->params->get('catItemExtraFields') && count($this->item->extra_fields)): ?>
			<!-- Item extra fields -->
			<div class="catItemExtraFields">
				<h4><?php echo JText::_('K2_ADDITIONAL_INFO'); ?></h4>
				<ul>
					<?php foreach ($this->item->extra_fields as $key=>$extraField): ?>
					<?php if($extraField->value != ''): ?>
					<li class="<?php echo ($key%2) ? "odd" : "even"; ?> type<?php echo ucfirst($extraField->type); ?> group<?php echo $extraField->group; ?>">
						<?php if($extraField->type == 'header'): ?>
						<h4 class="catItemExtraFieldsHeader"><?php echo $extraField->name; ?></h4>
						<?php else: ?>
						<span class="catItemExtraFieldsLabel"><?php echo $extraField->name; ?></span>
						<span class="catItemExtraFieldsValue"><?php echo $extraField->value; ?></span>
						<?php endif; ?>
					</li>
					<?php endif; ?>
					<?php endforeach; ?>
					</ul>
				<div class="clr"></div>
			</div>
			<?php endif; ?>

			<!-- Plugins: AfterDisplayContent -->
			<?php echo $this->item->event->AfterDisplayContent; ?>

			<!-- K2 Plugins: K2AfterDisplayContent -->
			<?php echo $this->item->event->K2AfterDisplayContent; ?>
			
			<?php if ($this->item->params->get('catItemReadMore')): ?>
			<!-- Item "read more..." link -->
			<div class="catItemReadMore">
				<a class="btn btn-secondary" href="<?php echo $this->item->link; ?>">
					<?php echo JText::_('K2_READ_MORE'); ?>
				</a>
			</div>
			<?php endif; ?>
			
			<div class="clr"></div>
		</div>

		<div class="clr"></div>
		
		<?php
		if(
		$this->item->params->get('catItemHits') ||
		!empty($this->item->event->K2CommentsCounter) ||
		$this->item->params->get('catItemDateModified') ||
		($this->item->params->get('catItemTags') && count($this->item->tags))
		):
		?>
		<div class="catItemPostInfo">
			
			<?php if($this->item->params->get('catItemTags') && count($this->item->tags)): ?>
			<!-- Item tags -->
			<div class="catItemTagsBlock">
				<ul class="catItemTags">
					<?php foreach ($this->item->tags as $tag): ?>
					<li><a href="<?php echo $tag->link; ?>"><?php echo $tag->name; ?></a></li>
					<?php endforeach; ?>
				</ul>
				<div class="clr"></div>
			</div>
			<?php endif; ?>
			
			<?php if($this->item->params->get('catItemHits')): ?>
			<!-- Item Hits -->
			<span class="catItemHits">
				<i class="icon-eye"></i>
				<?php echo $this->item->hits; ?>
			</span>
			<?php endif; ?>
			
			<?php if($this->item->params->get('catItemCommentsAnchor') && ( ($this->item->params->get('comments') == '2' && !$this->user->guest) || ($this->item->params->get('comments') == '1')) ): ?>
			<!-- Anchor link to comments below -->
			<span class="catItemComments">
				<?php if(!empty($this->item->event->K2CommentsCounter)): ?>
					<!-- K2 Plugins: K2CommentsCounter -->
					<?php echo $this->item->event->K2CommentsCounter; ?>
				<?php else: ?>
					<?php if($this->item->numOfComments > 0): ?>
					<i class="icon-comments"></i>
					<a href="<?php echo $this->item->link; ?>#itemCommentsAnchor">
						<?php echo $this->item->numOfComments; ?>
					</a>
					<?php else: ?>
					<a href="<?php echo $this->item->link; ?>#itemCommentsAnchor">
						<?php echo JText::_('K2_BE_THE_FIRST_TO_COMMENT'); ?>
					</a>
					<?php endif; ?>
				<?php endif; ?>
			</span>
			<?php endif; ?>
			
			<?php if($this->item->params->get('catItemDateModified')): ?>
			<!-- Item date modified -->
			<?php if($this->item->modified != $this->nullDate && $this->item->modified != $this->item->created ): ?>
			<span class="catItemDateModified">
				<i class="icon-edit"></i>
				<?php echo JHTML::_('date', $this->item->modified, JText::_('K2_DATE_FORMAT_LC2')); ?>
			</span>
			<?php endif; ?>
			<?php endif; ?>
		</div>
		<?php endif; ?>
		
		<div class="clr"></div>
		
		<?php if($this->item->params->get('catItemAttachments') && count($this->item->attachments)): ?>
		<!-- Item attachments -->
		<div class="catItemAttachmentsBlock">
			<i class="icon-download"></i>
			<ul class="catItemAttachments">
				<?php foreach ($this->item->attachments as $attachment): ?>
				<li>
					<a title="<?php echo K2HelperUtilities::cleanHtml($attachment->titleAttribute); ?>" href="<?php echo $attachment->link; ?>">
						<?php echo $attachment->title ; ?>
					</a>
					<?php if($this->item->params->get('catItemAttachmentsCounter')): ?>
					<span>(<?php echo $attachment->hits; ?> <?php echo ($attachment->hits==1) ? JText::_('K2_DOWNLOAD') : JText::_('K2_DOWNLOADS'); ?>)</span>
					<?php endif; ?>
				</li>
				<?php endforeach; ?>
			</ul>
		</div>
		<?php endif; ?>

		<div class="clr"></div>

		<?php if($this->item->params->get('catItemVideo') && !empty($this->item->video)): ?>
		<!-- Item video -->
		<div class="catItemVideoBlock">
			<h4><?php echo JText::_('K2_RELATED_VIDEO'); ?></h4>
			<?php if($this->item->videoType=='embedded'): ?>
			<div class="catItemVideoEmbedded">
				<?php echo $this->item->video; ?>
			</div>
			<?php else: ?>
			<span class="catItemVideo"><?php echo $this->item->video; ?></span>
			<?php endif; ?>
		</div>
		<?php endif; ?>

		<?php if($this->item->params->get('catItemImageGallery') && !empty($this->item->gallery)): ?>
		<!-- Item image gallery -->
		<div class="catItemImageGallery">
			<h4><?php echo JText::_('K2_IMAGE_GALLERY'); ?></h4>
			<?php echo $this->item->gallery; ?>
		</div>
		<?php endif; ?>

		<div class="clr"></div>

		<!-- Plugins: AfterDisplay -->
		<?php echo $this->item->event->AfterDisplay; ?>

		<!-- K2 Plugins: K2AfterDisplay -->
		<?php echo $this->item->event->K2AfterDisplay; ?>

		<div class="clr"></div>
	</div>
	<?php endif; ?>
</div>
<!-- End K2 Item Layout -->
