<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

// no direct access
defined('_JEXEC') or die;

?>

<?php if(JFactory::getApplication()->input->getInt('print')==1): ?>
<!-- Print button at the top of the print page only -->
<a class="itemPrintThisPage" rel="nofollow" href="#" onclick="window.print();return false;">
	<span><?php echo JText::_('K2_PRINT_THIS_PAGE'); ?></span>
</a>
<?php endif; ?>

<!-- Start K2 Item Layout -->
<span id="startOfPageId<?php echo JFactory::getApplication()->input->getInt('id'); ?>"></span>

<div id="k2Container" class="itemView<?php echo ($this->item->featured) ? ' itemIsFeatured' : ''; ?><?php if($this->item->params->get('pageclass_sfx')) echo ' '.$this->item->params->get('pageclass_sfx'); ?>">

	<!-- Plugins: BeforeDisplay -->
	<?php echo $this->item->event->BeforeDisplay; ?>

	<!-- K2 Plugins: K2BeforeDisplay -->
	<?php echo $this->item->event->K2BeforeDisplay; ?>

	<div class="itemHeader">

		<?php if($this->item->params->get('itemTitle')): ?>
		<!-- Item title -->
		<h2 class="itemTitle">
			<?php if(isset($this->item->editLink)): ?>
			<!-- Item edit link -->
			<span class="itemEditLink">
				<a data-k2-modal="edit" href="<?php echo $this->item->editLink; ?>" title="<?php echo JText::_('K2_EDIT_ITEM'); ?>">
				<i class="icon-edit"></i>
				</a>
			</span>
			<?php endif; ?>

			<?php echo $this->item->title; ?>

			<?php if($this->item->params->get('itemFeaturedNotice') && $this->item->featured): ?>
			<!-- Featured flag -->
			<span>
				<sup>
					<?php echo JText::_('K2_FEATURED'); ?>
				</sup>
			</span>
			<?php endif; ?>
		</h2>
		<?php endif; ?>
		
		<?php
		if(
		$this->item->params->get('itemAuthor') ||
		$this->item->params->get('itemDateCreated') ||
		$this->item->params->get('itemCategory')
		):
		?>
		<div class="itemPreInfo">
			<?php if($this->item->params->get('itemAuthor')): ?>
			<!-- Item Author -->
			<span class="itemAuthor">
				<i class="icon-user"></i>
				<?php if(empty($this->item->created_by_alias)): ?>
				<a rel="author" href="<?php echo $this->item->author->link; ?>"><?php echo $this->item->author->name; ?></a>
				<?php else: ?>
				<?php echo $this->item->author->name; ?>
				<?php endif; ?>
			</span>
			<?php endif; ?>
			
			<?php if($this->item->params->get('itemDateCreated')): ?>
			<!-- Date created -->
			<span class="itemDateCreated">
				<i class="icon-calendar"></i>
				<?php echo JHTML::_('date', $this->item->created , JText::_('K2_DATE_FORMAT_LC2')); ?>
			</span>
			<?php endif; ?>
			
			<?php if($this->item->params->get('itemCategory')): ?>
			<!-- Item category -->
			<span class="itemCategory">
				<i class="icon-th-list"></i>
				<a href="<?php echo $this->item->category->link; ?>"><?php echo $this->item->category->name; ?></a>
			</span>
			<?php endif; ?>
		</div>
		<?php endif; ?>
	</div>

	<!-- Plugins: AfterDisplayTitle -->
	<?php echo $this->item->event->AfterDisplayTitle; ?>

	<!-- K2 Plugins: K2AfterDisplayTitle -->
	<?php echo $this->item->event->K2AfterDisplayTitle; ?>

	<?php if(
		$this->item->params->get('itemFontResizer') ||
		$this->item->params->get('itemPrintButton') ||
		$this->item->params->get('itemEmailButton') ||
		$this->item->params->get('itemSocialButton') ||
		($this->item->params->get('itemVideoAnchor') && !empty($this->item->video)) ||
		($this->item->params->get('itemImageGalleryAnchor') && !empty($this->item->gallery)) ||
		($this->item->params->get('itemCommentsAnchor') && $this->item->params->get('itemComments') && $this->item->params->get('comments'))
	): ?>
	<div class="itemToolbar">
	
		<?php if($this->item->params->get('itemRating')): ?>
		<!-- Item Rating -->
		<div class="itemRatingBlock">
			<span><?php echo JText::_('K2_RATE_THIS_ITEM'); ?></span>
			<div class="itemRatingForm">
				<ul class="itemRatingList">
					<li class="itemCurrentRating" id="itemCurrentRating<?php echo $this->item->id; ?>" style="width:<?php echo $this->item->votingPercentage; ?>%;"></li>
					<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_1_STAR_OUT_OF_5'); ?>" class="one-star">1</a></li>
					<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_2_STARS_OUT_OF_5'); ?>" class="two-stars">2</a></li>
					<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_3_STARS_OUT_OF_5'); ?>" class="three-stars">3</a></li>
					<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_4_STARS_OUT_OF_5'); ?>" class="four-stars">4</a></li>
					<li><a href="#" data-id="<?php echo $this->item->id; ?>" title="<?php echo JText::_('K2_5_STARS_OUT_OF_5'); ?>" class="five-stars">5</a></li>
				</ul>
				<div id="itemRatingLog<?php echo $this->item->id; ?>" class="itemRatingLog"><?php echo $this->item->numOfvotes; ?></div>
				<div class="clr"></div>
			</div>
			<div class="clr"></div>
		</div>
		<?php endif; ?>
	
		<ul>
			<?php if($this->item->params->get('itemFontResizer')): ?>
			<!-- Font Resizer -->
			<li id="font-size">
				<i class="icon-font"></i>
				<a href="#" id="fontIncrease" title="<?php echo ucfirst(JText::_('K2_INCREASE_FONT_SIZE')); ?>">
					<i class="icon-plus"></i>
				</a>
				<a href="#" id="fontDecrease" title="<?php echo ucfirst(JText::_('K2_DECREASE_FONT_SIZE')); ?>">
					<i class="icon-minus"></i>
				</a>
			</li>
			<?php endif; ?>

			<?php if($this->item->params->get('itemPrintButton') && !JFactory::getApplication()->input->getInt('print')): ?>
			<!-- Print Button -->
			<li>
				<a class="itemPrintLink" rel="nofollow" href="<?php echo $this->item->printLink; ?>" onclick="window.open(this.href,'printWindow','width=900,height=600,location=no,menubar=no,resizable=yes,scrollbars=yes'); return false;" title="<?php echo JText::_('K2_PRINT'); ?>">
					<i class="icon-print"></i>
				</a>
			</li>
			<?php endif; ?>

			<?php if($this->item->params->get('itemEmailButton') && !JFactory::getApplication()->input->getInt('print')): ?>
			<!-- Email Button -->
			<li>
				<a class="itemEmailLink" rel="nofollow" href="<?php echo $this->item->emailLink; ?>" onclick="window.open(this.href,'emailWindow','width=400,height=350,location=no,menubar=no,resizable=no,scrollbars=no'); return false;" title="<?php echo JText::_('K2_EMAIL'); ?>">
					<i class="icon-envelope"></i>
				</a>
			</li>
			<?php endif; ?>

			<?php if($this->item->params->get('itemSocialButton') && !is_null($this->item->params->get('socialButtonCode', NULL))): ?>
			<!-- Item Social Button -->
			<li>
				<?php echo $this->item->params->get('socialButtonCode'); ?>
			</li>
			<?php endif; ?>

			<?php if($this->item->params->get('itemVideoAnchor') && !empty($this->item->video)): ?>
			<!-- Anchor link to item video below - if it exists -->
			<li>
				<a class="itemVideoLink k2Anchor" href="<?php echo $this->item->link; ?>#itemVideoAnchor" title="<?php echo JText::_('K2_MEDIA'); ?>">
					<i class="icon-film"></i>
				</a>
			</li>
			<?php endif; ?>

			<?php if($this->item->params->get('itemImageGalleryAnchor') && !empty($this->item->gallery)): ?>
			<!-- Anchor link to item image gallery below - if it exists -->
			<li>
				<a class="itemImageGalleryLink k2Anchor" href="<?php echo $this->item->link; ?>#itemImageGalleryAnchor" title="<?php echo JText::_('K2_IMAGE_GALLERY'); ?>">
					<i class="icon-picture-o"></i>
				</a>
			</li>
			<?php endif; ?>

			<?php if($this->item->params->get('itemCommentsAnchor') && $this->item->params->get('itemComments') && ( ($this->item->params->get('comments') == '2' && !$this->user->guest) || ($this->item->params->get('comments') == '1')) ): ?>
			<!-- Anchor link to comments below - if enabled -->
			<li>
				<?php if(!empty($this->item->event->K2CommentsCounter)): ?>
				<!-- K2 Plugins: K2CommentsCounter -->
				<?php echo $this->item->event->K2CommentsCounter; ?>
				<?php else: ?>
				<?php if($this->item->numOfComments > 0): ?>
				<a href="<?php echo $this->item->link; ?>#itemCommentsAnchor" title="<?php echo ucfirst(($this->item->numOfComments>1) ? JText::_('K2_COMMENTS') : JText::_('K2_COMMENT')); ?>">
					<i class="icon-comments"></i>
					<?php echo $this->item->numOfComments; ?>
				</a>
				<?php else: ?>
				<a href="<?php echo $this->item->link; ?>#itemCommentsAnchor">
					<?php echo JText::_('K2_BE_THE_FIRST_TO_COMMENT'); ?>
				</a>
				<?php endif; ?>
				<?php endif; ?>
			</li>
			<?php endif; ?>
		</ul>
		<div class="clr"></div>
	</div>
	<?php endif; ?>

	<div class="itemBody">

		<!-- Plugins: BeforeDisplayContent -->
		<?php echo $this->item->event->BeforeDisplayContent; ?>

		<!-- K2 Plugins: K2BeforeDisplayContent -->
		<?php echo $this->item->event->K2BeforeDisplayContent; ?>

		<?php if($this->item->params->get('itemImage') && !empty($this->item->image)): ?>
		<!-- Item Image -->
		<div class="itemImageBlock">
			<span class="itemImage">
				<a data-k2-modal="image" href="<?php echo $this->item->imageXLarge; ?>" title="<?php echo JText::_('K2_CLICK_TO_PREVIEW_IMAGE'); ?>">
					<img src="<?php echo $this->item->image; ?>" alt="<?php if(!empty($this->item->image_caption)) echo K2HelperUtilities::cleanHtml($this->item->image_caption); else echo K2HelperUtilities::cleanHtml($this->item->title); ?>" style="width:<?php echo $this->item->imageWidth; ?>px; height:auto;" />
				</a>
				<?php if($this->item->params->get('itemImageMainCaption') && !empty($this->item->image_caption)): ?>
				<!-- Image caption -->
				<span class="itemImageCaption"><?php echo $this->item->image_caption; ?></span>
				<?php endif; ?>
			</span>

			<?php if($this->item->params->get('itemImageMainCredits') && !empty($this->item->image_credits)): ?>
			<!-- Image credits -->
			<span class="itemImageCredits"><?php echo $this->item->image_credits; ?></span>
			<?php endif; ?>

			<div class="clr"></div>
		</div>
		<?php endif; ?>

		<?php if(!empty($this->item->fulltext)): ?>

		<?php if($this->item->params->get('itemIntroText')): ?>
		<!-- Item introtext -->
		<div class="itemIntroText">
			<?php echo $this->item->introtext; ?>
		</div>
		<?php endif; ?>

		<?php if($this->item->params->get('itemFullText')): ?>
		<!-- Item fulltext -->
		<div class="itemFullText">
			<?php echo $this->item->fulltext; ?>
		</div>
		<?php endif; ?>

		<?php else: ?>

		<!-- Item text -->
		<div class="itemFullText">
			<?php echo $this->item->introtext; ?>
		</div>

		<?php endif; ?>

		<div class="clr"></div>

		<?php if($this->item->params->get('itemExtraFields') && count($this->item->extra_fields)): ?>
		<!-- Item extra fields -->
		<div class="itemExtraFields">
			<h4><?php echo JText::_('K2_ADDITIONAL_INFO'); ?></h4>
			<ul>
				<?php foreach ($this->item->extra_fields as $key=>$extraField): ?>
				<?php if($extraField->value != ''): ?>
				<li class="<?php echo ($key%2) ? "odd" : "even"; ?> type<?php echo ucfirst($extraField->type); ?> group<?php echo $extraField->group; ?>">
					<?php if($extraField->type == 'header'): ?>
					<h4 class="itemExtraFieldsHeader"><?php echo $extraField->name; ?></h4>
					<?php else: ?>
					<span class="itemExtraFieldsLabel"><?php echo $extraField->name; ?>:</span>
					<span class="itemExtraFieldsValue"><?php echo $extraField->value; ?></span>
					<?php endif; ?>
				</li>
				<?php endif; ?>
				<?php endforeach; ?>
			</ul>
			<div class="clr"></div>
		</div>
		<?php endif; ?>

		<div class="clr"></div>

	</div>
	
	<?php
	if(
	$this->item->params->get('itemHits') ||
	($this->item->params->get('itemDateModified') && intval($this->item->modified)!=0) ||
	($this->item->params->get('itemTags') && count($this->item->tags))
	):
	?>
	<div class="itemPostInfo">

		<?php if($this->item->params->get('itemTags') && count($this->item->tags)): ?>
		<!-- Item tags -->
		<div class="itemTagsBlock">
			<ul class="itemTags">
				<?php foreach ($this->item->tags as $tag): ?>
				<li><a href="<?php echo $tag->link; ?>"><?php echo $tag->name; ?></a></li>
				<?php endforeach; ?>
			</ul>
		</div>
		<?php endif; ?>
	
		<?php if($this->item->params->get('itemHits')): ?>
		<!-- Item Hits -->
		<span class="itemHits">
			<i class="icon-eye"></i>
			<?php echo $this->item->hits; ?>
		</span>
		<?php endif; ?>

		<?php if($this->item->params->get('itemDateModified') && intval($this->item->modified)!=0): ?>
		<!-- Item date modified -->
		<span class="itemDateModified">
			<i class="icon-edit"></i>
			<?php echo JHTML::_('date', $this->item->modified, JText::_('K2_DATE_FORMAT_LC2')); ?>
		</span>
		<?php endif; ?>

		<div class="clr"></div>
	</div>
	<?php endif; ?>
	
	<!-- Plugins: AfterDisplayContent -->
	<?php echo $this->item->event->AfterDisplayContent; ?>

	<!-- K2 Plugins: K2AfterDisplayContent -->
	<?php echo $this->item->event->K2AfterDisplayContent; ?>

	<div class="clr"></div>
	
	<?php if($this->item->params->get('itemAttachments') && count($this->item->attachments)): ?>
	<!-- Item attachments -->
	<div class="itemAttachmentsBlock">
		<i class="icon-download"></i>
		<ul class="itemAttachments">
			<?php foreach ($this->item->attachments as $attachment): ?>
			<li>
				<a title="<?php echo K2HelperUtilities::cleanHtml($attachment->titleAttribute); ?>" href="<?php echo $attachment->link; ?>"><?php echo $attachment->title; ?></a>
				<?php if($this->item->params->get('itemAttachmentsCounter')): ?>
				<span>(<?php echo $attachment->hits; ?> <?php echo ($attachment->hits==1) ? JText::_('K2_DOWNLOAD') : JText::_('K2_DOWNLOADS'); ?>)</span>
				<?php endif; ?>
			</li>
			<?php endforeach; ?>
		</ul>
	</div>
	<?php endif; ?>

	<?php if(
		$this->item->params->get('itemTwitterButton',1) ||
		$this->item->params->get('itemFacebookButton',1) ||
		$this->item->params->get('itemGooglePlusOneButton',1) ||
		($this->item->params->get('itemNavigation') && !JFactory::getApplication()->input->getCmd('print') && (isset($this->item->nextLink) || isset($this->item->previousLink)))
	): ?>
	<!-- Social sharing -->
	<div class="row-fluid itemBottomToolbar">
		
		<?php if(
			$this->item->params->get('itemTwitterButton',1) ||
			$this->item->params->get('itemFacebookButton',1) ||
			$this->item->params->get('itemGooglePlusOneButton',1)
		): ?>
		
		<div class="itemSocialSharing span10">
			<?php if($this->item->params->get('itemTwitterButton',1)): ?>
			<!-- Twitter Button -->
			<div class="itemTwitterButton">
				<a href="https://twitter.com/share" class="twitter-share-button" data-lang="<?php echo $this->item->langTagForTW; ?>" data-via="<?php if($this->item->params->get('twitterUsername')) echo $this->item->params->get('twitterUsername'); ?>"><?php echo JText::_('K2_TWEET'); ?></a>
				<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+'://platform.twitter.com/widgets.js';fjs.parentNode.insertBefore(js,fjs);}}(document, 'script', 'twitter-wjs');</script>
			</div>
			<?php endif; ?>

			<?php if($this->item->params->get('itemFacebookButton',1)): ?>
			<!-- Facebook Button -->
			<div class="itemFacebookButton">
				<div id="fb-root"></div>
				<script type="text/javascript">
					(function(d, s, id) {
					  var js, fjs = d.getElementsByTagName(s)[0];
					  if (d.getElementById(id)) return;
					  js = d.createElement(s); js.id = id;
					  js.src = "//connect.facebook.net/en_US/all.js#xfbml=1";
					  fjs.parentNode.insertBefore(js, fjs);
					}(document, 'script', 'facebook-jssdk'));
				</script>
				<div class="fb-like" data-send="false" data-width="200" data-show-faces="true"></div>
			</div>
			<?php endif; ?>

			<?php if($this->item->params->get('itemGooglePlusOneButton',1)): ?>
			<!-- Google +1 Button -->
			<div class="itemGooglePlusOneButton">
				<div class="g-plusone" data-size="medium"></div>
				<script>window.___gcfg={lang:'<?php echo $this->item->langTagForGP; ?>'};(function(){var po=document.createElement('script');po.type='text/javascript';po.async=true;po.src='https://apis.google.com/js/platform.js';var s=document.getElementsByTagName('script')[0];s.parentNode.insertBefore(po,s);})();</script>
			</div>
			<?php endif; ?>
		</div>
		<?php endif; ?>

		<?php if($this->item->params->get('itemNavigation') && !JFactory::getApplication()->input->getCmd('print') && (isset($this->item->nextLink) || isset($this->item->previousLink))): ?>
		<!-- Item navigation -->
		<div class="itemNavigation span2">
			<?php if(isset($this->item->previousLink)): ?>
			<a class="itemPrevious" href="<?php echo $this->item->previousLink; ?>" title="<?php echo $this->item->previousTitle; ?>"><i class="icon-chevron-left"></i></a>
			<?php endif; ?>

			<?php if(isset($this->item->nextLink)): ?>
			<a class="itemNext" href="<?php echo $this->item->nextLink; ?>" title="<?php echo $this->item->nextTitle; ?>"><i class="icon-chevron-right"></i></a>
			<?php endif; ?>
		</div>
		<?php endif; ?>
		
		<div class="clr"></div>
		
	</div>
	<?php endif; ?>
	
	<?php if($this->item->params->get('itemAuthorBlock') && empty($this->item->created_by_alias)): ?>
	<!-- Author Block -->
	<div class="itemAuthorBlock">
		<?php if($this->item->params->get('itemAuthorImage') && !empty($this->item->author->avatar)): ?>
		<img class="itemAuthorAvatar" src="<?php echo $this->item->author->avatar; ?>" alt="<?php echo K2HelperUtilities::cleanHtml($this->item->author->name); ?>" />
		<?php endif; ?>

		<div class="itemAuthorDetails">
			<h4 class="itemAuthorName">
				<a rel="author" href="<?php echo $this->item->author->link; ?>"><?php echo $this->item->author->name; ?></a>
			</h4>

			<?php
			if($this->item->params->get('itemAuthorDescription') && !empty($this->item->author->profile->description)):
				echo $this->item->author->profile->description;
			endif;
			?>

			<?php if($this->item->params->get('itemAuthorURL') && !empty($this->item->author->profile->url)): ?>
			<span class="itemAuthorUrl"><i class="icon-globe"></i> <a rel="me" href="<?php echo $this->item->author->profile->url; ?>" target="_blank"><?php echo str_replace('http://','',$this->item->author->profile->url); ?></a></span>
			<?php endif; ?>

			<?php if($this->item->params->get('itemAuthorURL') && !empty($this->item->author->profile->url) && $this->item->params->get('itemAuthorEmail')): ?>
			<span class="k2HorizontalSep">|</span>
			<?php endif; ?>

			<?php if($this->item->params->get('itemAuthorEmail')): ?>
			<span class="itemAuthorEmail"><i class="icon-envelope"></i> <?php echo JHTML::_('Email.cloak', $this->item->author->email); ?></span>
			<?php endif; ?>

			<div class="clr"></div>

			<!-- K2 Plugins: K2UserDisplay -->
			<?php echo $this->item->event->K2UserDisplay; ?>

			<div class="clr"></div>
		</div>
		<div class="clr"></div>
	</div>
	<?php endif; ?>

	<?php
	if(
	($this->item->params->get('itemAuthorLatest') && empty($this->item->created_by_alias) && isset($this->authorLatestItems)) ||
	($this->item->params->get('itemRelated') && isset($this->relatedItems))
	):?>
	<div class="row-fluid itemLatestRelated">
		<?php if($this->item->params->get('itemAuthorLatest') && empty($this->item->created_by_alias) && isset($this->authorLatestItems)): ?>
		<!-- Latest items from author -->
		<div class="span6">
			<div class="itemAuthorLatest">
				<h3><?php echo JText::_('K2_LATEST_FROM'); ?> <?php echo $this->item->author->name; ?></h3>
				<ul>
					<?php foreach($this->authorLatestItems as $key=>$item): ?>
					<li class="<?php echo ($key%2) ? "odd" : "even"; ?>">
						<?php if($item->imageSmall): ?>
						<div class="itemAuthorLatestImage">
							<img alt="<?php echo $item->title; ?>" src="<?php echo $item->imageSmall; ?>" />
						</div>
						<?php endif; ?>
						<div class="itemAuthorLatestDetails">
							<h5 class="itemAuthorLatestTitle">
								<a href="<?php echo $item->link ?>"><?php echo $item->title; ?></a>
							</h5>
							<div class="itemAuthorLatestInfo">
								<span class="itemAuthorLatestDateCreated">
									<i class="icon-calendar"></i>
									<?php echo JHTML::_('date', $item->created , JText::_('K2_DATE_FORMAT_LC2')); ?>
								</span>
							</div>
						</div>
					</li>
					<?php endforeach; ?>
				</ul>
				<div class="clr"></div>
			</div>
		</div>
		<?php endif; ?>

		<?php
		/*
		A note regarding 'Related Items'...
		If you add:
		- the CSS rule 'overflow-x:scroll;' in the element div.itemRelated {…} in the k2.css
		- the class 'k2Scroller' to the ul element below
		- the classes 'k2ScrollerElement' and 'k2EqualHeights' to the li element inside the foreach loop below
		- the style attribute 'style="width:<?php echo $item->imageWidth; ?>px;"' to the li element inside the foreach loop below
		...then your Related Items will be transformed into a vertical-scrolling block, inside which, all items have the same height (equal column heights). This can be very useful if you want to show your related articles or products with title/author/category/image etc., which would take a significant amount of space in the classic list-style display.
		*/
		?>

		<?php if($this->item->params->get('itemRelated') && isset($this->relatedItems)): ?>
		<!-- Related items by tag -->
		<div class="span6">
			<div class="itemRelated">
				<h3><?php echo JText::_("K2_RELATED_ITEMS_BY_TAG"); ?></h3>
				<ul>
					<?php foreach($this->relatedItems as $key=>$item): ?>
					<li class="<?php echo ($key%2) ? "odd" : "even"; ?>">

						<?php if($this->item->params->get('itemRelatedImageSize')): ?>
						<div class="itemRelImage">
							<img src="<?php echo $item->image; ?>" alt="<?php echo K2HelperUtilities::cleanHtml($item->title); ?>" />
						</div>
						<?php endif; ?>

						<div class="itemRelDetails">
							<?php if($this->item->params->get('itemRelatedTitle', 1)): ?>
							<h5 class="itemRelTitle">
								<a href="<?php echo $item->link ?>"><?php echo $item->title; ?></a>
							</h5>
							<?php endif; ?>

							<?php if($this->item->params->get('itemRelatedCategory') || $this->item->params->get('itemRelatedAuthor')): ?>
							<div class="itemRelInfo">
								<?php if($this->item->params->get('itemRelatedCategory')): ?>
								<span class="itemRelCat">
									<i class="icon-th-list"></i>
									<a href="<?php echo $item->category->link ?>"><?php echo $item->category->name; ?></a>
								</span>
								<?php endif; ?>

								<?php if($this->item->params->get('itemRelatedAuthor')): ?>
								<span class="itemRelAuthor">
									<i class="icon-user"></i>
									<a rel="author" href="<?php echo $item->author->link; ?>"><?php echo $item->author->name; ?></a>
								</span>
								<?php endif; ?>
							</div>
							<?php endif; ?>
							
							<?php if($this->item->params->get('itemRelatedIntrotext')): ?>
							<div class="itemRelIntrotext"><?php echo $item->introtext; ?></div>
							<?php endif; ?>

							<?php if($this->item->params->get('itemRelatedFulltext')): ?>
							<div class="itemRelFulltext"><?php echo $item->fulltext; ?></div>
							<?php endif; ?>

							<?php if($this->item->params->get('itemRelatedMedia')): ?>
							<?php if($item->videoType=='embedded'): ?>
							<div class="itemRelMediaEmbedded"><?php echo $item->video; ?></div>
							<?php else: ?>
							<div class="itemRelMedia"><?php echo $item->video; ?></div>
							<?php endif; ?>
							<?php endif; ?>

							<?php if($this->item->params->get('itemRelatedImageGallery')): ?>
							<div class="itemRelImageGallery"><?php echo $item->gallery; ?></div>
							<?php endif; ?>
						</div>
					</li>
					<?php endforeach; ?>
				</ul>
				<div class="clr"></div>
			</div>
		</div>
		<?php endif; ?>
	</div>
	<?php endif; ?>

	<div class="clr"></div>

	<?php if($this->item->params->get('itemVideo') && !empty($this->item->video)): ?>
	<!-- Item video -->
	<a name="itemVideoAnchor" id="itemVideoAnchor"></a>
	<div class="itemVideoBlock">
		<h4><?php echo JText::_('K2_MEDIA'); ?></h4>

		<?php if($this->item->videoType=='embedded'): ?>
		<div class="itemVideoEmbedded">
			<?php echo $this->item->video; ?>
		</div>
		<?php else: ?>
		<span class="itemVideo"><?php echo $this->item->video; ?></span>
		<?php endif; ?>

		<?php if($this->item->params->get('itemVideoCaption') && !empty($this->item->video_caption)): ?>
		<span class="itemVideoCaption"><?php echo $this->item->video_caption; ?></span>
		<?php endif; ?>

		<?php if($this->item->params->get('itemVideoCredits') && !empty($this->item->video_credits)): ?>
		<span class="itemVideoCredits"><?php echo $this->item->video_credits; ?></span>
		<?php endif; ?>

		<div class="clr"></div>
	</div>
	<?php endif; ?>

	<?php if($this->item->params->get('itemImageGallery') && !empty($this->item->gallery)): ?>
	<!-- Item image gallery -->
	<a name="itemImageGalleryAnchor" id="itemImageGalleryAnchor"></a>
	<div class="itemImageGallery">
		<h4><?php echo JText::_('K2_IMAGE_GALLERY'); ?></h4>
		<?php echo $this->item->gallery; ?>
	</div>
	<?php endif; ?>

	<!-- Plugins: AfterDisplay -->
	<?php echo $this->item->event->AfterDisplay; ?>

	<!-- K2 Plugins: K2AfterDisplay -->
	<?php echo $this->item->event->K2AfterDisplay; ?>

	<?php if(
		$this->item->params->get('itemComments') &&
		(($this->item->params->get('comments') == '2' && !$this->user->guest) || ($this->item->params->get('comments') == '1'))
	): ?>
	<!-- K2 Plugins: K2CommentsBlock -->
	<?php echo $this->item->event->K2CommentsBlock; ?>
	<?php endif; ?>

	<?php if(
		$this->item->params->get('itemComments') &&
		($this->item->params->get('comments') == '1' || ($this->item->params->get('comments') == '2')) && empty($this->item->event->K2CommentsBlock)
	): ?>
	<!-- Item comments -->
	<a name="itemCommentsAnchor" id="itemCommentsAnchor"></a>
	<div class="itemComments">
		<?php if($this->item->params->get('commentsFormPosition')=='above' && $this->item->params->get('itemComments') && !JFactory::getApplication()->input->getInt('print') && ($this->item->params->get('comments') == '1' || ($this->item->params->get('comments') == '2' && K2HelperPermissions::canAddComment($this->item->catid)))): ?>
		<!-- Item comments form -->
		<div class="itemCommentsForm">
			<?php echo $this->loadTemplate('comments_form'); ?>
		</div>
		<?php endif; ?>

		<?php if($this->item->numOfComments>0 && $this->item->params->get('itemComments') && ($this->item->params->get('comments') == '1' || ($this->item->params->get('comments') == '2'))): ?>
		<!-- Item user comments -->
		<h3 class="itemCommentsCounter">
			<span><?php echo $this->item->numOfComments; ?></span> <?php echo ($this->item->numOfComments>1) ? JText::_('K2_COMMENTS') : JText::_('K2_COMMENT'); ?>
		</h3>

		<ul class="itemCommentsList">
			<?php foreach ($this->item->comments as $key=>$comment): ?>
			<li id="comment<?php echo $comment->id; ?>" class="<?php echo ($key%2) ? "odd" : "even"; echo (!$this->item->created_by_alias && $comment->userID==$this->item->created_by) ? " authorResponse" : ""; echo($comment->published) ? '':' unpublishedComment'; ?>">

				<?php if($comment->userImage): ?>
				<img class="commentAuthorAvatar" src="<?php echo $comment->userImage; ?>" alt="<?php echo JFilterOutput::cleanText($comment->userName); ?>" width="<?php echo $this->item->params->get('commenterImgWidth'); ?>" />
				<?php endif; ?>
				<div class="commentDetails">
					<div class="commentInfo">
						<span class="commentAuthorName">
							<i class="icon-user"></i>
							<?php if(!empty($comment->userLink)): ?>
							<a href="<?php echo JFilterOutput::cleanText($comment->userLink); ?>" title="<?php echo JFilterOutput::cleanText($comment->userName); ?>" target="_blank" rel="nofollow"><?php echo $comment->userName; ?></a>
							<?php else: ?>
							<?php echo $comment->userName; ?>
							<?php endif; ?>
						</span>

						<span class="commentDate">
							<i class="icon-calendar"></i>
							<?php echo JHTML::_('date', $comment->commentDate, JText::_('K2_DATE_FORMAT_LC2')); ?>
						</span>

						<span class="commentLink">
							<a href="<?php echo $this->item->link; ?>#comment<?php echo $comment->id; ?>" title="<?php echo JText::_('K2_COMMENT_LINK'); ?>" name="comment<?php echo $comment->id; ?>">
								<i class="icon-link"></i>
							</a>
						</span>
					</div>

					<p><?php echo $comment->commentText; ?></p>

					<?php if(
						$this->inlineCommentsModeration ||
						($comment->published && ($this->params->get('commentsReporting')=='1' || ($this->params->get('commentsReporting')=='2' && !$this->user->guest)))
					): ?>
					<span class="commentToolbar">
						<?php if($this->inlineCommentsModeration): ?>
						<?php if(!$comment->published): ?>
						<a class="commentApproveLink" href="<?php echo JRoute::_('index.php?option=com_k2&view=comments&task=publish&commentID='.$comment->id.'&format=raw')?>" title="<?php echo JText::_('K2_APPROVE')?>"><i class="icon-check"></i></a>
						<?php endif; ?>

						<a class="commentRemoveLink" href="<?php echo JRoute::_('index.php?option=com_k2&view=comments&task=remove&commentID='.$comment->id.'&format=raw')?>" title="<?php echo JText::_('K2_REMOVE')?>"><i class="icon-delete"></i></a>
						<?php endif; ?>

						<?php if($comment->published && ($this->params->get('commentsReporting')=='1' || ($this->params->get('commentsReporting')=='2' && !$this->user->guest))): ?>
						<a class="commentReport" data-k2-modal="iframe" href="<?php echo JRoute::_('index.php?option=com_k2&view=comments&task=report&commentID='.$comment->id)?>" title="<?php echo JText::_('K2_REPORT')?>"><i class="icon-exclamation"></i></a>
						<?php endif; ?>

						<?php if($comment->reportUserLink): ?>
						<a class="k2ReportUserButton" href="<?php echo $comment->reportUserLink; ?>" title="<?php echo JText::_('K2_FLAG_AS_SPAMMER'); ?>"><i class="icon-flag"></i></a>
						<?php endif; ?>
					</span>
					<?php endif; ?>
				</div>
				<div class="clr"></div>
			</li>
			<?php endforeach; ?>
		</ul>

		<?php
		$pages_links = $this->pagination->getPagesLinks();
		
		if(!empty($pages_links)):
		?>
		<!-- Comments Pagination -->
		<div class="itemCommentsPagination">
			<?php echo $pages_links; ?>
			<div class="clr"></div>
		</div>
		<?php endif; ?>
		<?php endif; ?>

		<?php if(
			$this->item->params->get('commentsFormPosition')=='below' &&
			$this->item->params->get('itemComments') &&
			!JFactory::getApplication()->input->getInt('print') &&
			($this->item->params->get('comments') == '1' || ($this->item->params->get('comments') == '2' && K2HelperPermissions::canAddComment($this->item->catid)))
		): ?>
		<!-- Item comments form -->
		<div class="itemCommentsForm">
			<?php echo $this->loadTemplate('comments_form'); ?>
		</div>
		<?php endif; ?>

		<?php $user = JFactory::getUser(); if($this->item->params->get('comments') == '2' && $user->guest): ?>
		<div class="itemCommentsLoginFirst"><?php echo JText::_('K2_LOGIN_TO_POST_COMMENTS'); ?></div>
		<?php endif; ?>

	</div>
	<?php endif; ?>

	<?php if(!JFactory::getApplication()->input->getCmd('print')): ?>
	<div class="itemBackToTop">
		<a class="k2Anchor" href="<?php echo $this->item->link; ?>#startOfPageId<?php echo JFactory::getApplication()->input->getInt('id'); ?>">
			<i class="icon-arrow-up"></i>
		</a>
	</div>
	<?php endif; ?>

	<div class="clr"></div>

</div>
<!-- End K2 Item Layout -->
