<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

// no direct access
defined('_JEXEC') or die;

?>

<!-- Start K2 Latest Layout -->
<div id="k2Container" class="latestView<?php if($this->params->get('pageclass_sfx')) echo ' '.$this->params->get('pageclass_sfx'); ?>">

	<?php if($this->params->get('show_page_title')): ?>
	<!-- Page title -->
	<div class="componentheading<?php echo $this->params->get('pageclass_sfx')?>">
		<?php echo $this->escape($this->params->get('page_title')); ?>
	</div>
	<?php endif; ?>

	<?php foreach($this->blocks as $key=>$block):
		if((($key+1)%($this->params->get('latestItemsCols'))==0) || count($this->blocks)<$this->params->get('latestItemsCols'))
			$lastContainer= ' last';
		else
			$lastContainer='';
	?>
	<div class="latestItemsContainer<?php echo (($this->params->get('latestItemsCols') > 1) ? ' cols'.$this->params->get('latestItemsCols') : ''); ?><?php echo $lastContainer; ?>">

		<?php if($this->source=='categories'): $category=$block; ?>

		<?php if($this->params->get('categoryFeed') || $this->params->get('categoryImage') || $this->params->get('categoryTitle') || $this->params->get('categoryDescription')): ?>
		
		<?php if($this->params->get('categoryFeed')): ?>
		<!-- RSS feed icon -->
		<div class="k2FeedIcon">
			<a href="<?php echo $category->feed; ?>" title="<?php echo JText::_('K2_SUBSCRIBE_TO_THIS_RSS_FEED'); ?>">
				<span><?php echo JText::_('K2_SUBSCRIBE_TO_THIS_RSS_FEED'); ?></span>
			</a>
			<div class="clr"></div>
		</div>
		<?php endif; ?>
		
		<!-- Start K2 Category block -->
		<div class="latestItemsCategory">
			<?php if ($this->params->get('categoryImage') && !empty($category->image)): ?>
			<div class="latestItemsCategoryImage">
				<img src="<?php echo $category->image; ?>" alt="<?php echo K2HelperUtilities::cleanHtml($category->name); ?>" style="width:<?php echo $this->params->get('catImageWidth'); ?>px;height:auto;" />
			</div>
			<?php endif; ?>
			
			<div class="latestItemsCategoryDetails">
				<?php if ($this->params->get('categoryTitle')): ?>
				<h3><a href="<?php echo $category->link; ?>"><?php echo $category->name; ?></a></h3>
				<?php endif; ?>

				<?php
				if ($this->params->get('categoryDescription') && isset($category->description)):
					echo $category->description;
				endif;
				?>

				<div class="clr"></div>

				<!-- K2 Plugins: K2CategoryDisplay -->
				<?php echo $category->event->K2CategoryDisplay; ?>
			</div>
			<div class="clr"></div>
		</div>
		<!-- End K2 Category block -->
		<?php endif; ?>

		<?php else: $user=$block; ?>

		<?php if ($this->params->get('userFeed') || $this->params->get('userImage') || $this->params->get('userName') || $this->params->get('userDescription') || $this->params->get('userURL') || $this->params->get('userEmail')): ?>
		<!-- Start K2 User block -->
		<div class="latestItemsUser">

			<?php if($this->params->get('userFeed')): ?>
			<!-- RSS feed icon -->
			<div class="k2FeedIcon">
				<a href="<?php echo $user->feed; ?>" title="<?php echo JText::_('K2_SUBSCRIBE_TO_THIS_RSS_FEED'); ?>">
					<span><?php echo JText::_('K2_SUBSCRIBE_TO_THIS_RSS_FEED'); ?></span>
				</a>
				<div class="clr"></div>
			</div>
			<?php endif; ?>

			<?php if ($this->params->get('userImage') && !empty($user->avatar)): ?>
			<img class="latestItemsUserAvatar" src="<?php echo $user->avatar; ?>" alt="<?php echo $user->name; ?>" style="width:<?php echo $this->params->get('userImageWidth'); ?>px;height:auto;" />
			<?php endif; ?>

            <div class="latestItemsUserDetails">
                <?php if ($this->params->get('userName')): ?>
                <h4 class="latestItemsUserName">
                    <a rel="author" href="<?php echo $user->link; ?>"><?php echo $user->name; ?></a>
                </h4>
                <?php endif; ?>

                <?php if ($this->params->get('userDescription') && isset($user->profile->description)): ?>
                <div class="latestItemsUserDescription"><?php echo $user->profile->description; ?></div>
                <?php endif; ?>

                <?php if ($this->params->get('userURL') || $this->params->get('userEmail')): ?>
                <div class="latestItemsUserAdditionalInfo">
                    <?php if ($this->params->get('userURL') && isset($user->profile->url)): ?>
                    <span class="latestItemsUserURL">
                        <i class="icon-globe"></i>
                        <a rel="me" href="<?php echo $user->profile->url; ?>" target="_blank" title="<?php echo JText::_('K2_WEBSITE_URL'); ?>"><?php echo $user->profile->url; ?></a>
                    </span>
                    <?php endif; ?>

                    <?php if ($this->params->get('userEmail')): ?>
                    <span class="latestItemsUserEmail">
                        <i class="icon-envelope"></i>
                        <?php echo JHTML::_('Email.cloak', $user->email); ?>
                    </span>
                    <?php endif; ?>
                </div>
                <?php endif; ?>
            </div>
			<div class="clr"></div>

			<?php echo $user->event->K2UserDisplay; ?>

			<div class="clr"></div>
		</div>
		<!-- End K2 User block -->
		<?php endif; ?>

		<?php endif; ?>

		<!-- Start Items list -->
		<div class="latestItemList">
			<?php if($this->params->get('latestItemsDisplayEffect')=="first"): ?>

			<?php foreach ($block->items as $itemCounter=>$item): K2HelperUtilities::setDefaultImage($item, 'latest', $this->params); ?>
			<?php if($itemCounter==0): ?>
			<?php $this->item=$item; echo $this->loadTemplate('item'); ?>
			<?php else: ?>
			<h3 class="latestItemTitleList">
				<?php if ($item->params->get('latestItemTitleLinked')): ?>
				<a href="<?php echo $item->link; ?>"><?php echo $item->title; ?></a>
				<?php else: ?>
				<?php echo $item->title; ?>
				<?php endif; ?>
			</h3>
			<?php endif; ?>
			<?php endforeach; ?>

			<?php else: ?>

			<?php foreach ($block->items as $item): K2HelperUtilities::setDefaultImage($item, 'latest', $this->params); ?>
			<?php $this->item=$item; echo $this->loadTemplate('item'); ?>
			<?php endforeach; ?>

			<?php endif; ?>
		</div>
		<!-- End Item list -->

	</div>

	<?php if(($key+1)%($this->params->get('latestItemsCols'))==0): ?>
	<div class="clr"></div>
	<?php endif; ?>

	<?php endforeach; ?>
	<div class="clr"></div>
</div>

<!-- End K2 Latest Layout -->
