<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

// no direct access
defined('_JEXEC') or die;
?>

<div id="k2ModuleBox<?php echo $module->id; ?>" class="k2ItemsBlock<?php if($params->get('moduleclass_sfx')) echo ' '.$params->get('moduleclass_sfx'); ?>">

	<?php if($params->get('itemPreText')): ?>
	<p class="modulePretext"><?php echo $params->get('itemPreText'); ?></p>
	<?php endif; ?>

	<?php if(count($items)): ?>
	<ul>
		<?php foreach ($items as $key=>$item): ?>
		<li class="<?php echo ($key%2) ? "odd" : "even"; if(count($items)==$key+1) echo ' lastItem'; ?>">

			<!-- Plugins: BeforeDisplay -->
			<?php echo $item->event->BeforeDisplay; ?>

			<!-- K2 Plugins: K2BeforeDisplay -->
			<?php echo $item->event->K2BeforeDisplay; ?>

			<?php
			if(
			$params->get('itemAuthorAvatar') ||
			$params->get('itemAuthor')
			): ?>
			<div class="moduleItemAuthorInfo">
				<?php if($params->get('itemAuthorAvatar')): ?>
				<a class="k2Avatar moduleItemAuthorAvatar" rel="author" href="<?php echo $item->authorLink; ?>">
					<img src="<?php echo $item->authorAvatar; ?>" alt="<?php echo K2HelperUtilities::cleanHtml($item->author); ?>" style="width:<?php echo $avatarWidth; ?>px;height:auto;" />
				</a>
				<?php endif; ?>
				
				<?php if($params->get('itemAuthor')): ?>
				<div class="moduleItemAuthor">
					<?php if(isset($item->authorLink)): ?>
					<h4>
						<a rel="author" title="<?php echo K2HelperUtilities::cleanHtml($item->author); ?>" href="<?php echo $item->authorLink; ?>"><?php echo $item->author; ?></a>
					</h4>
					<?php else: ?>
					<h4><?php echo $item->author; ?></h4>
					<?php endif; ?>

					<?php if($params->get('userDescription')): ?>
					<?php echo $item->authorDescription; ?>
					<?php endif; ?>
				</div>
				<?php endif; ?>
			</div>
			<?php endif; ?>

			<div class="moduleItemContainer">
				<?php if($params->get('itemImage') && isset($item->image)): ?>
				<div class="moduleItemImageBlock">
					<span class="moduleItemImage">
						<a href="<?php echo $item->link; ?>" title="<?php echo JText::_('K2_CONTINUE_READING'); ?> &quot;<?php echo K2HelperUtilities::cleanHtml($item->title); ?>&quot;">
							<img src="<?php echo $item->image; ?>" alt="<?php echo K2HelperUtilities::cleanHtml($item->title); ?>" />
						</a>
					</span>
				</div>
				<?php endif; ?>
				
				<div class="moduleItemContent">
					<?php if($params->get('itemTitle')): ?>
					<h3 class="moduleItemTitle">
						<a href="<?php echo $item->link; ?>"><?php echo $item->title; ?></a>
					</h3>
					<?php endif; ?>
					
					<!-- Plugins: AfterDisplayTitle -->
					<?php echo $item->event->AfterDisplayTitle; ?>

					<!-- K2 Plugins: K2AfterDisplayTitle -->
					<?php echo $item->event->K2AfterDisplayTitle; ?>

					<!-- Plugins: BeforeDisplayContent -->
					<?php echo $item->event->BeforeDisplayContent; ?>

					<!-- K2 Plugins: K2BeforeDisplayContent -->
					<?php echo $item->event->K2BeforeDisplayContent; ?>

					<?php if($params->get('itemIntroText')): ?>
					<div class="moduleItemIntroText">
						<?php echo $item->introtext; ?>
					</div>
					<?php endif; ?>

					<?php if($params->get('itemExtraFields') && count($item->extra_fields)): ?>
					<div class="moduleItemExtraFields">
						<b><?php echo JText::_('K2_ADDITIONAL_INFO'); ?></b>
						<ul>
							<?php foreach ($item->extra_fields as $extraField): ?>
							<?php if($extraField->value != ''): ?>
							<li class="type<?php echo ucfirst($extraField->type); ?> group<?php echo $extraField->group; ?>">
								<?php if($extraField->type == 'header'): ?>
								<h4 class="moduleItemExtraFieldsHeader"><?php echo $extraField->name; ?></h4>
								<?php else: ?>
								<span class="moduleItemExtraFieldsLabel"><?php echo $extraField->name; ?></span>
								<span class="moduleItemExtraFieldsValue"><?php echo $extraField->value; ?></span>
								<?php endif; ?>
								<div class="clr"></div>
							</li>
							<?php endif; ?>
							<?php endforeach; ?>
						</ul>
					</div>
					<?php endif; ?>

					<div class="clr"></div>

					<?php if($params->get('itemVideo') && !empty($item->video)): ?>
					<div class="moduleItemVideo">
						<?php echo $item->video; ?>
						<span class="moduleItemVideoCaption"><?php echo $item->video_caption; ?></span>
						<span class="moduleItemVideoCredits"><?php echo $item->video_credits; ?></span>
					</div>
					<?php endif; ?>

					<div class="clr"></div>

					<!-- Plugins: AfterDisplayContent -->
					<?php echo $item->event->AfterDisplayContent; ?>

					<!-- K2 Plugins: K2AfterDisplayContent -->
					<?php echo $item->event->K2AfterDisplayContent; ?>

					<?php if($params->get('itemReadMore') && $item->fulltext): ?>
					<div class="moduleItemReadMore">
						<a class="btn btn-secondary" href="<?php echo $item->link; ?>">
							<?php echo JText::_('K2_READ_MORE'); ?>
						</a>
					</div>
					<?php endif; ?>
					
					<?php if($params->get('itemTags') && count($item->tags)>0): ?>
					<div class="moduleItemTagsBlock">
						<ul class="moduleItemTags">
							<?php foreach ($item->tags as $tag): ?>
							<li>
								<a href="<?php echo $tag->link; ?>"><?php echo $tag->name; ?></a>
							</li>
							<?php endforeach; ?>
						</ul>
					</div>
					<?php endif; ?>
				</div>
				
				<?php
				if(
				$params->get('itemDateCreated') ||
				$params->get('itemCategory') ||
				($params->get('itemCommentsCounter') && $componentParams->get('comments')) ||
				$params->get('itemHits') ||
				($params->get('itemAttachments') && count($item->attachments))
				):
				?>
				<div class="moduleItemInfo">
					<?php if($params->get('itemDateCreated')): ?>
					<span class="moduleItemDateCreated">
					<i class="icon-calendar"></i>
					<?php echo JHTML::_('date', $item->created, JText::_('K2_DATE_FORMAT_LC2')); ?>
					</span>
					<?php endif; ?>

					<?php if($params->get('itemCategory')): ?>
					<span class="moduleItemCategory">
						<i class="icon-th-list"></i>
						<a href="<?php echo $item->categoryLink; ?>"><?php echo $item->categoryname; ?></a>
					</span>
					<?php endif; ?>
					
					<?php if($params->get('itemCommentsCounter') && $componentParams->get('comments')): ?>
						<?php if(!empty($item->event->K2CommentsCounter)): ?>
							<!-- K2 Plugins: K2CommentsCounter -->
							<?php echo $item->event->K2CommentsCounter; ?>
						<?php else: ?>
							<span class="moduleItemComments">
								<?php if($item->numOfComments>0): ?>
								<i class="icon-comments"></i>
								<a href="<?php echo $item->link.'#itemCommentsAnchor'; ?>" title="<?php if($item->numOfComments>1) echo ucfirst(JText::_('K2_COMMENTS')); else echo ucfirst(JText::_('K2_COMMENT')); ?>">
									<?php echo $item->numOfComments; ?>
								</a>
								<?php else: ?>
								<a href="<?php echo $item->link.'#itemCommentsAnchor'; ?>">
									<?php echo JText::_('K2_BE_THE_FIRST_TO_COMMENT'); ?>
								</a>
								<?php endif; ?>
							</span>
						<?php endif; ?>
					<?php endif; ?>
					
					<?php if($params->get('itemHits')): ?>
					<span class="moduleItemHits">
						<i class="icon-eye"></i>
						<?php echo $item->hits; ?>
					</span>
					<?php endif; ?>
					
					<?php if($params->get('itemAttachments') && count($item->attachments)): ?>
					<div class="moduleAttachments">
						<i class="icon-download"></i>
						<?php foreach ($item->attachments as $attachment): ?>
						<a title="<?php echo K2HelperUtilities::cleanHtml($attachment->titleAttribute); ?>" href="<?php echo $attachment->link; ?>"><?php echo $attachment->title; ?></a>
						<?php endforeach; ?>
					</div>
					<?php endif; ?>
				</div>
				<?php endif; ?>
			</div>
			
			<!-- Plugins: AfterDisplay -->
			<?php echo $item->event->AfterDisplay; ?>

			<!-- K2 Plugins: K2AfterDisplay -->
			<?php echo $item->event->K2AfterDisplay; ?>
			
			<div class="clr"></div>
		</li>
		<?php endforeach; ?>
	</ul>
	<?php endif; ?>

	<?php if($params->get('itemCustomLink')): ?>
	<a class="moduleCustomLink" href="<?php echo $itemCustomLinkURL; ?>" title="<?php echo K2HelperUtilities::cleanHtml($itemCustomLinkTitle); ?>"><?php echo $itemCustomLinkTitle; ?></a>
	<?php endif; ?>

	<?php if($params->get('feed')): ?>
	<div class="k2FeedIcon">
		<a href="<?php echo JRoute::_('index.php?option=com_k2&view=itemlist&format=feed&moduleID='.$module->id); ?>" title="<?php echo JText::_('K2_SUBSCRIBE_TO_THIS_RSS_FEED'); ?>">
			<span><?php echo JText::_('K2_SUBSCRIBE_TO_THIS_RSS_FEED'); ?></span>
		</a>
		<div class="clr"></div>
	</div>
	<?php endif; ?>

</div>
