<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die;

$is_main_menu       = strpos($module->position, 'main-menu') !== false;
$class_sfx          = htmlspecialchars($params->get('moduleclass_sfx'));
$template_params    = JFactory::getApplication()->getTemplate(true)->params;
?>

<ul class="rstpl-template-menu <?php if ($is_main_menu)
{
	echo 'nav ';
} ?>menu<?php echo $class_sfx; ?>"<?php
$tag = '';
if ($params->get('tag_id') != null)
{
	$tag = $params->get('tag_id') . '';
	echo ' id="' . $tag . '"';
}
?>>
	<?php
	$end = (int) $params->get('endLevel');

	foreach ($list as $i => &$item) {

        $class = 'item-' . $item->id;
        if ($item->id == $active_id) {
            $class .= ' current';
        }

        if (in_array($item->id, $path)) {
            $class .= ' active';
        } elseif ($item->type == 'alias') {
            $aliasToId = $item->params->get('aliasoptions');
            if (count($path) > 0 && $aliasToId == $path[count($path) - 1]) {
                $class .= ' active';
            } elseif (in_array($aliasToId, $path)) {
                $class .= ' alias-parent-active';
            }
        }

        if ($is_main_menu && $item->type == 'separator') {
            $class .= ' divider';
        }

        if ($item->deeper) {
            $class .= ' deeper';
        }

        if ($item->parent) {
            if ($is_main_menu) {
                if ($item->level > 1 && (!$end || $end > $item->level)) {
                    $class .= ' dropdown-submenu parent';
                } else {
                    $class .= ' dropdown parent';
                }
            } else {
                $class .= ' parent';
            }
        }

        if ($item->params->get('mega_menu') && $item->level = 1) {
            $class .= ' rstpl-mega-menu';
        }

        if (!empty($class)) {
            $class = ' class="' . trim($class) . '"';
        }

        $attr = '';

        if ($item->params->get('menu_item_icon') != null) {
            $attr = 'data-icon = icon' . substr($item->params->get('menu_item_icon'), 5);
        }

        echo '<li' . $class . ' ' . $attr . '>';

        // Render the menu item.
        switch ($item->type) {
            case 'separator':
            case 'url':
            case 'component':
            case 'heading':
                require JModuleHelper::getLayoutPath('mod_menu', 'default_' . $item->type);
                break;

            default:
                require JModuleHelper::getLayoutPath('mod_menu', 'default_url');
                break;
        }

        // The next item is deeper.
        if ($item->params->get('mega_menu')) {
            $mega_menu = new RSMegaMenu($item);
        };

        if ($item->deeper && !($item->params->get('mega_menu'))) {
            if ($is_main_menu) {
                echo '<ul class="dropdown-menu unstyled small">';
            } else {
                echo '<ul class="nav-inner">';
            }
        } elseif ($item->params->get('mega_menu') && count($item->tree) == 1) {
            echo $mega_menu->buildMegaMenu();
            echo '</li>';
        } // The next item is shallower.
        elseif ($item->shallower) {
            echo '</li>';
            echo str_repeat('</ul></li>', $item->level_diff);
        } // The next item is on the same level.
        else {
            echo '</li>';
        }

    }

	if ($template_params->get('login_in_menu') && $module->position == 'main-menu')
	{
		echo RSTemplate::createLogin();
	}

	if ($template_params->get('search_in_menu') && $module->position == 'main-menu')
	{
		echo RSTemplate::createSearch($template_params->get('search_in_menu'));
	}
	?>

</ul>
