<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die;

// Check if there is any message in the que and if so, render it
if (count($app->getMessageQueue()))
{ ?>
	<section class="rstpl-component-message rstpl-m-top">
		<div class="container">
			<div class="row">
				<div class="span12">
					<jdoc:include type="message" />
				</div>
			</div>
		</div>
	</section>
<?php } ?>

<?php if (!$template->isHomeHidden())
{ ?>
	<!-- Start All Content Position -->
	<?php // Configuration array
	$attr = array(
		'class' => 'rstpl-all-content-position'.$settings->rowclass,
		'style' => $settings->css,
		'id'    => 'rstpl-all-content-position',
	);

	?>
	<section <?php echo RSTemplateHelper::add_attributes($attr) ?>>
			<?php if ((!$settings->isfullwidth) && (JFactory::getApplication()->input->get('option') != 'com_rspagebuilder')): ?>
			<div class="container">
			<?php endif; ?>

				<?php
				/**
				 * We need to check if there is any widget/column
				 * associated with this page to change the content area
				 */
				$sidebars		= 0;
				$unused_size	= 0;

				foreach ($settings->columns as $column)
				{
					if (($this->countModules($column->name) || (bool) $column->widget) && !$column->isremoved)
					{
						if ($column->name != 'content') {
							$sidebars++;
						}
					} else if (!$column->isremoved && ($column->name != 'content')) {
						preg_match('/[0-9]+/', $column->size, $matches);
						$unused_size += (int)$matches[0];
					}
				}
				?>
				<div class="row-fluid">
					<?php foreach ($settings->columns as $column)
					{
						// Column configuration array
						$attr = array(
							'class'   => $column->size,
							'data-sr' => $column->animation
						);

						if (($this->countModules($column->name) || (bool) $column->widget) && !$column->isremoved)
						{ ?>
							<div <?php echo RSTemplateHelper::add_attributes($attr) ?>>
								<aside id="<?php echo $column->name ?>">
									<?php
									foreach ($column->widget as $widget)
									{
										$template->widgets[strtolower($widget)]->render();
									} ?>
									<jdoc:include type="modules" name="<?php echo $column->name ?>" style="rsmodule" />
								</aside>
							</div>
						<?php }
						if ($column->name == 'content')
						{
							$attr = array(
								'class' => $column->size
							);
							
							if (!$sidebars) {
								$attr['class'] = 'span12';
							} else if ($unused_size) {
								preg_match('/[0-9]+/', $column->size, $matches);
								$attr['class']	= 'span' . ((int)$matches[0] + $unused_size);
							}
						?>
							<div <?php echo RSTemplateHelper::add_attributes($attr) ?>>
								<?php if ($this->countModules('inner-before-content'))
								{
									// Column configuration array
									$attr = array(
										'data-sr' => $column->animation,
									);
									?>
									<!-- Start Inner Before Content -->
									<div class="row-fluid rstpl-inner-before-content-position">
										<div class="span12" <?php echo RSTemplateHelper::add_attributes($attr) ?>>
											<jdoc:include type="modules" name="inner-before-content" style="rscontent" />
										</div>
									</div>
									<!-- End Inner-Before-Content -->
								<?php }; ?>
								<!-- Start Content -->
								<div id="rstpl-<?php echo $template->getOption(); ?>" class="rstpl-content">
									<jdoc:include type="component" />
								</div>
								<!-- End Content -->
								<?php if ($this->countModules('inner-after-content'))
								{
									// Column configuration array
									$attr = array(
										'data-sr' => $column->animation,
									);
									?>
									<!-- Start Inner Before Content -->
									<div class="row-fluid rstpl-inner-after-content-position">
										<div class="span12" <?php echo RSTemplateHelper::add_attributes($attr) ?>>
											<jdoc:include type="modules" name="inner-after-content" style="rscontent" />
										</div>
									</div>
									<!-- End Inner-Before-Content -->
								<?php }; ?>
							</div>
						<?php }; ?>
					<?php }; ?>
				</div>

			<?php if ((!$settings->isfullwidth) && (JFactory::getApplication()->input->get('option') != 'com_rspagebuilder')): ?>
			</div>
			<?php endif; ?>
	</section>
	<!-- End All Content Position-->
<?php }; ?>
