<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die;

if ($this->countModules('main-menu'))
{

	$modules		= JModuleHelper::getModules('main-menu');
	$menu_params    = new JRegistry($modules[0]->params);
	$logo_position	= $this->params->get('logo_position');
	$logo_class		= ($logo_position == 'pull-right') ? ' logo-right' : ' logo-left';
	$wrapper		= 'container';

// load a helping script to check we don't have submenus outside the viewport
	$template->addJS('offscreen.min.js');
	if ($settings->isfullwidth)
	{
		$wrapper = 'full-width-menu';
	};

// Configuration arrays
// Container Atrtributes
	$fullwidth = array(
		'class' => $wrapper,
	);

// Row Attributes
	$attr = array(
		'class'        => 'rstpl-main-menu-position'.$logo_class.$settings->rowclass,
		'style'        => $settings->css,
		'id'           => 'rstpl-main-menu-position',
		'data-onepage' => 'false'
	);

// Menu Attributes
	$menu_attr = array(
		'class' => 'rstpl-navigation',
	);

	if ($this->params->get('one_page'))
	{
		$attr['data-onepage'] = 'true';
	}

	if ($this->params->get('absolute_menu'))
	{
		$attr['class'] .= ' rstpl-absolute-menu';
	}
	?>
	<!-- Start Main Menu -->
	<section <?php echo RSTemplateHelper::add_attributes($attr) ?>>
		<div <?php echo RSTemplateHelper::add_attributes($fullwidth) ?>>
			<div class="row-fluid">
				<div class="span12">
					<nav <?php echo RSTemplateHelper::add_attributes($menu_attr) ?>>
						<div class="navbar">
							<div class="navbar-inner">
								<?php if ($logo_position)
								{
									$template->widgets['logo']->render();
								} ?>
								<a class="btn btn-navbar collapsed" data-toggle="collapse" data-target=".rstpl-main-menu-position .nav-collapse" rel="nofollow">
									<span class="icon-bar first-bar"></span>
									<span class="icon-bar second-bar"></span>
									<span class="icon-bar third-bar"></span>
								</a>

								<div class="nav-collapse collapse navbar-responsive-collapse <?php echo $this->params->get('menu_position') ?>">
									<jdoc:include type="modules" name="main-menu" />
								</div>
							</div>
						</div>
					</nav>
				</div>
			</div>
		</div>
	</section>
	<!-- End Main Menu -->
<?php } ?>
