<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die;

/**
 * General options
 */
$position       = $this->params->get('social_position');
$alignment      = $this->params->get('social_alignment', 'center');
$text           = $this->params->get('social_text');
$text_alignment = $this->params->get('social_text_alignment');
$text_heading   = $this->params->get('social_text_heading');
$target         = $this->params->get('social_blank_window');

/**
 * Build array that holds the actual links
 */
$newSocials = array(
	'facebook'  => $this->params->get('social_facebook'),
	'twitter'   => $this->params->get('social_twitter'),
	'linkedin'  => $this->params->get('social_linkedin'),
	'google'    => $this->params->get('social_google'),
	'youtube'   => $this->params->get('social_youtube'),
	'vimeo'     => $this->params->get('social_vimeo'),
	'flickr'    => $this->params->get('social_flickr'),
	'pinterest' => $this->params->get('social_pinterest'),
	'skype'     => $this->params->get('social_skype'),
	'yahoo'     => $this->params->get('social_yahoo'),
	'instagram' => $this->params->get('social_instagram')
);

/**
 * Filter the array, if key does not have value - it's removed
 */
$newSocials = array_filter($newSocials);

/**
 * In case there is no link assigned for socials, we return false
 */
if (!count($newSocials))
{
	return false;
}

/**
 * Load the layout that we need
 */
if ($position == 'float-left' || $position == 'float-right')
{
	include $this->getLayout('floated');
}
else
{
	include $this->getLayout('default');
}
