<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die;

/**
 * Creates a twitter widget
 */
class RSTwitterWidget
{

	/**
	 * Authenticate and return the time line
	 * @method auth
	 *
	 * @param  array  $options
	 * @param  array  $oauth
	 * @param  string $user
	 * @param  int    $count
	 *
	 * @return object
	 */
	public static function auth($options, $oauth, $user, $count)
	{
		try
		{
			$options = new JRegistry($options);
			$auth    = new JTwitterOAuth($options);
			$auth->setToken($oauth);
			$auth->authenticate();
			$twitter  = new JTwitter($auth);
			$statuses = $twitter->statuses;

			return array(
				'success'  => true,
				'response' => $statuses->getUserTimeline($user, $count),
			);

		} // Catch the exception
		catch (Exception $e)
		{
			return array(
				'success'  => false,
				'response' => $e,
			);
		}

	}

}
