<?php
/**
 * @version       1.0.0
 * @package       RSTrone! 1.0.0
 * @copyright (C) 2018 www.rsjoomla.com
 * @license       GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

defined('_JEXEC') or die;
$doc = JFactory::getDocument();

require_once '/classes/class-twitter.php';

$options = array(
	'consumer_key'    => trim($this->params->get('twitter_consumer_key')),
	'consumer_secret' => trim($this->params->get('twitter_consumer_secret')),
	'callback'        => JUri::current(),
	'sendheaders'     => true
);

$oauth = array(
	'key'    => trim($this->params->get('twitter_access_token')),
	'secret' => trim($this->params->get('twitter_access_token_secret')),
);

$user   = trim($this->params->get('twitter_user'));
$count  = (int) ($this->params->get('twitter_count'));
$layout = $this->params->get('twitter_layout');
$cache  = JFactory::getCache('lib_rstemplate');
$cache->setCaching(true);
$tweets = $cache->call(array('RSTwitterWidget', 'auth'), $options, $oauth, $user, $count);

if ($tweets['success'])
{
	$tweets = $tweets['response'];
	if (count($tweets))
	{
		include $this->getLayout('default' . $layout);
	}
	else
	{
		echo '<div class="alert alert-info">' . JText::_("LIB_RSTEMPLATE_NO_TWEETS") . '</div>';
	}
}
else
{
	echo '<div class="alert alert-error">' . $tweets['response']->getMessage() . '</div>';
}
